/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "App.g.h"
#include "Common\SplitViewRadioButton.h"

namespace CompletePDFViewer
{
	ref class App sealed
	{
	protected:
		virtual void OnLaunched(Windows::ApplicationModel::Activation::LaunchActivatedEventArgs^ e) override;
		virtual void OnFileActivated(Windows::ApplicationModel::Activation::FileActivatedEventArgs^ args) override;
		virtual void OnActivated(Windows::ApplicationModel::Activation::IActivatedEventArgs^ args) override;

	internal:
		App();

	private:
		void InitializeBackgroundTask();
		void InitializeAppResource();
		Windows::UI::Xaml::Controls::Frame^ CreateRootFrame();
		void InitializeApp(Windows::ApplicationModel::Activation::IActivatedEventArgs^ args);
		void InitializeWindowContent(Windows::UI::Xaml::Controls::Frame^ rootFrame, Windows::ApplicationModel::Activation::IActivatedEventArgs^ args);

	private:
		void OnSuspending(Platform::Object^ sender, Windows::ApplicationModel::SuspendingEventArgs^ e);
		void OnNavigationFailed(Platform::Object ^sender, Windows::UI::Xaml::Navigation::NavigationFailedEventArgs ^e);
		void OnResuming(Platform::Object ^sender, Platform::Object ^args);
		void OnUnhandledException(Platform::Object ^sender, Windows::UI::Xaml::UnhandledExceptionEventArgs ^e);
	};
}
