﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#include "pch.h"
#include "SplitViewRadioButton.h"

using namespace CompletePDFViewer;

using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Documents;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Interop;
using namespace Windows::UI::Xaml::Media;

SplitViewRadioButton::SplitViewRadioButton()
{
	DefaultStyleKey = "CompletePDFViewer.SplitViewRadioButton";
}

static DependencyProperty^ _LabelProperty = DependencyProperty::Register("Label", TypeName(Platform::String::typeid), TypeName(SplitViewRadioButton::typeid),
	ref new PropertyMetadata(nullptr, ref new PropertyChangedCallback(SplitViewRadioButton::OnLabelChanged)));

static DependencyProperty^ _RedIconVisibleProperty = DependencyProperty::Register("RedIconVisible", TypeName(bool::typeid), TypeName(SplitViewRadioButton::typeid),
	ref new PropertyMetadata(nullptr, ref new PropertyChangedCallback(SplitViewRadioButton::OnRedIconVisibleChanged)));

Windows::UI::Xaml::DependencyProperty^ SplitViewRadioButton::LabelProperty::get()
{
	return _LabelProperty;
}

Platform::String^ SplitViewRadioButton::Label::get()
{
	return (Platform::String^)GetValue(LabelProperty);
}

void SplitViewRadioButton::Label::set(Platform::String^ value)
{
	SetValue(LabelProperty, value);
}

Windows::UI::Xaml::DependencyProperty^ SplitViewRadioButton::RedIconVisibleProperty::get()
{
	return _RedIconVisibleProperty;
}

bool SplitViewRadioButton::RedIconVisible::get()
{
	return (bool)GetValue(RedIconVisibleProperty);
}

void SplitViewRadioButton::RedIconVisible::set(bool value)
{
	SetValue(RedIconVisibleProperty, value);
}


void SplitViewRadioButton::OnLabelChanged(Windows::UI::Xaml::DependencyObject^ obj, Windows::UI::Xaml::DependencyPropertyChangedEventArgs^ args)
{

}

void SplitViewRadioButton::OnRedIconVisibleChanged(Windows::UI::Xaml::DependencyObject^ obj, Windows::UI::Xaml::DependencyPropertyChangedEventArgs^ args)
{

}
