/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#include "pch.h"
#include "GeneralSetting.h"

using namespace CompletePDFViewer;

using namespace Platform;


#define DOCUMENT_MAX_SCALE 5.0
#define DOCUMENT_SCALE_FORVIEW 1.0

namespace CompletePDFViewer
{
	ref class DefaultGeneralSetting : IGeneralSetting
	{
	public:
		property double DocumentMaxScale
		{
			virtual double get()
			{
				return DOCUMENT_MAX_SCALE;
			}
		}
		
		property double ScaleForView
		{
			virtual double get()
			{
				return DOCUMENT_SCALE_FORVIEW;
			}
		}

		property double MRUThumbnailWidth
		{
			virtual double get()
			{
				return _MRUThumbnailWidth;
			}
			virtual void set(double value)
			{
				_MRUThumbnailWidth = value;
			}
		}

		property double MRUThumbnailHeight
		{
			virtual double get()
			{
				return _MRUThumbnailHeight;
			}
			virtual void set(double value)
			{
				_MRUThumbnailHeight = value;
			}
		}

	internal:
		DefaultGeneralSetting()
		{
			_MRUThumbnailWidth = 110;
			_MRUThumbnailHeight = 140;
		}

	private:
		double _MRUThumbnailHeight;
		double _MRUThumbnailWidth;
	};
}

static IGeneralSetting^ _Setting;

IGeneralSetting^ GeneralSetting::Current::get()
{
	if (!_Setting)
	{
		_Setting = ref new DefaultGeneralSetting();
	}
	return _Setting;
}

void GeneralSetting::SetGeneralSetting(IGeneralSetting^ value)
{
	if (_Setting != value)
	{
		_Setting = value;
	}
}
