/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

namespace CompletePDFViewer
{
	public ref class ThumbnailFileSaveCompletionEventArgs sealed
	{
	public:
		property Platform::String^ Token
		{
			Platform::String^ get();
		}

	internal:
		ThumbnailFileSaveCompletionEventArgs(Platform::String^ token);

	private:
		Platform::String^ _Token;
	};

	public delegate void ThumbnailFileSaveCompletionEventHandler(Platform::Object^ sender, ThumbnailFileSaveCompletionEventArgs^ args);
	[Windows::Foundation::Metadata::WebHostHidden]
	public ref class MRUManager sealed
	{
	public:
		static bool IsStorageFileInMRUList(Windows::Storage::StorageFile^ file);
		static Platform::String^ GetStorageFileMRUToken(Windows::Storage::StorageFile^ file);
		[Windows::Foundation::Metadata::DefaultOverload]
		static bool IsStorageFileInMRUList(Platform::String^ filepath);
		[Windows::Foundation::Metadata::DefaultOverload]
		static Platform::String^ GetStorageFileMRUToken(Platform::String^ filepath);
		static bool IsMatchTokenWithFilePath(Platform::String^ token, Platform::String^ filepath);

		static Platform::String^ AddStorageFileToMRUList(Windows::Storage::StorageFile^ file);
		[Windows::Foundation::Metadata::DefaultOverload]
		static void DeleteFromMRUListByStorageFile(Windows::Storage::StorageFile^ file);
		static void DeleteFromMRUListByFilePath(Platform::String^ filepath);
		static void DeleteFromMRUListByToken(Platform::String^ token);

		static Windows::Foundation::IAsyncOperation<Windows::UI::Xaml::Media::Imaging::WriteableBitmap^>^ LoadWriteableBitmapFromMRUThumbnailFileAsync(Platform::String^ token);

		static property MRUManager^ Current
		{
			MRUManager^ get();
		}

		event ThumbnailFileSaveCompletionEventHandler^ ThumbnailFileSaveCompletion;

	internal:
		MRUManager();
		static concurrency::task<Windows::UI::Xaml::Media::Imaging::WriteableBitmap^> LoadWriteableBitmapFromMRUThumbnailFile(Platform::String^ token);
		static concurrency::task<void> LoadStreamFromWriteableBitmap(Windows::Storage::Streams::IRandomAccessStream^ stream, Windows::UI::Xaml::Media::Imaging::WriteableBitmap^ bitmap);
		static concurrency::task<void> SaveMRUItemThumbnailToFileByToken(Platform::String^ token, Windows::UI::Xaml::Media::Imaging::WriteableBitmap^ bitmap);
		static concurrency::task<void> SaveMRUItemThumbnailToFileByStorageFile(Windows::Storage::StorageFile^ file, Windows::UI::Xaml::Media::Imaging::WriteableBitmap^ bitmap);		
		static concurrency::task<void> DeleteMRUThumbnailFile(Platform::String^ token);
		static concurrency::task<void> ConvertToImageFile(Platform::String^ FileName, Platform::String^ ImageFileName, Windows::UI::Xaml::Media::Imaging::WriteableBitmap^ bitmap);

	private:
		void InitMRUManager();

	private:
		Windows::Storage::StorageFolder^ m_MRUFolder;
	};
}