﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "MainPage.g.h"

namespace CompletePDFViewer
{
	public ref class MainPage sealed
	{
	public:
		MainPage();

		void OpenPdfFile(Windows::Storage::StorageFile^ pFile);

	private:
		foxit::rdk::PDFViewCtrl^ m_pViewCtrl;
		foxit::rdk::uiextensions::UIExtensionsManager^ m_uiextensions;
		Windows::Foundation::EventRegistrationToken m_DataRequestedEventToken;
		Windows::Storage::StorageFile^ m_pPDFFile;

	private:
		void OnInitializeControl();

	protected:
		virtual void OnNavigatedTo(Windows::UI::Xaml::Navigation::NavigationEventArgs^ e) override;
		virtual void OnNavigatedFrom(Windows::UI::Xaml::Navigation::NavigationEventArgs^ e)override;

	private:
		void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
		void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
		void OpenFileButton_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void SplitViewToggle_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void OnOpenPdfFileEvent(foxit::rdk::PDFViewCtrl ^sender, foxit::rdk::DocEventArgs^ e);
		void OnClosePdfFileEvent(foxit::rdk::PDFViewCtrl ^sender, foxit::rdk::DocEventArgs^ e);
		void OnDataRequested(Windows::ApplicationModel::DataTransfer::DataTransferManager ^sender, Windows::ApplicationModel::DataTransfer::DataRequestedEventArgs ^args);
	};
}
