﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "RecentlyListPage.g.h"

namespace CompletePDFViewer {
	namespace ConnectedPDF
	{
		ref class SkyDriveManager;
	}
}

namespace CompletePDFViewer
{	
	ref class RecentlyFileItem;
	ref class ThumbnailFileSaveCompletionEventArgs;
	ref class SkyDriveInfoItem;
	enum class FileViewMode;

	[Windows::Foundation::Metadata::WebHostHidden]
	public ref class RecentlyListPage sealed
	{
	public:
		RecentlyListPage();

		void SetViewMode(Platform::String^ viewMode);
		void ClearMruList();
		void UpdateMRUControlViewState();
		void DownLoadDriveFile();

		property FileViewMode LayoutMode
		{
			FileViewMode get();
		}

	private:
		Windows::UI::Xaml::Controls::Page^ m_ParentPage;
		Windows::Foundation::Collections::IVector<RecentlyFileItem^>^ m_MRUVectorItems;
		FileViewMode m_ViewMode;
		Windows::Foundation::EventRegistrationToken m_ThumbnailFileSaveCompletionToken;
		concurrency::cancellation_token_source m_TipsDlgCts;
		bool m_bFileOpenPickerOpened;
		concurrency::cancellation_token_source m_FileOpenPickerCts;
		Platform::String^ _DriveLogoutUrl;
		Platform::String^ _DriveLoginUrl;
		RecentlyFileItem^ curFileItem;
		Windows::UI::Xaml::DispatcherTimer^ m_GetProgressTimer;
		bool m_isCancelDownLoadFile;
		Platform::String^ tempFileName;
		Platform::String^ curfileName;
		bool m_driveFileDeleted;

	protected:
		void OnNavigatedTo(Windows::UI::Xaml::Navigation::NavigationEventArgs^ e) override;
		void OnNavigatedFrom(Windows::UI::Xaml::Navigation::NavigationEventArgs^ e) override;

	private:
		void OnInitializePage();
		void InitMruFileItems();
		int GetViewMode(FileViewMode viewmode);
		FileViewMode GetEnumViewMode(int viewmode);
		Platform::String^ GetStringViewMode(FileViewMode viewmode);
		void LoadMruFileItems();
		bool JudgeIsSkyDriveFile(Platform::String^ filePath);
		void RemoveDeleteFile(RecentlyFileItem^ item);

	private:
		void MRUButtonPanel_ItemClick(Platform::Object^ sender, Windows::UI::Xaml::Controls::ItemClickEventArgs^ e);
		void OnThumbnailFileSaveCompletion(Platform::Object ^sender, CompletePDFViewer::ThumbnailFileSaveCompletionEventArgs ^args);
		void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
		void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
		void ThumbModeMRUButtonPanel_Loaded(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
	};
}
