﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "StartPage.g.h"

namespace CompletePDFViewer
{
	[Windows::Foundation::Metadata::WebHostHidden]
	public ref class StartPage sealed
	{
	public:
		StartPage();

	internal:
		void OpenPage(Platform::String^ pageClassName, Platform::String^ title);
		double GetRelativePanelLength();

	private:
		bool m_CommandBarIsCompact;
		bool m_PinCommandBarIsCompact;
		Windows::Foundation::EventRegistrationToken m_SuspendingEventToken;
		Windows::Foundation::EventRegistrationToken m_HardwareButtonsBackPressedEventToken, m_SystemNavigationBackRequestedEventToken;
		Windows::Foundation::EventRegistrationToken m_SignInEventToken, m_LogoutEventToken;
		bool m_bFileOpenPickerOpened;
		concurrency::cancellation_token_source m_FileOpenPickerCts;
		Platform::String^ m_titleStr;

	private:
		void OnInitializePage();
		void UpdatePageState();
		void UpdateCommandBarControl();
		void UpdatePageTitle();
		void SetCommandBarControl(bool bIsCompact);

	private:
		void SplitViewToggle_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void RecentRadioButton_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void ListViewBtn_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void ThumbViewBtn_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void ClearListBtn_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void RecentMoreBtn_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void PageBackButton_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
		void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
		void OnSuspending(Platform::Object ^sender, Windows::ApplicationModel::SuspendingEventArgs ^e);
		void OnBackRequested(Platform::Object ^sender, Windows::UI::Core::BackRequestedEventArgs ^args);
	};
}
