﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "MainPage.g.h"

namespace FunctionDemo
{
	/// <summary>
	/// An empty page that can be used on its own or navigated to within a Frame.
	/// </summary>
	public ref class MainPage sealed
	{
	public:
		MainPage();

	private:
		Windows::Storage::StorageFolder^ m_InputFilesFolder;
		Windows::Storage::StorageFolder^ m_OutputFilesFolder;

	private:
		void pdf2txt_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void outline_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void annotation_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void docinfo_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void render_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		
		void setProperties(foxit::pdf::Bookmark^ bookmark);
		void showMesseageDialog(Platform::String^ title, Platform::String^ content);
		
		foxit::pdf::PDFDoc^ m_doc;
	};
}
