/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once


namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			public ref class AnnotSettingManager sealed : public IAnnotSettingImplementor
			{
			public:
				AnnotSettingManager();

				virtual double GetAnnotOpacity();
				virtual Windows::UI::Color GetAnnotColor();
				virtual int GetAnnotDrawBorderWidth();

				virtual void UpdateSaveCommandVisible();
				virtual void SavePropertySetting();

				virtual int GetEraserWidth();
				virtual void SetEraserWidth(int value);

			public:
				virtual void SetAnnotOpacity(double value);
				virtual void SetAnnotColor(Windows::UI::Color value);
				virtual void SetAnnotDrawBorderWidth(int linewidth);

				virtual void SetNoteLogoUrl(Platform::String^ url);
				virtual Platform::String^ GetNoteLogoUrl();

				virtual void SetNoteAuthor(Platform::String^ authorName);
				virtual Platform::String^ GetNoteAuthor();

				virtual void SetIsLinkHighlight(bool isHighlight);
				virtual bool GetIsLinkHighlight();

				virtual void SetViewIsDarkMode(Platform::String^ isDarkMode);
				virtual Platform::String^ GetViewIsDarkMode();

				virtual void SetIsFirstUserAnnot(bool isFirstUserAnnot);
				virtual bool GetIsFirstUserAnnot();

				virtual Windows::UI::Color GetHightLightAnnotColor();
				virtual void SetHightLightAnnotColor(Windows::UI::Color value);

				virtual double GetHightLightAnnotOpacity();
				virtual void SetHightLightAnnotOpacity(double value);

				virtual Windows::UI::Color GetUnderLineAnnotColor();
				virtual void SetUnderLineAnnotColor(Windows::UI::Color value);

				virtual double GetUnderLineAnnotOpacity();
				virtual void SetUnderLineAnnotOpacity(double value);

				virtual Windows::UI::Color GetStrikeOutAnnotColor();
				virtual void SetStrikeOutAnnotColor(Windows::UI::Color value);

				virtual double GetStrikeOutAnnotOpacity();
				virtual void SetStrikeOutAnnotOpacity(double value);

				virtual Windows::UI::Color GetSquigglyAnnotColor();
				virtual void SetSquigglyAnnotColor(Windows::UI::Color value);

				virtual double GetSquigglyAnnotOpacity();
				virtual void SetSquigglyAnnotOpacity(double value);

				virtual Windows::UI::Color GetLineAnnotColor();
				virtual void SetLineAnnotColor(Windows::UI::Color value);

				virtual int GetStampIndex();
				virtual void SetStampIndex(int value);

				virtual bool GetHightLightIsContinueOpera();
				virtual void SetHightLightIsContinueOpera(bool value);

				virtual bool GetAreaHightLightIsContinueOpera();
				virtual void SetAreaHightLightIsContinueOpera(bool value);

				virtual bool GetStrikeOutIsContinueOpera();
				virtual void SetStrikeOutIsContinueOpera(bool value);

				virtual bool GetUnderLineIsContinueOpera();
				virtual void SetUnderLineIsContinueOpera(bool value);

				virtual bool GetSquigglyIsContinueOpera();
				virtual void SetSquigglyIsContinueOpera(bool value);

				virtual bool GetTextIsContinueOpera();
				virtual void SetTextIsContinueOpera(bool value);

				virtual bool GetLineIsContinueOpera();
				virtual void SetLineIsContinueOpera(bool value);

				virtual bool GetArrowIsContinueOpera();
				virtual void SetArrowIsContinueOpera(bool value);

				virtual bool GetSquareIsContinueOpera();
				virtual void SetSquareIsContinueOpera(bool value);

				virtual bool GetCircleIsContinueOpera();
				virtual void SetCircleIsContinueOpera(bool value);

				virtual bool GetStampIsContinueOpera();
				virtual void SetStampeIsContinueOpera(bool value);

				virtual bool GetFreeTextIsContinueOpera();
				virtual void SetFreeTextIsContinueOpera(bool value);

				virtual Windows::UI::Color GetFreeTextColor();
				virtual void SetFreeTextColor(Windows::UI::Color value);

				virtual double GetFreeTextAnnotOpacity();
				virtual void SetFreeTextAnnotOpacity(double value);

				virtual int GetFreeTextFontSize();
				virtual void SetFreeTextFontSize(int value);

				virtual Platform::String^ GetFreeTextFontName();
				virtual void SetFreeTextFontName(Platform::String^ value);

				virtual void SetIsFirstUserTip(bool isFirstUserTip);
				virtual bool GetIsFirstUserTip();

				virtual bool GetInsertTextIsContinueOpera();
				virtual void SetInsertTextIsContinueOpera(bool value);

				virtual Windows::UI::Color GetInsertTextColor();
				virtual void SetInsertTextColor(Windows::UI::Color value);

				virtual double GetInsertTextAnnotOpacity();
				virtual void SetInsertTextAnnotOpacity(double value);

				virtual Windows::UI::Color GetReplaceTextColor();
				virtual void SetReplaceTextColor(Windows::UI::Color value);

				virtual double GetReplaceTextAnnotOpacity();
				virtual void SetReplaceTextAnnotOpacity(double value);

				virtual bool GetReplaceTextIsContinueOpera();
				virtual void SetReplaceTextIsContinueOpera(bool value);

			private:
				double _opacity;

				double _pencilopacity;
				Windows::UI::Color _PencilColor;
				int _linewidth;
				Platform::String^ noteLogo;
				Platform::String^ _authorName;
				bool _isLinkHightlight;
				Platform::String^ _isDarkMode;
				bool _isFirstUserAnnot;

				double _HighlightOpacity;
				Windows::UI::Color _HighlightColor;
				double _UnderLineOpacity;
				Windows::UI::Color _UnderLineColor;
				double _StrikeOutOpacity;
				Windows::UI::Color _StrikeOutColor;
				double _SquigglyOpacity;
				Windows::UI::Color _SquigglyColor;
				int  _EraserWidth;
				Windows::UI::Color _LineColor;
				int _StamIndex;

				bool _HightLightIsContinueOpera;
				bool _AreaHightLightIsContinueOpera;
				bool _StrikeOutIsContinueOpera;
				bool _UnderLineIsContinueOpera;
				bool _SquigglyIsContinueOpera;
				bool _TextIsContinueOpera;
				bool _LineIsContinueOpera;
				bool _ArrowIsContinueOpera;
				bool _SquareIsContinueOpera;
				bool _CircleIsContinueOpera;
				bool _StampIsContinueOpera;
				bool _FreeTextIsContinueOpera;
				bool _ReplaceTextIsContinueOpera;
				bool _IsFirstUserTip;

				double _FreeTextOpacity;
				Windows::UI::Color _FreeTextColor;
				int _FreeTextFontSize;
				Platform::String^ _FreeTextFontName;

				double _InsertTextOpacity;
				Windows::UI::Color _InsertTextColor;
				bool _InsertTextIsContinueOpera;

				double _ReplaceTextOpacity;
				Windows::UI::Color _ReplaceTextColor;

			private:
				Windows::Storage::ApplicationDataCompositeValue^ composite;
			};
		}
	}
}
