/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once


namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class CaretAnnot sealed : BaseAnnot
			{
			public:
				property Windows::Foundation::Rect Device_HightLightRect
				{
					Windows::Foundation::Rect get();
					void set(Windows::Foundation::Rect value);
				}

				property Windows::Foundation::Rect Page_HightLightRect
				{
					Windows::Foundation::Rect get();
					void set(Windows::Foundation::Rect value);
				}

				property Windows::Foundation::Rect GroupAnnotMinRect
				{
					Windows::Foundation::Rect get();
					void set(Windows::Foundation::Rect value);
				}

				property int GroupAnnotIndex
				{
					int get();
					void set(int value);
				}

				property bool IsHasGroup
				{
					bool get();
					void set(bool value);
				}

				property int TextRotate
				{
					int get();
					void set(int value);
				}

				property double InnerMargin
				{
					double get();
					void set(double value);
				}

				property Platform::String^ Intent
				{
					Platform::String^ get();
					void set(Platform::String^ value);
				}

			internal:
				property foxit::pdf::annots::Annot^ AnnotHandle
				{
					foxit::pdf::annots::Annot^ get()
					{
						return _PdfAnnot->PDF_Annot;
					}
				}

			public:
				/// Click on the precise
				virtual bool IsHitTest(Windows::Foundation::Point pagePoint) override;
				/// Click on the range
				virtual bool IsHitTestRange(Windows::Foundation::Point pagePoint) override;
				/// initialize
				virtual bool OnLoadAnnot(IAnnotManager^ annotmgr, Platform::Object^ pageObj, PDFAnnotHandle^ annot) override;
				/// create
				virtual bool OnCreate(IAnnotManager^ annotmgr, Platform::Object^ pageObj) override;

			internal:
				CaretAnnot();

			private:
				Windows::Foundation::Rect	_Device_HightLightRect;
				Windows::Foundation::Rect	_Page_HightLightRect;
				foxit::pdf::annots::IAnnot^ _GroupAnnotHandle;
				Windows::Foundation::Rect _GroupAnnotMinRect;
				bool _IsHasGroup;
				int _GroupAnnotIndex;
				int _TextRotate;
				double _InnerMargin;
				Platform::String^ _Intent;
			};

			ref class AnnotationManager;
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class CaretHandler sealed : public BaseAnnotHandler
			{
			public:
				CaretHandler();

			private:
				bool m_IsPressed;
				Windows::Foundation::Point m_PressedStartPoint;

			private:
				CaretAnnot^ m_SelectedAnnot;
			};
		}
	}
}
