/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#include "pch.h"
#include "Annot_Circle.h"


using namespace foxit::rdk::uiextensions;

using namespace Platform;
using namespace std;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;
using namespace Windows::UI::Popups;
using namespace Windows::UI::Xaml::Shapes;

CircleAnnot::CircleAnnot()
{
	_AnnotType = AnnotationType::Circle;
}

Windows::Foundation::Rect CircleAnnot::Page_HightLightRect::get()
{
	return _Page_HightLightRect;
}

void CircleAnnot::Page_HightLightRect::set(Windows::Foundation::Rect value)
{
	if (_Page_HightLightRect != value)
	{
		_Page_HightLightRect = value;
		if (_PdfAnnot && _PdfAnnot->PDF_Annot)
		{
			foxit::common::fxcrt::RectF^ rect = FoxitRectConverter::ConvertToFoxitRectF(_Page_HightLightRect);
			_PdfAnnot->PDF_Annot->Move(rect);
			_PdfAnnot->PDF_Annot->ResetAppearanceStream();
			NotifyDocumentChanged();
		}
	}
}

Windows::Foundation::Rect CircleAnnot::Device_HightLightRect::get()
{
	return _Device_HightLightRect;
}

void CircleAnnot::Device_HightLightRect::set(Windows::Foundation::Rect value)
{
	if (_Device_HightLightRect != value)
	{
		_Device_HightLightRect = value;
	}
}

bool CircleAnnot::IsHitTest(Windows::Foundation::Point pagePoint)
{
	return false;
}

bool CircleAnnot::IsHitTestRange(Windows::Foundation::Point pagePoint)
{
	return _Page_HightLightRect.Contains(pagePoint);
	return false;
}

bool CircleAnnot::OnLoadAnnot(IAnnotManager^ annotmgr, Platform::Object^ pageObj, PDFAnnotHandle^ annot)
{
	if (!BaseAnnot::OnLoadAnnot(annotmgr, pageObj, annot))
		return false;

	FS_RESULT iRet = -1;
	_Page_HightLightRect = _MinRect;

	return true;
}

bool CircleAnnot::OnCreate(IAnnotManager^ annotmgr, Platform::Object^ pageObj)
{
	_MinRect = _Page_HightLightRect;
	if (!BaseAnnot::OnCreate(annotmgr, pageObj))
		return false;


	_PdfAnnot->PDF_Annot->ResetAppearanceStream();
	AnnotMgr->AddAnnot(this);

	return true;
}

CircleHandler::CircleHandler()
{
	_AnnotHandlerType = AnnotationType::Circle;
}