/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class FreeTextAnnot sealed : BaseAnnot
			{
			public:
				property Windows::Foundation::Rect Device_HightLightRect
				{
					Windows::Foundation::Rect get()
					{
						return _Device_HightLightRect;
					}
					void set(Windows::Foundation::Rect value)
					{
						_Device_HightLightRect = value;
					}
				}

				property Windows::Foundation::Rect Page_HightLightRect
				{
					Windows::Foundation::Rect get();
					void set(Windows::Foundation::Rect value);
				}

				property Platform::String^ Intent
				{
					Platform::String^ get();
					void set(Platform::String^ value);
				}

				property double FontSize
				{
					double get();
					void set(double value);
				}

				property Platform::String^ FontName
				{
					Platform::String^ get();
					void set(Platform::String^ value);
				}

				property Windows::UI::Color TextColor
				{
					Windows::UI::Color get();
					void set(Windows::UI::Color value);
				}

				property Windows::Foundation::Numerics::float3x2 TextMatrix
				{
					Windows::Foundation::Numerics::float3x2 get();
					void set(Windows::Foundation::Numerics::float3x2 value);
				}

			internal:
				property foxit::pdf::annots::Annot^ AnnotHandle
				{
					foxit::pdf::annots::Annot^ get()
					{
						return _PdfAnnot->PDF_Annot;
					}
				}

			public:
				/// Click on the precise
				virtual bool IsHitTest(Windows::Foundation::Point pagePoint) override;
				/// Click on the range
				virtual bool IsHitTestRange(Windows::Foundation::Point pagePoint) override;
				/// initialize
				virtual bool OnLoadAnnot(IAnnotManager^ annotmgr, Platform::Object^ pageObj, PDFAnnotHandle^ annot) override;
				/// create
				virtual bool OnCreate(IAnnotManager^ annotmgr, Platform::Object^ pageObj) override;

			public:
				void ResetAppearence();

			internal:
				FreeTextAnnot();

			private:
				Windows::Foundation::Rect _Device_HightLightRect;
				Windows::Foundation::Rect _Page_HightLightRect;
				Platform::String^ _Intent;
				double _FontSize;
				Platform::String^ _FontName;
				Windows::UI::Color	_TextColor;
				Windows::Foundation::Numerics::float3x2 _TextMatrix;
			};

			ref class AnnotationManager;
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class FreeTextAnnotHandler sealed : public BaseAnnotHandler
			{
			public:
				FreeTextAnnotHandler();

			public:
				void OnManipulationStarted(Platform::Object^ sender, Windows::UI::Xaml::Input::ManipulationStartedRoutedEventArgs^ e) override;
				void OnManipulationDelta(Platform::Object^ sender, Windows::UI::Xaml::Input::ManipulationDeltaRoutedEventArgs^ e) override;
				void OnManipulationCompleted(Platform::Object^ sender, Windows::UI::Xaml::Input::ManipulationCompletedRoutedEventArgs^ e) override;

			private:
				FreeTextAnnot^ m_SelectedAnnot;

			private:
				bool m_IsPressed;
				Windows::Foundation::Point m_PressedStartPoint;
			};
		}
	}
}