/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once


namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class HighLightAnnot sealed : BaseAnnot
			{
			public:
				property Windows::UI::Xaml::Shapes::Shape^ Bordershape
				{
					Windows::UI::Xaml::Shapes::Shape^  get()
					{
						return _Bordershape;
					}
					void set(Windows::UI::Xaml::Shapes::Shape^ value)
					{
						_Bordershape = value;
					}
				}

			public:
				property Windows::Foundation::Collections::IVector<Windows::Foundation::Rect>^ Device_HightLightRectGroup
				{
					Windows::Foundation::Collections::IVector<Windows::Foundation::Rect>^ get()
					{
						return _Device_HightLightRectGroup;
					}
					void set(Windows::Foundation::Collections::IVector<Windows::Foundation::Rect>^ value)
					{
						_Device_HightLightRectGroup = value;
					}
				}

				property Windows::Foundation::Collections::IVector<Windows::Foundation::Rect>^ Page_HightLightRectGroup
				{
					Windows::Foundation::Collections::IVector<Windows::Foundation::Rect>^ get()
					{
						return _Page_HightLightRectGroup;
					}
					void set(Windows::Foundation::Collections::IVector<Windows::Foundation::Rect>^ value)
					{
						_Page_HightLightRectGroup = value;
					}
				}

				property Windows::Foundation::Rect DeviceMinRect
				{
					Windows::Foundation::Rect get()
					{
						return _DeviceMinRect;
					}
					void set(Windows::Foundation::Rect value)
					{
						_DeviceMinRect = value;
					}
				}

			internal:
				property foxit::pdf::annots::Annot^ AnnotHandle
				{
					foxit::pdf::annots::Annot^ get()
					{
						return _PdfAnnot->PDF_Annot;
					}
				}

			public:
				/// Click on the precise
				virtual bool IsHitTest(Windows::Foundation::Point pagePoint) override;
				/// Click on the range
				virtual bool IsHitTestRange(Windows::Foundation::Point pagePoint) override;
				/// initialize
				virtual bool OnLoadAnnot(IAnnotManager^ annotmgr, Platform::Object^ pageObj, PDFAnnotHandle^ annot) override;
				/// create
				virtual bool OnCreate(IAnnotManager^ annotmgr, Platform::Object^ pageObj) override;

			internal:
				HighLightAnnot();

			private:
				Windows::UI::Xaml::Shapes::Shape^ _Bordershape;
				Windows::Foundation::Rect _DeviceMinRect;

			private:
				Windows::Foundation::Collections::IVector<Windows::Foundation::Rect>^ _Device_HightLightRectGroup;
				Windows::Foundation::Collections::IVector<Windows::Foundation::Rect>^ _Page_HightLightRectGroup;
			};

			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class HighLightAnnotHandler sealed : public BaseAnnotHandler
			{
			public:
				HighLightAnnotHandler();

				virtual void ClearSelectedBorder() override;
				virtual void EndDrawing() override;
				virtual void Reset() override;

			private:
				Windows::UI::Xaml::Controls::TextBox^ __TB;
				Windows::UI::Xaml::Controls::Primitives::Popup^ m_PopUp_Annotation;
				Windows::Foundation::EventRegistrationToken __inputPaneShowingEventRegistrationToken, __inputPaneHidingEventRegistrationToken;
				double m_PopUp_AnnotationVertocalOffset;

			private:
				void InitCommentPopup();
				void CommentPopupOpened(Platform::Object^ sender, Platform::Object^ e);
				void CommentPopupClosed(Platform::Object^ sender, Platform::Object^ e);
				void OpenCommentPopupMarkup(Windows::Foundation::Point pt, Platform::String^ contents, Platform::Object^ param);
				void OnRichEditBoxLostFocus(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void ResetCommentPopup();
			};
		}
	}
}


