/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class PencilAnnot sealed : public BaseAnnot
			{
			public:
				property Windows::Foundation::Rect PageMinRect
				{
					Windows::Foundation::Rect get();
					void set(Windows::Foundation::Rect value);
				}
				property Windows::Foundation::Rect DeviceMinRect
				{
					Windows::Foundation::Rect get();
					void set(Windows::Foundation::Rect value);
				}

				property Windows::Foundation::Collections::IVector<Windows::Foundation::Collections::IVector<Windows::Foundation::Point>^>^ UpdatePage_VectPoint
				{
					Windows::Foundation::Collections::IVector<Windows::Foundation::Collections::IVector<Windows::Foundation::Point>^>^ get();
					void set(Windows::Foundation::Collections::IVector<Windows::Foundation::Collections::IVector<Windows::Foundation::Point>^>^ value);
				}

			public:
				property Windows::Foundation::Collections::IVector<Windows::Foundation::Collections::IVector<Windows::Foundation::Point>^>^ Device_VectPoint
				{
					Windows::Foundation::Collections::IVector<Windows::Foundation::Collections::IVector<Windows::Foundation::Point>^>^ get()
					{
						return _Device_VectPoint;
					}
					void set(Windows::Foundation::Collections::IVector<Windows::Foundation::Collections::IVector<Windows::Foundation::Point>^>^ value)
					{
						_Device_VectPoint = value;
					}
				}

				property Windows::Foundation::Collections::IVector<Windows::Foundation::Collections::IVector<Windows::Foundation::Point>^>^ Page_VectPoint
				{
					Windows::Foundation::Collections::IVector<Windows::Foundation::Collections::IVector<Windows::Foundation::Point>^>^ get()
					{
						return _Page_VectPoint;
					}
					void set(Windows::Foundation::Collections::IVector<Windows::Foundation::Collections::IVector<Windows::Foundation::Point>^>^ value)
					{
						_Page_VectPoint = value;
					}
				}

				property Windows::Foundation::Collections::IVector<Windows::Foundation::Collections::IVector<Windows::Foundation::Point>^>^ Device_VectPointNoMargin
				{
					Windows::Foundation::Collections::IVector<Windows::Foundation::Collections::IVector<Windows::Foundation::Point>^>^ get()
					{
						return _Device_VectPointNoMargin;
					}
					void set(Windows::Foundation::Collections::IVector<Windows::Foundation::Collections::IVector<Windows::Foundation::Point>^>^ value)
					{
						_Device_VectPointNoMargin = value;
					}
				}

			internal:
				property foxit::pdf::annots::Annot^ AnnotHandle
				{
					foxit::pdf::annots::Annot^ get()
					{
						if (_PdfAnnot)
							return _PdfAnnot->PDF_Annot;
						else
							return nullptr;
					}
				}

			public:
				/// Click on the precise
				virtual bool IsHitTest(Windows::Foundation::Point pagePoint) override;
				/// Click on the range
				virtual bool IsHitTestRange(Windows::Foundation::Point pagePoint) override;
				/// initialize
				virtual bool OnLoadAnnot(IAnnotManager^ annotmgr, Platform::Object^ pageObj, PDFAnnotHandle^ annot) override;
				/// create
				virtual bool OnCreate(IAnnotManager^ annotmgr, Platform::Object^ pageObj) override;

			public:
				bool UpdatePathData();
				bool EraserPencilPoint(Windows::Foundation::Rect eraserRect, bool isUpdateView);
				bool IsHitInkPoint(Windows::Foundation::Rect eraserRect);

			internal:
				PencilAnnot();

			internal:
				Windows::Foundation::Collections::IVector<Windows::Foundation::Collections::IVector<Windows::Foundation::Point>^>^ GetNewVector(Windows::Foundation::Collections::IVector<Windows::Foundation::Collections::IVector<Windows::Foundation::Point>^>^ pVect);
			
			private:
				Windows::Foundation::Rect _PageMinRect;
				Windows::Foundation::Rect _DeviceMinRect;
				bool m_isUpdateView;

			private:
				Windows::Foundation::Collections::IVector<Windows::Foundation::Collections::IVector<Windows::Foundation::Point>^>^	_Device_VectPoint;
				Windows::Foundation::Collections::IVector<Windows::Foundation::Collections::IVector<Windows::Foundation::Point>^>^	_Page_VectPoint;
				Windows::Foundation::Collections::IVector<Windows::Foundation::Collections::IVector<Windows::Foundation::Point>^>^ _Device_VectPointNoMargin;
				Windows::Foundation::Collections::IVector<Windows::Foundation::Collections::IVector<Windows::Foundation::Point>^>^	_Update_VectPoint;
			};

			ref class AnnotationManager;
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class PencilHandler sealed : public BaseAnnotHandler
			{
			public:
				PencilHandler();

			private:
				bool m_IsPressed;
				Windows::Foundation::Point m_PressedStartPoint;
				Windows::Foundation::Collections::IVector<Windows::Foundation::Collections::IVector<Windows::Foundation::Point>^>^	m_deviceVectPoint;
				Windows::Foundation::Collections::IVector<Windows::Foundation::Collections::IVector<Windows::Foundation::Point>^>^	m_deviceVectPointMargin;
				Windows::Foundation::Collections::IVector<Windows::Foundation::Point>^ m_pointsMargin;
				Windows::Foundation::Collections::IVector<Windows::Foundation::Point>^ m_DrawPoints;
				int m_DrawingPageIndex;

			private:
				Windows::UI::Xaml::DispatcherTimer^ m_PencilTimer;
				// Timer interval
				Windows::Foundation::TimeSpan m_PencilTimerTimeSpan;
			};
		}
	}
}
