/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once


namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class LineAnnot sealed : public BaseAnnot
			{
			public:
				property Windows::Foundation::Point Device_StartPoint
				{
					Windows::Foundation::Point get()
					{
						return _Device_StartPoint;
					}
					void set(Windows::Foundation::Point value)
					{
						_Device_StartPoint = value;
					}
				}

				property Windows::Foundation::Point Device_EndPoint
				{
					Windows::Foundation::Point get()
					{
						return _Device_EndPoint;
					}
					void set(Windows::Foundation::Point value)
					{
						_Device_EndPoint = value;
					}
				}

				property Windows::Foundation::Point Page_StartPoint
				{
					Windows::Foundation::Point get();
					void set(Windows::Foundation::Point value);
				}

				property Windows::Foundation::Point Page_EndPoint
				{
					Windows::Foundation::Point get();
					void set(Windows::Foundation::Point value);
				}

				property Windows::Foundation::Rect PageMinRect
				{
					Windows::Foundation::Rect get();
					void set(Windows::Foundation::Rect value);
				}

				property bool IsArrow
				{
					bool get();
					void set(bool value);
				}

			internal:
				property foxit::pdf::annots::Annot^ AnnotHandle
				{
					foxit::pdf::annots::Annot^ get()
					{
						return _PdfAnnot->PDF_Annot;
					}
				}

			public:
				/// Click on the precise
				virtual bool IsHitTest(Windows::Foundation::Point pagePoint) override;
				/// Click on the range
				virtual bool IsHitTestRange(Windows::Foundation::Point pagePoint) override;
				/// initialize
				virtual bool OnLoadAnnot(IAnnotManager^ annotmgr, Platform::Object^ pageObj, PDFAnnotHandle^ annot) override;
				/// create
				virtual bool OnCreate(IAnnotManager^ annotmgr, Platform::Object^ pageObj) override;

			internal:
				LineAnnot();

			private:
				Windows::Foundation::Rect _PageMinRect;

			private:
				Windows::Foundation::Point	_Device_StartPoint;
				Windows::Foundation::Point	_Device_EndPoint;
				Windows::Foundation::Point	_Page_StartPoint;
				Windows::Foundation::Point	_Page_EndPoint;

				double _LineWidth;
				bool  m_IsArrow = false;
				bool m_IsDistance = false;
			};

			ref class AnnotationManager;
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class LineHandler sealed : public BaseAnnotHandler
			{
			public:
				LineHandler();

			private:
				LineAnnot^ m_SelectedAnnot;

			private:
				bool m_IsPressed;
				Windows::Foundation::Point m_PressedStartPoint;
			};
		}
	}
}
