/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once


namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			public ref class LinkAnnotPolygon sealed
			{
			public:
				LinkAnnotPolygon()
				{

				}
				virtual ~LinkAnnotPolygon() {}
				property double x1 { double get() { return _x1; } void set(double value) { _x1 = value; }}
				property double x2 { double get() { return _x2; } void set(double value) { _x2 = value; }}
				property double x3 { double get() { return _x3; } void set(double value) { _x3 = value; }}
				property double x4 { double get() { return _x4; } void set(double value) { _x4 = value; }}
				property double y1 { double get() { return _y1; } void set(double value) { _y1 = value; }}
				property double y2 { double get() { return _y2; } void set(double value) { _y2 = value; }}
				property double y3 { double get() { return _y3; } void set(double value) { _y3 = value; }}
				property double y4 { double get() { return _y4; } void set(double value) { _y4 = value; }}

			private:
				double _x1;
				double _x2;
				double _x3;
				double _x4;
				double _y1;
				double _y2;
				double _y3;
				double _y4;
			};

			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class LinkAnnot sealed : BaseAnnot
			{
			public:
				property Windows::UI::Xaml::Shapes::Shape^ Bordershape
				{
					Windows::UI::Xaml::Shapes::Shape^  get()
					{
						return _Bordershape;
					}
					void set(Windows::UI::Xaml::Shapes::Shape^ value)
					{
						_Bordershape = value;
					}
				}

			public:
				property Windows::Foundation::Collections::IVector<LinkAnnotPolygon^>^ Device_HightLightRectGroup
				{
					Windows::Foundation::Collections::IVector<LinkAnnotPolygon^>^ get()
					{
						return _Device_HightLightRectGroup;
					}
					void set(Windows::Foundation::Collections::IVector<LinkAnnotPolygon^>^ value)
					{
						_Device_HightLightRectGroup = value;
					}
				}

				property Windows::Foundation::Collections::IVector<LinkAnnotPolygon^>^ Page_HightLightRectGroup
				{
					Windows::Foundation::Collections::IVector<LinkAnnotPolygon^>^ get()
					{
						return _Page_HightLightRectGroup;
					}
					void set(Windows::Foundation::Collections::IVector<LinkAnnotPolygon^>^ value)
					{
						_Page_HightLightRectGroup = value;
					}
				}

				property Windows::Foundation::Rect DeviceMinRect
				{
					Windows::Foundation::Rect get()
					{
						return _DeviceMinRect;
					}
					void set(Windows::Foundation::Rect value)
					{
						_DeviceMinRect = value;
					}
				}

			internal:
				property foxit::pdf::annots::Annot^ AnnotHandle
				{
					foxit::pdf::annots::Annot^ get()
					{
						return _PdfAnnot->PDF_Annot;
					}
				}

			public:
				/// Click on the precise
				virtual bool IsHitTest(Windows::Foundation::Point pagePoint) override;
				/// Click on the range
				virtual bool IsHitTestRange(Windows::Foundation::Point pagePoint) override;
				/// initialize
				virtual bool OnLoadAnnot(IAnnotManager^ annotmgr, Platform::Object^ pageObj, PDFAnnotHandle^ annot) override;
				/// create
				virtual bool OnCreate(IAnnotManager^ annotmgr, Platform::Object^ pageObj) override;

			internal:
				LinkAnnot();

			private:
				bool pointInPolygon(LinkAnnotPolygon^ pLinkPoint, Windows::Foundation::Point pagePt);

			private:
				Windows::UI::Xaml::Shapes::Shape^ _Bordershape;
				Windows::Foundation::Rect _DeviceMinRect;

			private:
				Windows::Foundation::Collections::IVector<LinkAnnotPolygon^>^ _Device_HightLightRectGroup;
				Windows::Foundation::Collections::IVector<LinkAnnotPolygon^>^ _Page_HightLightRectGroup;
			};

			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class LinkAnnotHandler sealed : public BaseAnnotHandler
			{
			public:
				LinkAnnotHandler();

				virtual void ClearSelectedBorder() override;
				virtual void EndDrawing() override;
				virtual void Reset() override;

			};
		}
	}
}


