/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once


namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class StampAnnot sealed : BaseAnnot
			{
			public:
				property Windows::Foundation::Rect Device_HightLightRect
				{
					Windows::Foundation::Rect get()
					{
						return _Device_HightLightRect;
					}
					void set(Windows::Foundation::Rect value)
					{
						_Device_HightLightRect = value;
					}
				}

				property Windows::Foundation::Rect Page_HightLightRect
				{
					Windows::Foundation::Rect get();
					void set(Windows::Foundation::Rect value);
				}

				property Platform::String^ Subject
				{
					Platform::String^ get()
					{
						return m_AnnotSubject;
					}
					void set(Platform::String^ value)
					{
						m_AnnotSubject = value;
					}
				}

				property Windows::Storage::StorageFile^ CustomStampResourceFile
				{
					Windows::Storage::StorageFile^ get()
					{
						return m_CustomStampResourceFile;
					}
					void set(Windows::Storage::StorageFile^ value)
					{
						m_CustomStampResourceFile = value;
					}
				}

				property int DefaultStampIndex
				{
					int get()
					{
						return m_DefaultStampIndex;
					}
					void set(int value)
					{
						m_DefaultStampIndex = value;
					}
				}

			internal:

				property foxit::pdf::annots::Annot^ AnnotHandle
				{
					foxit::pdf::annots::Annot^ get()
					{
						return _PdfAnnot->PDF_Annot;
					}
				}

			public:
				/// Click on the precise
				virtual bool IsHitTest(Windows::Foundation::Point pagePoint) override;
				/// Click on the range
				virtual bool IsHitTestRange(Windows::Foundation::Point pagePoint) override;
				/// initialize
				virtual bool OnLoadAnnot(IAnnotManager^ annotmgr, Platform::Object^ pageObj, PDFAnnotHandle^ annot) override;
				/// create
				virtual bool OnCreate(IAnnotManager^ annotmgr, Platform::Object^ pageObj) override;

			internal:
				StampAnnot();

			private:
				Windows::Foundation::Rect _Device_HightLightRect;
				Windows::Foundation::Rect _Page_HightLightRect;
				double _FontSize;
				Windows::UI::Color	_TextColor;
				Platform::String^ m_AnnotSubject;
				Windows::Storage::StorageFile^ m_CustomStampResourceFile;
				int m_DefaultStampIndex;
			};

			ref class AnnotationManager;
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class StampAnnotHandler sealed : public BaseAnnotHandler
			{
			public:
				StampAnnotHandler();

			public:
				void OnManipulationStarted(Platform::Object^ sender, Windows::UI::Xaml::Input::ManipulationStartedRoutedEventArgs^ e) override;
				void OnManipulationDelta(Platform::Object^ sender, Windows::UI::Xaml::Input::ManipulationDeltaRoutedEventArgs^ e) override;
				void OnManipulationCompleted(Platform::Object^ sender, Windows::UI::Xaml::Input::ManipulationCompletedRoutedEventArgs^ e) override;

			private:
				StampAnnot^ m_SelectedAnnot;

			private:
				bool m_IsPressed;
				Windows::Foundation::Point m_PressedStartPoint;
			};
		}
	}
}
