/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::UI::Xaml::Data::Bindable]
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class ReplyAnnot sealed : public BindableBase
			{
			public:
				ReplyAnnot();

				property Platform::String^ ReplyTitle
				{
					Platform::String^ get();
					void set(Platform::String^ value);
				}

				property Platform::String^ ReplyContents
				{
					Platform::String^ get();
					void set(Platform::String^ value);
				}

				property Platform::String^ ReplyDateTime
				{
					Platform::String^ get();
					void set(Platform::String^ value);
				}

				property int ReplySeries
				{
					int get();
					void set(int value);
				}

			private:
				Platform::String^ _ReplyTitle;
				Platform::String^ _ReplyContents;
				Platform::String^ _ReplyDateTime;
				int _ReplySeries;
			};

			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class TextAnnot sealed : BaseAnnot
			{
			public:
				property AnnotIconNameTextType IconType
				{
					AnnotIconNameTextType get();
					void set(AnnotIconNameTextType value);
				}
				property bool OpenStatus
				{
					bool get();
					void set(bool value);
				}
				property Windows::Foundation::Point PosPoint
				{
					Windows::Foundation::Point get();
					void set(Windows::Foundation::Point value);
				}
				property Windows::Foundation::Size IconSize
				{
					Windows::Foundation::Size get();
					void set(Windows::Foundation::Size value);
				}

				property int ReplyCount
				{
					int get();
					void set(int value);
				}

				property Windows::Foundation::Collections::IVector<ReplyAnnot^>^ ReplyAnnotGroup
				{
					Windows::Foundation::Collections::IVector<ReplyAnnot^>^ get()
					{
						return _ReplyAnnotGroup;
					}
					void set(Windows::Foundation::Collections::IVector<ReplyAnnot^>^ value)
					{
						_ReplyAnnotGroup = value;
					}
				}

				property Windows::Foundation::Rect DrawRect
				{
					Windows::Foundation::Rect get();
					void set(Windows::Foundation::Rect value);
				}

			internal:
				property foxit::pdf::annots::Annot^ AnnotHandle
				{
					foxit::pdf::annots::Annot^ get()
					{
						return _PdfAnnot->PDF_Annot;
					}
				}

			public:
				/// Click on the precise
				virtual bool IsHitTest(Windows::Foundation::Point pagePoint) override;
				/// Click on the range
				virtual bool IsHitTestRange(Windows::Foundation::Point pagePoint) override;
				/// initialize
				virtual bool OnLoadAnnot(IAnnotManager^ annotmgr, Platform::Object^ pageObj, PDFAnnotHandle^ annot) override;
				/// create
				virtual bool OnCreate(IAnnotManager^ annotmgr, Platform::Object^ pageObj) override;

			internal:
				TextAnnot();

			private:
				void LoadSubReplyAnnot(foxit::pdf::annots::Note^ parentannot, int count, int series);

			private:
				AnnotIconNameTextType _IconType;
				bool _OpenStatus;
				Windows::Foundation::Point _PosPoint;
				Windows::Foundation::Size _IconSize;
				Windows::Foundation::Collections::IVector<ReplyAnnot^>^ _ReplyAnnotGroup;
				int _ReplyCount;
				Windows::Foundation::Rect _DrawRect;
			};

			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class TextAnnotHandler sealed : public BaseAnnotHandler
			{
			public:
				TextAnnotHandler();

				virtual void ClearSelectedBorder() override;
				virtual void EndDrawing() override;
				virtual void Reset() override;

			};
		}
	}
}


