/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once


namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class UnderLineAnnot sealed : BaseAnnot
			{
			public:
				property Windows::UI::Xaml::Shapes::Shape^ Bordershape
				{
					Windows::UI::Xaml::Shapes::Shape^  get()
					{
						return _Bordershape;
					}
					void set(Windows::UI::Xaml::Shapes::Shape^ value)
					{
						_Bordershape = value;
					}
				}

			public:
				property Windows::Foundation::Collections::IVector<Windows::Foundation::Rect>^ Device_HightLightRectGroup
				{
					Windows::Foundation::Collections::IVector<Windows::Foundation::Rect>^ get()
					{
						return _Device_HightLightRectGroup;
					}
					void set(Windows::Foundation::Collections::IVector<Windows::Foundation::Rect>^ value)
					{
						_Device_HightLightRectGroup = value;
					}
				}

				property Windows::Foundation::Collections::IVector<Windows::Foundation::Rect>^ Page_HightLightRectGroup
				{
					Windows::Foundation::Collections::IVector<Windows::Foundation::Rect>^ get()
					{
						return _Page_HightLightRectGroup;
					}
					void set(Windows::Foundation::Collections::IVector<Windows::Foundation::Rect>^ value)
					{
						_Page_HightLightRectGroup = value;
					}
				}

				property Windows::Foundation::Rect DeviceMinRect
				{
					Windows::Foundation::Rect get()
					{
						return _DeviceMinRect;
					}
					void set(Windows::Foundation::Rect value)
					{
						_DeviceMinRect = value;
					}
				}

				property Windows::Foundation::Collections::IVector<int>^ TextRotateVect
				{
					Windows::Foundation::Collections::IVector<int>^ get()
					{
						return _TextRotateVect;
					}
					void set(Windows::Foundation::Collections::IVector<int>^ value)
					{
						_TextRotateVect = value;
					}
				}

			internal:
				property foxit::pdf::annots::Annot^ AnnotHandle
				{
					foxit::pdf::annots::Annot^ get()
					{
						return _PdfAnnot->PDF_Annot;
					}
				}

			public:
				/// Click on the precise
				virtual bool IsHitTest(Windows::Foundation::Point pagePoint) override;
				/// Click on the range
				virtual bool IsHitTestRange(Windows::Foundation::Point pagePoint) override;
				/// initialize
				virtual bool OnLoadAnnot(IAnnotManager^ annotmgr, Platform::Object^ pageObj, PDFAnnotHandle^ annot) override;
				/// create
				virtual bool OnCreate(IAnnotManager^ annotmgr, Platform::Object^ pageObj) override;

			internal:
				UnderLineAnnot();

			private:
				Windows::UI::Xaml::Shapes::Shape^ _Bordershape;
				Windows::Foundation::Rect _DeviceMinRect;

			private:
				Windows::Foundation::Collections::IVector<Windows::Foundation::Rect>^ _Device_HightLightRectGroup;
				Windows::Foundation::Collections::IVector<Windows::Foundation::Rect>^ _Page_HightLightRectGroup;

				Windows::Foundation::Collections::IVector<int>^ _TextRotateVect;
			};

			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class UnderLineAnnotHandler sealed : public BaseAnnotHandler
			{
			public:
				UnderLineAnnotHandler();

				virtual void ClearSelectedBorder() override;
				virtual void EndDrawing() override;
				virtual void Reset() override;

			};
		}
	}
}


