/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#include "pch.h"
#include "Annot_Widget.h"

using namespace foxit::rdk::uiextensions;

using namespace Platform;
using namespace std;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;
using namespace Windows::UI::Popups;
using namespace Windows::UI::Xaml::Shapes;

WidgetAnnot::WidgetAnnot()
{
	_AnnotType = AnnotationType::Widget;
}

Windows::Foundation::Rect WidgetAnnot::Page_HightLightRect::get()
{
	return _Page_HightLightRect;
}

void WidgetAnnot::Page_HightLightRect::set(Windows::Foundation::Rect value)
{
	if (_Page_HightLightRect != value)
	{
		_Page_HightLightRect = value;
		if (_PdfAnnot && _PdfAnnot->PDF_Annot)
		{
			foxit::common::fxcrt::RectF^ rect = FoxitRectConverter::ConvertToFoxitRectF(_Page_HightLightRect);
			_PdfAnnot->PDF_Annot->Move(rect);
			_PdfAnnot->PDF_Annot->ResetAppearanceStream();
			NotifyDocumentChanged();
		}
	}
}

PDFFormControlWrapper^ WidgetAnnot::FormControl::get()
{
	return _Wrapper;
}

bool WidgetAnnot::IsHitTest(Windows::Foundation::Point pagePoint)
{
	return BaseAnnot::IsHitTest(pagePoint);
}

bool WidgetAnnot::IsHitTestRange(Windows::Foundation::Point pagePoint)
{
	return BaseAnnot::IsHitTestRange(pagePoint);
}

bool WidgetAnnot::OnLoadAnnot(IAnnotManager^ annotmgr, Platform::Object^ pageObj, PDFAnnotHandle^ annot)
{
	if (!BaseAnnot::OnLoadAnnot(annotmgr, pageObj, annot))
		return false;

	_Page_HightLightRect = _MinRect;

	return true;
}

bool WidgetAnnot::OnCreate(IAnnotManager^ annotmgr, Platform::Object^ pageObj)
{
	_MinRect = _Page_HightLightRect;
	if (!BaseAnnot::OnCreate(annotmgr, pageObj))
		return false;

	_PdfAnnot->PDF_Annot->ResetAppearanceStream();
	AnnotMgr->AddAnnot(this);

	return true;
}


WidgetAnnotHandler::WidgetAnnotHandler()
{
	_AnnotHandlerType = AnnotationType::Widget;
}

void WidgetAnnotHandler::OnManipulationStarted(Platform::Object^ sender, Windows::UI::Xaml::Input::ManipulationStartedRoutedEventArgs^ e)
{

}

void WidgetAnnotHandler::OnManipulationDelta(Platform::Object^ sender, Windows::UI::Xaml::Input::ManipulationDeltaRoutedEventArgs^ e)
{

}

void WidgetAnnotHandler::OnManipulationCompleted(Platform::Object^ sender, Windows::UI::Xaml::Input::ManipulationCompletedRoutedEventArgs^ e)
{

}

