/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			public ref class SaveFileBufferAnnotCom sealed
			{
			internal:
				Platform::Object^	fileBuffer;
				int offsetvalue;
				int size;
			};


			class FSSDK_FileHandlerReadWriteAnnotCom
			{
			public:
				FSSDK_FileHandlerReadWriteAnnotCom();
				virtual ~FSSDK_FileHandlerReadWriteAnnotCom();
				void	CreateFileRead(Windows::Storage::StorageFile^ pFile, int nFileSize);
				void	CreateFileToRead(Windows::Storage::StorageFile^ pFile, int nFileSize);
				void	Release();
				int		GetSize();
				void	SetSize(int nSize);
				bool	ReadBlock(void* buffer, int offset, size_t size);
				bool	WriteBlock(const void* buffer, int offset, size_t size);
				void	ReleaseTempWriteBuffer();
				BOOL	LoadSpecifyFileCache();

				Platform::Collections::Vector<SaveFileBufferAnnotCom^>^ GetFileBuffer();
			private:
				Windows::Storage::StorageFile^						m_pFile;
				int													m_iFileSize;
				Platform::Collections::Vector<SaveFileBufferAnnotCom^>^	m_Buffer;
				void*												m_pFileCacheBuffer;
			};
		}
	}
}