﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "Annotations\AnnotNoteUserControl.g.h"
#include "..\Common\TemplateSelector.h"

using namespace foxit::rdk;

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class AnnotNoteUserControl sealed
			{
			public:
				AnnotNoteUserControl(foxit::rdk::PDFViewCtrl^ page, Windows::Foundation::Point pt);

				property foxit::rdk::PDFViewCtrl^ View
				{
					foxit::rdk::PDFViewCtrl^ get();
				}

				Windows::Foundation::Point CreateAnnotNote();
				void SaveAnnotNote();
				void CreateNewNote();
				bool IsSelectText();

			private:
				Windows::Foundation::EventRegistrationToken m_BackPressed;
				Platform::WeakReference m_ViewWeakRef;
				bool  m_isTextAnnotDelete;
				bool  m_isCreateNewNote;
				Windows::UI::Xaml::DispatcherTimer^ contentLenghtTimer;
				bool isCreatePopupContent;
				Windows::Foundation::EventRegistrationToken __inputPaneShowingEventRegistrationToken, __inputPaneHidingEventRegistrationToken;
				Windows::Foundation::Point notePt;
				Windows::UI::Xaml::Media::CompositeTransform^ m_LayoutGridTransform;
				bool isPhoneHorizontalMode;
				Windows::Foundation::EventRegistrationToken __windowSizeChangedEventRegistrationToken;
				int selectLength;

			private:
				void OnInitializeControl();
				Platform::String^ GetDateTimeStr(Windows::Foundation::DateTime datetime);
				void SetUserControlUpdate();
				void CreateInsertAnnot();

			private:
				void DeleteBtn_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void CloseBtn_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void Grid_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void CreateBtn_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void ContentTextBlock_GotFocus(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void CancelBtn_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void SaveBtn_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);

				void OnTappedTick(Platform::Object ^sender, Platform::Object ^args);
				void ContentTextBlock_LostFocus(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void ContentTB_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void OnManipulationDelta(Platform::Object ^sender, Windows::UI::Xaml::Input::ManipulationDeltaRoutedEventArgs ^e);
				void CreateBtn_PointerEntered(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				void CreateBtn_PointerExited(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				void ContentTextBlockPhoneHor_LostFocus(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void ContentTextBlockPhoneHor_GotFocus(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void OnSizeChanged(Platform::Object ^sender, Windows::UI::Core::WindowSizeChangedEventArgs ^e);
				void ContentTextBlock_SelectionChanged(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
			};
		}
	}
}
