﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "Annotations\AnnotPropertyAppBar.g.h"

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class AnnotPropertyAppBar sealed
			{
			public:
				AnnotPropertyAppBar(foxit::rdk::PDFViewCtrl^ view);

			internal:
				property foxit::rdk::PDFViewCtrl^ View
				{
					foxit::rdk::PDFViewCtrl^ get();
				}
				void HideNoteStylePopup();
				bool IsNoteStylePopupIsOpen();
				void SetPropertyToolIsEnabled(bool isEnable);
				void CloseBorderListPopup();
				void SetStampPopupClosed();
				void InitControlSize();
				void SetFreeTextPropertyShow(bool isShow);

			private:
				Platform::WeakReference m_PageViewWeakRef;
				Windows::UI::Xaml::Controls::Primitives::Popup^ stampIconPopup;
				Windows::UI::Core::CoreDispatcher^	m_MainPageDispatcher;

			private:
				void InitPropertyPanelVisible();
				void InitAppBarProperty();

			private:
				void NoteLogoSetting_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void ColorPageBtnSelect_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void OpacityPageBtnSelect_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void ExitProperty_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);

				void OnSizeChanged(Platform::Object ^sender, Windows::UI::Core::WindowSizeChangedEventArgs ^e);
				void InitAnnotColorList(foxit::rdk::uiextensions::AnnotationType type);
				foxit::rdk::uiextensions::AnnotationType GetAnnotType(foxit::rdk::uiextensions::AnnotCreateType optType);
				void SetRadioColorChecked(Platform::String^ colorRGBValue, foxit::rdk::uiextensions::AnnotationType type);
				void AppBarButton_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnValueChanged(Platform::Object ^sender, Windows::UI::Xaml::Controls::Primitives::RangeBaseValueChangedEventArgs ^e);
			};
		}
	}
}
