﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "Annotations/AnnotToolAppBar.g.h"

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			ref class MainPageAppBar;
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class AnnotToolAppBar sealed
			{
			public:
				AnnotToolAppBar();

			internal:
				property MainPageAppBar^ MainAppBar
				{
					MainPageAppBar^ get();
				}
				void SetAppBarIsCompact(bool isCompact);

				void UpdateUndoControlState();
				void SetStampPopupClosed();
				void HideNoteStylePopup();
				void ResetAppBarBG();
				void SetAllPopupClosed();
				void InitCurNoteIcon();
				void InitStampAppBarSelect();
				bool IsPopupIsOpen();
				void SetPropertyCurColor(Windows::UI::Color color);
				void StartHideLabelTick();
				void SetFreeTextPropertyShow(bool isShow);
				void SetUnRedoIsEnabled(bool isEnable);
				bool IsMobileAnnnotMoreToolOpen();

			private:
				Platform::WeakReference m_MainAppBarWeakRef;
				Windows::Foundation::EventRegistrationToken m_AfterUndoEventToken, m_AfterRedoEventToken, m_OperaListChangedUndoRedoEventToken;
				Windows::UI::Xaml::Controls::Primitives::Popup^ proprtyPopup;
				Windows::UI::Xaml::Media::SolidColorBrush^ selectcolor;
				Windows::UI::Xaml::Media::SolidColorBrush^ normalcolor;
				Windows::UI::Xaml::DispatcherTimer^ m_HideLableTimer;
				Windows::UI::Xaml::DispatcherTimer^ m_HideMobileAnnotTipTimer;
				Windows::UI::Xaml::Controls::Primitives::Popup^ stampPhonePopup;
				double offsetWidth;

			private:
				void CreateAnnot(AnnotCreateType type);
				void InitAnnotMobileToolLayout();
				void SetAnnotPropertButtonEnable(bool isEnable);
				void InitCurGraphAnnot(AnnotCreateType type);
				void AnnotToolClick(Platform::Object^ sender, AnnotCreateType type);
				void ResetPropertyBG();
				void SetProertyBtnEnabled();
				void InitCurCreateAnnotTypeColor();
				void SetAnnotToolPopupClosed();
				void InitBorderWidth();
				void ResetBorderWidthList();
				void InitMobileCurAnnotTip(AnnotCreateType type);
				void InitAnnotIsContinueOpera(AnnotCreateType type);
				void ResetSetMobileAnnotBarCompact();
				void SetUnRedoUnEnabled();
				void SetAnnotBtnClick(AnnotCreateType type, bool m_isCreate);
				void SetAnnotMobileMoreBtnSelected();
				void InitNoteIcon();
				void ResetAnnotToolBarButton(bool isChecked);

			private:
				void RadioHightLight_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void RadioUnderLine_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void RadioStrikeOut_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void RadioNote_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void RadioSquiggly_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void RadioAreaHightLight_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void exitAnnotTool_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void RadioInk_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void RadioSquare_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void RadioCircle_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void RadioLine_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);

				void OnSizeChanged(Platform::Object ^sender, Windows::UI::Xaml::SizeChangedEventArgs ^e);
				void imgMoreMain_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void WindowsDesktopCommandBar_Opening(Platform::Object^ sender, Platform::Object^ e);
				void RadioArrow_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void RadioEraser_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void OnAfterUndo(Platform::Object ^sender, Platform::Object ^args);
				void OnAfterRedo(Platform::Object ^sender, Platform::Object ^args);
				void OnOperaListChanged(Platform::Object ^sender, Platform::Object ^args);
				void RadioUndo_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void RadioRedo_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void ShowAllLabel_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void HideAllLabel_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void BorderPanel_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void appBarBorder_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void appBarProerty_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void appBarContinueOpera_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void RadioGroupDown_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void RadioNoteDown_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void RadioStampDown_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void OnHideTipTick(Platform::Object ^sender, Platform::Object ^args);
				void OnTick(Platform::Object ^sender, Platform::Object ^args);
				void RadioFreeText_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void Border1_PointerEntered(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				void Border1_PointerExited(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				void LandMobileMoreCommans_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void Grid_PointerReleased(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);

				void OnPhoneTipLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void RadioInsertText_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void RadioReplaceText_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void scrollTollbar_ManipulationDelta(Platform::Object^ sender, Windows::UI::Xaml::Input::ManipulationDeltaRoutedEventArgs^ e);
				void appbarSetting_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void RadioStampMobile_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void RadioShapeGroup_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void RadioStamp_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
			};
		}
	}
}
