﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#include "pch.h"
#include "ContextMenuUserControl.xaml.h"
#include "AnnotNoteUserControl.xaml.h"
#include "EditAnnotUnDoAction.h"
#include "AnnotPropertyAppBar.xaml.h"
#include "FreeTextEventPeer.h"

using namespace foxit::rdk;
using namespace foxit::rdk::uiextensions;
using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;


ContextMenuUserControl::ContextMenuUserControl(foxit::rdk::PDFViewCtrl^ view, AnnotContextMenuType menuType)
{
	InitializeComponent();

	m_PageViewWeakRef = view;

	this->Loaded += ref new Windows::UI::Xaml::RoutedEventHandler(this, &ContextMenuUserControl::OnLoaded);
	this->Unloaded += ref new Windows::UI::Xaml::RoutedEventHandler(this, &ContextMenuUserControl::OnUnloaded);

	SetSignCanvasHide();
	m_MenuType = menuType;
	UIExtensionsManager^ uiMgr = (UIExtensionsManager^)View->ExtensionsManager;
	if (menuType == AnnotContextMenuType::Add)
	{
		CopyText->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		EditAnnot->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		if (!FSPDFDocUtil::GetIsDocumentCanModifyAnnotation(View->GetDoc()) && View->GetDoc()->GetPasswordType() != foxit::pdf::PasswordType::e_PwdOwner
			&& FSPDFDocUtil::GetIsDocumentCanExtra(View->GetDoc()))
		{
			if (FSPDFDocUtil::GetIsDocumentCanBeCopy(View->GetDoc()))
			{
				CopyText->Visibility = Windows::UI::Xaml::Visibility::Visible;
			}
			Separator->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
			AddHightlight->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
			AddStrikeout->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
			AddUnderline->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
			AddSquiggly->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
			AddNote->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
			Separator1->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
			Separator2->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
			Separator6->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		}
		else
		{
			if (View->GetDoc()->GetPasswordType() != foxit::pdf::PasswordType::e_PwdOwner && !FSPDFDocUtil::GetIsDocumentCanBeCopy(View->GetDoc()))
			{
				Separator->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
			}
			else
			{
				CopyText->Visibility = Windows::UI::Xaml::Visibility::Visible;
				Separator->Visibility = Windows::UI::Xaml::Visibility::Visible;
			}			
			AddHightlight->Visibility = Windows::UI::Xaml::Visibility::Visible;
			AddStrikeout->Visibility = Windows::UI::Xaml::Visibility::Visible;
			AddUnderline->Visibility = Windows::UI::Xaml::Visibility::Visible;
			AddSquiggly->Visibility = Windows::UI::Xaml::Visibility::Visible;
		}
		AddNote->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		DeleteAnnot->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator3->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator4->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator5->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator7->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddAreaHighLight->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		PropertyAnnot->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
	}
	else if (menuType == AnnotContextMenuType::Delete)
	{
		CopyText->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddHightlight->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddStrikeout->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddUnderline->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		DeleteAnnot->Visibility = Windows::UI::Xaml::Visibility::Visible;
		AddNote->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator1->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator2->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator3->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator4->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator5->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		PropertyAnnot->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddSquiggly->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator6->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator7->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddAreaHighLight->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		EditAnnot->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
	}
	else if (menuType == AnnotContextMenuType::Note)
	{
		CopyText->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddHightlight->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddStrikeout->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddUnderline->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		DeleteAnnot->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddNote->Visibility = Windows::UI::Xaml::Visibility::Visible;
		Separator1->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator2->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator4->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator5->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		PropertyAnnot->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddSquiggly->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator6->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator7->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		EditAnnot->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		if (View->GetDoc() && !FSPDFDocUtil::GetIsDocumentCanModifyAnnotation(View->GetDoc()) && View->GetDoc()->GetPasswordType() != foxit::pdf::PasswordType::e_PwdOwner)
		{
			Separator3->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
			AddAreaHighLight->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		}
		else
		{
			Separator3->Visibility = Windows::UI::Xaml::Visibility::Visible;
			AddAreaHighLight->Visibility = Windows::UI::Xaml::Visibility::Visible;
		}
	}
	else if (menuType == AnnotContextMenuType::Edit)
	{
		CopyText->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddHightlight->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddStrikeout->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddUnderline->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		DeleteAnnot->Visibility = Windows::UI::Xaml::Visibility::Visible;
		AddNote->Visibility = Windows::UI::Xaml::Visibility::Visible;
		Separator1->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator2->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator3->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddSquiggly->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator6->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddNote->Text = uiMgr->GetResourceString("TextNoteStr");
		Separator7->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddAreaHighLight->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator8->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		EditAnnot->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		if (uiMgr->getAnnotMgr()->GetSelectedAnnot() && uiMgr->getAnnotMgr()->GetSelectedAnnot()->AnnotType == AnnotationType::FreeText)
		{
			Separator8->Visibility = Windows::UI::Xaml::Visibility::Visible;
			EditAnnot->Visibility = Windows::UI::Xaml::Visibility::Visible;
			AddNote->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
			Separator4->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		}
	}
	else if (menuType == AnnotContextMenuType::NotePro)
	{
		CopyText->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddHightlight->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddStrikeout->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddUnderline->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		DeleteAnnot->Visibility = Windows::UI::Xaml::Visibility::Visible;
		AddNote->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator1->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator2->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator3->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator4->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddSquiggly->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator6->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddNote->Text = uiMgr->GetResourceString("TextNoteStr");
		Separator7->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddAreaHighLight->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		PropertyAnnot->Visibility = Windows::UI::Xaml::Visibility::Visible;
		Separator5->Visibility = Windows::UI::Xaml::Visibility::Visible;
		EditAnnot->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
	}
	else if (menuType == AnnotContextMenuType::NewSign)
	{
		CopyText->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddHightlight->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddStrikeout->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddUnderline->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		DeleteAnnot->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddNote->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator1->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator2->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator3->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator4->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddSquiggly->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator6->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator7->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddAreaHighLight->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		PropertyAnnot->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator5->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		EditAnnot->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator12->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		DeleteSign->Visibility = Windows::UI::Xaml::Visibility::Collapsed;

		Separator9->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator10->Visibility = Windows::UI::Xaml::Visibility::Visible;
		Separator11->Visibility = Windows::UI::Xaml::Visibility::Visible;
		NewSignature->Visibility = Windows::UI::Xaml::Visibility::Visible;
		Signature->Visibility = Windows::UI::Xaml::Visibility::Visible;
		CancelSign->Visibility = Windows::UI::Xaml::Visibility::Visible;
	}
	else if (menuType == AnnotContextMenuType::ApplySign)
	{
		CopyText->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddHightlight->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddStrikeout->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddUnderline->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		DeleteAnnot->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddNote->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator1->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator2->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator3->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator4->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddSquiggly->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator6->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator7->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		AddAreaHighLight->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		PropertyAnnot->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator5->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		EditAnnot->Visibility = Windows::UI::Xaml::Visibility::Collapsed;		

		Separator9->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator10->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Separator11->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		NewSignature->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
		Signature->Visibility = Windows::UI::Xaml::Visibility::Visible;
		CancelSign->Visibility = Windows::UI::Xaml::Visibility::Collapsed;

		Separator12->Visibility = Windows::UI::Xaml::Visibility::Visible;
		DeleteSign->Visibility = Windows::UI::Xaml::Visibility::Visible;
	}
}

void ContextMenuUserControl::SetSignCanvasHide()
{
	Separator9->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
	Separator10->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
	Separator11->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
	NewSignature->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
	Signature->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
	CancelSign->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
	Separator12->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
	DeleteSign->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
}

foxit::rdk::PDFViewCtrl^ ContextMenuUserControl::View::get()
{
	return m_PageViewWeakRef.Resolve<foxit::rdk::PDFViewCtrl>();
}


AnnotContextMenuType ContextMenuUserControl::MenuType::get()
{
	return m_MenuType;
}

void ContextMenuUserControl::AddHightlight_PointerPressed(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e)
{
	UIExtensionsManager^ uiMgr = (UIExtensionsManager^)View->ExtensionsManager;
	if (!View)
		return;

	if (!uiMgr->IsShowAnnot)
	{
		uiMgr->IsShowAnnot = true;
		View->Redraw();
	}

	uiMgr->IsRightMenuAdd = true;
	CreateTextAnnot(AnnotCreateType::HightLight);
}


void ContextMenuUserControl::AddStrikeout_PointerPressed(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e)
{
	if (!View)
		return;
	UIExtensionsManager^ uiMgr = (UIExtensionsManager^)View->ExtensionsManager;
	if (!uiMgr->IsShowAnnot)
	{
		uiMgr->IsShowAnnot = true;
		View->Redraw();
	}


	uiMgr->IsRightMenuAdd = true;
	CreateTextAnnot(AnnotCreateType::StrikeOut);
}


void ContextMenuUserControl::AddUnderline_PointerPressed(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e)
{
	if (!View)
		return;
	UIExtensionsManager^ uiMgr = (UIExtensionsManager^)View->ExtensionsManager;
	if (!uiMgr->IsShowAnnot)
	{
		uiMgr->IsShowAnnot = true;
		View->Redraw();
	}

	uiMgr->IsRightMenuAdd = true;
	CreateTextAnnot(AnnotCreateType::UnderLine);
}

void ContextMenuUserControl::CreateTextAnnot(AnnotCreateType createType)
{
	UIExtensionsManager^ uiMgr = (UIExtensionsManager^)View->ExtensionsManager;
	uiMgr->SetTextMenuPopupHide();
	uiMgr->CreateTypeOfAnnot = createType;
	auto _pAnnotHandler = uiMgr->getAnnotMgr()->GetAnnotHandlerByType(GetAnnotType(uiMgr->CreateTypeOfAnnot));
	if (_pAnnotHandler)
		_pAnnotHandler->CreateAnnotAfterSelectText();
}

AnnotationType ContextMenuUserControl::GetAnnotType(AnnotCreateType optType)
{
	AnnotationType _annotType;
	switch (optType)
	{
	case AnnotCreateType::None:
		_annotType = AnnotationType::None;
		break;
	case AnnotCreateType::HightLight:
		_annotType = AnnotationType::HightLight;
		break;
	case AnnotCreateType::Comment:
		_annotType = AnnotationType::HightLight;
		break;
	case AnnotCreateType::UnderLine:
		_annotType = AnnotationType::UnderLine;
		break;
	case AnnotCreateType::StrikeOut:
		_annotType = AnnotationType::StrikeOut;
		break;
	case AnnotCreateType::Square:
		_annotType = AnnotationType::Square;
		break;
	case AnnotCreateType::Circle:
		_annotType = AnnotationType::Circle;
		break;
	case AnnotCreateType::Line:
		_annotType = AnnotationType::Line;
		break;
	case AnnotCreateType::Pencil:
		_annotType = AnnotationType::Ink;
		break;
	case AnnotCreateType::Squiggly:
		_annotType = AnnotationType::Squiggly;
		break;
	case AnnotCreateType::Text:
		_annotType = AnnotationType::Text;
		break;
	default:
		_annotType = AnnotationType::None;
		break;
	}
	return _annotType;
}


void ContextMenuUserControl::DeleteAnnot_PointerPressed(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e)
{
	UIExtensionsManager^ uiMgr = (UIExtensionsManager^)View->ExtensionsManager;
	if (View && uiMgr->getAnnotMgr())
	{
		IBaseAnnot^ annot = uiMgr->getAnnotMgr()->GetSelectedAnnot();
		if (annot)
		{
			int pageindex = annot->PageIndex;
			

			foxit::common::fxcrt::RectF^ minRect = FoxitRectConverter::ConvertToFoxitRectF(annot->MinRect);
			String^ rectStr = "[" + minRect->left.ToString() + " " + minRect->top.ToString() + " " + minRect->right.ToString() + " " + minRect->bottom.ToString() + "]";

			Platform::String^ annotTypeStr = uiMgr->GetAnnotTypeString(annot->AnnotType);
			uiMgr->CollectAnnotOperation(annotTypeStr, "Delete", annot->PageIndex.ToString(), rectStr);		

			bool isReplaceText = false;
			if (annot->AnnotType == AnnotationType::Caret)
			{
				CaretAnnot^ caretannot = dynamic_cast<CaretAnnot^>(annot);
				if (caretannot->IsHasGroup)
				{
					Windows::Foundation::Rect groupminRect = caretannot->GroupAnnotMinRect;
					bool isGetGroupAnnot = uiMgr->getAnnotMgr()->IsGetGroupAnnotElement(annot->PageIndex, groupminRect, caretannot->GroupAnnotIndex, AnnotationType::StrikeOut);
					if (isGetGroupAnnot)
					{
						isReplaceText = true;
						IBaseAnnot^ groupAnnot = uiMgr->getAnnotMgr()->GetGroupAnnot();

						auto pUndoItem = ref new DeleteReplaceAnnotUndoAction(View, annot,groupAnnot);
						UndoFactory::GetUndoInstance()->AddUndoItem(uiMgr, pUndoItem);

						if (groupAnnot)
							groupAnnot->OnDelete();
					}
				}
			}
			else if (annot->AnnotType == AnnotationType::StrikeOut)
			{
				StrikeOutAnnot^ strikeoutannot = dynamic_cast<StrikeOutAnnot^>(annot);
				if (strikeoutannot->IsHasGroup)
				{
					Windows::Foundation::Rect groupminRect = strikeoutannot->GroupAnnotMinRect;
					bool isGetGroupAnnot = uiMgr->getAnnotMgr()->IsGetGroupAnnotElement(annot->PageIndex, groupminRect, strikeoutannot->GroupAnnotIndex, AnnotationType::Caret);
					if (isGetGroupAnnot)
					{
						isReplaceText = true;
						IBaseAnnot^ groupAnnot = uiMgr->getAnnotMgr()->GetGroupAnnot();

						auto pUndoItem = ref new DeleteReplaceAnnotUndoAction(View, groupAnnot, annot);
						UndoFactory::GetUndoInstance()->AddUndoItem(uiMgr, pUndoItem);

						if (groupAnnot)
							groupAnnot->OnDelete();
					}
				}
			}

			uiMgr->getAnnotMgr()->InsertModifyAnnotBeforeDelete();

			if (!isReplaceText)
			{
				auto pUndoItem = ref new DeleteAnnotUndoAction(View, annot);
				UndoFactory::GetUndoInstance()->AddUndoItem(uiMgr, pUndoItem);
			}

			annot->OnDelete();
			uiMgr->SetTextMenuPopupHide();
			uiMgr->CloseAddNoteWindows();
			uiMgr->SetAnnotCanvasVisible(false);
		}
	}
}


void ContextMenuUserControl::AddNote_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e)
{
	Windows::Foundation::Point curPt = e->GetPosition(nullptr);
	UIExtensionsManager^ uiMgr = (UIExtensionsManager^)View->ExtensionsManager;
	if (uiMgr->getAnnotMgr()->GetSelectedAnnot())
	{
		auto _pSelectedAnnot = uiMgr->getAnnotMgr()->GetSelectedAnnot();
		if (_pSelectedAnnot->AnnotType == AnnotationType::HightLight || _pSelectedAnnot->AnnotType == AnnotationType::StrikeOut
			|| _pSelectedAnnot->AnnotType == AnnotationType::UnderLine || _pSelectedAnnot->AnnotType == AnnotationType::Squiggly
			|| _pSelectedAnnot->AnnotType == AnnotationType::Ink || _pSelectedAnnot->AnnotType == AnnotationType::Square || _pSelectedAnnot->AnnotType == AnnotationType::Circle
			|| _pSelectedAnnot->AnnotType == AnnotationType::Line || _pSelectedAnnot->AnnotType == AnnotationType::Caret)
		{
			Windows::Foundation::Rect rect = _pSelectedAnnot->MinRect;
			auto wrapperDevice = View->ConvertPageRectToDeviceRect(_pSelectedAnnot->PageIndex, rect);
			Windows::Foundation::Rect deviceRect = wrapperDevice;

			Windows::Foundation::Point _Pt(deviceRect.X, deviceRect.Y + deviceRect.Height / 2);
			auto control = ref new AnnotNoteUserControl(View, curPt);

			uiMgr->ShowAddNoteWindows(control, curPt);
			uiMgr->SetTextMenuPopupHide();
		}
	}
	else
	{
		if (!uiMgr->IsShowAnnot)
		{
			uiMgr->IsShowAnnot = true;
			View->Redraw();
		}

		
		uiMgr->IsRightMenuAdd = true;
		CreateNoteAnnot(curPt);
	}
}

void ContextMenuUserControl::CreateNoteAnnot(Windows::Foundation::Point curPt)
{
	UIExtensionsManager^ uiMgr = (UIExtensionsManager^)View->ExtensionsManager;
	auto _selectedtext = uiMgr->getTextMgr()->SelectedText;
	Windows::Foundation::Point devicept;
	int pageIndex = 0;
	Windows::Foundation::Point pagePt;;
	if (_selectedtext && _selectedtext->Size > 0 && _selectedtext->GetAt(0)->TextRectVect->Size > 0)
	{
		Windows::Foundation::Rect rect = _selectedtext->GetAt(0)->TextRectVect->GetAt(0);
		auto deviceRect = View->ConvertPageRectToDeviceRect(_selectedtext->GetAt(0)->PageIndex, rect);

		devicept = Point(deviceRect.X, deviceRect.Y);
		pageIndex = _selectedtext->GetAt(0)->PageIndex;
		pagePt = Point(rect.X, rect.Y);
	}
	else
	{
		auto _Pageinfo = uiMgr->GetHoldingPoint();

		pagePt = Point(_Pageinfo->PagePoint.X, _Pageinfo->PagePoint.Y);
		devicept = View->ConvertPagePtToDevicePt(_Pageinfo->PageIndex, pagePt);
		pageIndex = _Pageinfo->PageIndex;
	}

	uiMgr->CreateTypeOfAnnot = AnnotCreateType::Text;
	uiMgr->SetTextMenuPopupHide();

	auto _AnnotSetting = uiMgr->getAnnotMgr()->GetAnnotSetting();


	auto _Annot = foxit::rdk::uiextensions::AnnotCreaterFactory::GetInstance()->CreateNewAnnot(AnnotationType::Text);
	auto _pCreateAnnot = dynamic_cast<TextAnnot^>(_Annot);
	_pCreateAnnot->Color = Windows::UI::Colors::Yellow;
	_pCreateAnnot->Opacity = 1;
	_pCreateAnnot->Name = uiMgr->getAnnotMgr()->GetAnnotSetting()->GetNoteAuthor();
	_pCreateAnnot->Title = uiMgr->getAnnotMgr()->GetAnnotSetting()->GetNoteAuthor();
	_pCreateAnnot->PosPoint = pagePt;

	auto _msgDlg = ref new MessageDlg();
	auto _AnnotNoteUserControl = ref new AnnotNoteUserControl(View, curPt);
	auto _AnnotComandToken = ref new AnnotCommandToken();
	_AnnotComandToken->Pageindex = pageIndex;
	_AnnotComandToken->Param = _pCreateAnnot;
	_AnnotComandToken->Type = AnnotCommandType::Add;
	_AnnotNoteUserControl->Tag = _AnnotComandToken;

	uiMgr->ShowAddNoteWindows(_AnnotNoteUserControl, curPt);
}

foxit::rdk::uiextensions::AnnotIconNameTextType ContextMenuUserControl::GetCurIconType()
{
	UIExtensionsManager^ uiMgr = (UIExtensionsManager^)View->ExtensionsManager;
	auto _AnnotSetting = uiMgr->getAnnotMgr()->GetAnnotSetting();
	Platform::String^ iconname = uiMgr->getAnnotMgr()->GetAnnotSetting()->GetNoteLogoUrl();
	AnnotIconNameTextType icontype = AnnotIconNameTextType::Comment;
	if (iconname == "Checkmark")
	{
		icontype = AnnotIconNameTextType::Checkmark;
	}
	else if (iconname == "Circle")
	{
		icontype = AnnotIconNameTextType::Circle;
	}
	else if (iconname == "Comment")
	{
		icontype = AnnotIconNameTextType::Comment;
	}
	else if (iconname == "Cross")
	{
		icontype = AnnotIconNameTextType::Cross;
	}
	else if (iconname == "Help")
	{
		icontype = AnnotIconNameTextType::Help;
	}
	else if (iconname == "Insert")
	{
		icontype = AnnotIconNameTextType::Insert;
	}
	else if (iconname == "Key")
	{
		icontype = AnnotIconNameTextType::Key;
	}
	else if (iconname == "NewParagraph")
	{
		icontype = AnnotIconNameTextType::NewParagraph;
	}
	else if (iconname == "Note")
	{
		icontype = AnnotIconNameTextType::Note;
	}
	else if (iconname == "Paragraph")
	{
		icontype = AnnotIconNameTextType::Paragraph;
	}
	else if (iconname == "RightArrow")
	{
		icontype = AnnotIconNameTextType::RightArrow;
	}
	else if (iconname == "RightPointer")
	{
		icontype = AnnotIconNameTextType::RightPointer;
	}
	else if (iconname == "Star")
	{
		icontype = AnnotIconNameTextType::Star;
	}
	else if (iconname == "UpArrow")
	{
		icontype = AnnotIconNameTextType::UpArrow;
	}
	else if (iconname == "UpLeftArrow")
	{
		icontype = AnnotIconNameTextType::UpleftArrow;
	}
	return icontype;
}


void ContextMenuUserControl::OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e)
{
	
}


void ContextMenuUserControl::OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e)
{
	
}


void ContextMenuUserControl::CopyText_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e)
{
	UIExtensionsManager^ uiMgr = (UIExtensionsManager^)View->ExtensionsManager;
	if (View && uiMgr->getTextMgr())
	{
		auto selString = uiMgr->getTextMgr()->SelectedTextString;
		if (selString->Length() > 0)
		{
			Windows::ApplicationModel::DataTransfer::DataPackage^ _DataPackage = ref new Windows::ApplicationModel::DataTransfer::DataPackage();
			_DataPackage->SetText(selString);
			Windows::ApplicationModel::DataTransfer::Clipboard::SetContent(_DataPackage);
		}
	}
	uiMgr->SetTextMenuPopupHide();
}


void ContextMenuUserControl::PropertyAnnot_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e)
{
	UIExtensionsManager^ uiMgr = (UIExtensionsManager^)View->ExtensionsManager;
	uiMgr->LoadAnnotAppBar(AppBarType::AnnotPropertyBar);
	uiMgr->SetTextMenuPopupHide();
}

void ContextMenuUserControl::SetDownLogLocation(double xValue)
{
	auto _actwidth = ActualWidth / 2 + 8;
	if (xValue > _actwidth)
		xValue = _actwidth;
	else if (xValue < -_actwidth)
		xValue = -_actwidth;

	imgDownTransform->X = xValue;
}


void ContextMenuUserControl::AddSquiggly_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e)
{
	UIExtensionsManager^ uiMgr = (UIExtensionsManager^)View->ExtensionsManager;
	if (!View)
		return;
	if (!uiMgr->IsShowAnnot)
	{
		uiMgr->IsShowAnnot = true;
		View->Redraw();
	}
	uiMgr->IsRightMenuAdd = true;
	CreateTextAnnot(AnnotCreateType::Squiggly);
}


void ContextMenuUserControl::AddAreaHighLight_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e)
{
	UIExtensionsManager^ uiMgr = (UIExtensionsManager^)View->ExtensionsManager;
	if (!uiMgr->IsShowAnnot)
	{
		uiMgr->IsShowAnnot = true;
		View->Redraw();
	}
	uiMgr->SetTextMenuPopupHide();

	uiMgr->IsRightMenuAdd = true;
	uiMgr->AddAnnotByType(AnnotCreateType::AreaHighLight);
	uiMgr->LoadAnnotAppBar(AppBarType::AnnotPropertyBar);
}



void foxit::rdk::uiextensions::ContextMenuUserControl::Edit_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e)
{
	UIExtensionsManager^ uiMgr = (UIExtensionsManager^)View->ExtensionsManager;
	auto _SelectedAnnot = uiMgr->getAnnotMgr()->GetSelectedAnnot();
	if (_SelectedAnnot && _SelectedAnnot->AnnotType==AnnotationType::FreeText)
	{
		uiMgr->SetTextMenuPopupHide();
		uiMgr->SetAnnotCanvasVisible(false);

		IBaseAnnotEventPeer^ annotEventPeer = uiMgr->getAnnotMgr()->GetAnnotHandlerByType(AnnotationType::FreeText)->AnnotEvent;
		FreeTextEventPeer^ freetextEventPeer = dynamic_cast<FreeTextEventPeer^>(annotEventPeer);
		freetextEventPeer->OnEditFreeText();
	}
}

void foxit::rdk::uiextensions::ContextMenuUserControl::NewSign_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e)
{
	UIExtensionsManager^ uiMgr = (UIExtensionsManager^)View->ExtensionsManager;
	uiMgr->ShowDrawSignatureControl();
}

void foxit::rdk::uiextensions::ContextMenuUserControl::Sign_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e)
{
	UIExtensionsManager^ uiMgr = (UIExtensionsManager^)View->ExtensionsManager;
	auto _winrect = Windows::UI::Xaml::Window::Current->Bounds;
	Windows::Foundation::Point pt = uiMgr->GetSignPoint();
	auto _PagePtInfo = View->ConvertDevicePtToPDFPagePt(pt);
	int pageIndex = _PagePtInfo->PageIndex;
	auto page = View->GetDoc()->GetPage(pageIndex);

	Windows::Foundation::Rect locationRect = Windows::Foundation::Rect(pt.X-50, pt.Y - 50, 100, 100);
	auto pageRc = View->ConvertDeviceRectToPageRect(pageIndex, locationRect);
	foxit::common::fxcrt::RectF^ rect = FoxitRectConverter::ConvertToFoxitRectF(pageRc);

	Windows::Storage::StorageFolder^ localFolder = Windows::ApplicationModel::Package::Current->InstalledLocation;
	concurrency::create_task(Windows::Storage::ApplicationData::Current->LocalFolder->GetFolderAsync("SignatureImg"))
		.then([=](Windows::Storage::StorageFolder^ folder)
	{
		return folder->GetFileAsync("SignatureDefault.png");
	})
		.then([=](Windows::Storage::StorageFile^ pickedFile)
	{

	});
}

void foxit::rdk::uiextensions::ContextMenuUserControl::CancelSign_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e)
{
	UIExtensionsManager^ uiMgr = (UIExtensionsManager^)View->ExtensionsManager;
	uiMgr->HideDrawSignatureControl();
	uiMgr->HideSignatureCanvas();
}

void foxit::rdk::uiextensions::ContextMenuUserControl::Delete_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e)
{
	UIExtensionsManager^ uiMgr = (UIExtensionsManager^)View->ExtensionsManager;
	uiMgr->HideDrawSignatureControl();
	uiMgr->HideSignatureCanvas();
}
