﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "Annotations\ContextMenuUserControl.g.h"
using namespace foxit::rdk;

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			ref class AnnotPropertyAppBar;
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class ContextMenuUserControl sealed
			{
			public:
				ContextMenuUserControl(foxit::rdk::PDFViewCtrl^ view, AnnotContextMenuType menuType);

				property foxit::rdk::PDFViewCtrl^ View
				{
					foxit::rdk::PDFViewCtrl^ get();
				}

				property AnnotContextMenuType MenuType
				{
					AnnotContextMenuType get();
				}

				void SetDownLogLocation(double xValue);

			private:
				void AddHightlight_PointerPressed(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				void AddStrikeout_PointerPressed(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				void AddUnderline_PointerPressed(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				void DeleteAnnot_PointerPressed(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				void AddNote_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void AddSquiggly_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void AddAreaHighLight_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void CopyText_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void PropertyAnnot_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void Edit_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void NewSign_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void Sign_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void CancelSign_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void Delete_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);

			private:
				foxit::rdk::uiextensions::AnnotIconNameTextType ContextMenuUserControl::GetCurIconType();
				void CreateTextAnnot(AnnotCreateType createType);
				void CreateNoteAnnot(Windows::Foundation::Point curPt);
				foxit::rdk::uiextensions::AnnotationType GetAnnotType(AnnotCreateType optType);
				void SetSignCanvasHide();

			private:
				Platform::WeakReference m_PageViewWeakRef;
				AnnotContextMenuType  m_MenuType;
				double hOffsetValue;
				Windows::UI::Xaml::Controls::Primitives::Popup^ propertyPopup;
				Windows::Foundation::EventRegistrationToken			m_propertyPopupLoadedEventToken;
				AnnotPropertyAppBar^ control;
			};
		}
	}
}
