﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#include "pch.h"
#include "FreeTextBoxUC.xaml.h"

using namespace foxit::rdk;
using namespace foxit::rdk::uiextensions;

using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;

// The User Control item template is documented at http://go.microsoft.com/fwlink/?LinkId=234236

FreeTextBoxUC::FreeTextBoxUC()
{
	InitializeComponent();

	m_transformScaleX = 1;
	m_transformScaleY = 1;

	m_pageRenderScale = 1;

	this->KeyDown += ref new Windows::UI::Xaml::Input::KeyEventHandler(this, &foxit::rdk::uiextensions::FreeTextBoxUC::OnKeyDown);
}

void FreeTextBoxUC::SetTransforms(double X, double Y)
{
	m_transformScaleX = X;
	m_transformScaleY = Y;
	auto transform = ref new Windows::UI::Xaml::Media::ScaleTransform();
	transform->ScaleX = X;
	transform->ScaleY = Y;
	freeTextBox->RenderTransform = transform;
}

Windows::Foundation::Rect FreeTextBoxUC::GetAreaRect()
{
	UpdateLayout();
	Windows::Foundation::Rect rect;
	rect.X = (float)safe_cast<Platform::IBox<double>^>(GetValue(Canvas::LeftProperty))->Value;
	rect.Y = (float)safe_cast<Platform::IBox<double>^>(GetValue(Canvas::TopProperty))->Value;
	rect.Width = (float)(textBox->ActualWidth*m_transformScaleX);
	rect.Height = (float)(textBox->ActualHeight*m_transformScaleY);
	return rect;
}


void foxit::rdk::uiextensions::FreeTextBoxUC::freeTextBox_SelectionChanged(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e)
{
	selectionLength = freeTextBox->SelectionLength;	
}


void foxit::rdk::uiextensions::FreeTextBoxUC::freeTextBox_LostFocus(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e)
{
	selectionLength = 0;
}

bool foxit::rdk::uiextensions::FreeTextBoxUC::GetIsTextBoxSelection()
{
	if (selectionLength > 0)
		return true;
	else
		return false;
}

void foxit::rdk::uiextensions::FreeTextBoxUC::freeTextBox_TextChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::TextChangedEventArgs^ e)
{
	
}

void foxit::rdk::uiextensions::FreeTextBoxUC::SetFreeTextBoxMaxHeight(double maxHeight, double pageRenderScale)
{
	maxHeightValue = maxHeight;
	m_pageRenderScale = pageRenderScale;
}


void foxit::rdk::uiextensions::FreeTextBoxUC::OnKeyDown(Platform::Object ^sender, Windows::UI::Xaml::Input::KeyRoutedEventArgs ^e)
{
	contentstr = freeTextBox->Text + "/r/n";
}
