﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "Annotations\FreeTextBoxUC.g.h"

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class FreeTextBoxUC sealed
			{
			public:
				FreeTextBoxUC();

				property Windows::UI::Xaml::Controls::TextBox ^textBox
				{
					Windows::UI::Xaml::Controls::TextBox^ get() { return freeTextBox; };
				}

			public:
				void SetTransforms(double X, double Y);
				Windows::Foundation::Rect GetAreaRect();
				bool GetIsTextBoxSelection();
				void SetFreeTextBoxMaxHeight(double maxHeight, double pageRenderScale);

			private:
				void freeTextBox_SelectionChanged(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);

			private:
				int selectionLength;
				double m_transformScaleX, m_transformScaleY;
				Platform::String^ contentstr;

				void freeTextBox_LostFocus(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void freeTextBox_TextChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::TextChangedEventArgs^ e);
				double maxHeightValue;
				double m_pageRenderScale;
				void OnKeyDown(Platform::Object ^sender, Windows::UI::Xaml::Input::KeyRoutedEventArgs ^e);
			};
		}
	}
}
