/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once


namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			ref class FreeTextBoxUC;
			ref class FreeTextEventPeer : foxit::rdk::uiextensions::IBaseAnnotEventPeer
			{
			internal:
				FreeTextEventPeer(PDFViewCtrl^ view);

				property PDFViewCtrl^ View
				{
					PDFViewCtrl^ get();
				}

			private:
				Platform::WeakReference m_PageViewWeakRef;
				Windows::Foundation::Point  m_pressPoint;
				Windows::Foundation::Rect   m_AreaRect;
				int  m_PageIndex;
				int m_EndIndex;
				bool m_isPressed;
				double borderWidth;

				Windows::Foundation::Point pt;
				FreeTextBoxUC^ freeTextBox;
				Windows::Foundation::EventRegistrationToken __inputPaneShowingEventRegistrationToken;
				Windows::Foundation::EventRegistrationToken __inputPaneHideEventRegistrationToken;
				double m_needMoveOffset;
				bool m_IsInputPanelShow;
				double topvalue, leftavalue;

			public:
				virtual void OnPointerPressed(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				virtual void OnPointerMoved(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				virtual void OnPointerReleased(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				virtual void OnTapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				virtual void OnRightTapped(Platform::Object^ sender, Windows::UI::Xaml::Input::RightTappedRoutedEventArgs^ e);
				virtual void OnManipulationStarted(Platform::Object^ sender, Windows::UI::Xaml::Input::ManipulationStartedRoutedEventArgs^ e);
				virtual void OnManipulationDelta(Platform::Object^ sender, Windows::UI::Xaml::Input::ManipulationDeltaRoutedEventArgs^ e);
				virtual void OnManipulationCompleted(Platform::Object^ sender, Windows::UI::Xaml::Input::ManipulationCompletedRoutedEventArgs^ e);
				virtual void OnManipulationInertiaStarting(Platform::Object^ sender, Windows::UI::Xaml::Input::ManipulationInertiaStartingRoutedEventArgs^ e);

				virtual void OnCreateAnnotAfterSelectText();

			public:
				void OnEditFreeText();
				void OnUpdateFreeTextContent();
				bool IsFreeTextSelect();
				void UpdateEditLayout();
				void UpdatFreeTextBoxProperty();
				void SetFreeTextBoxGetFocus();
				void ReCacluateByChangeFontSize();
				bool IsTextBoxHasContent();

			private:
				void RegisterInputPanelEvent();
				double GetRenderScale();
				Windows::Foundation::Rect CalculateRectSize();
				TypeWriterRange^ GetContentStr(Windows::Foundation::Rect actualRect);
			};
		}
	}
}
