﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "Annotations\FreeTextProperty.g.h"

using namespace	foxit::rdk;

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::UI::Xaml::Data::Bindable]
			public ref class FontNameItem sealed : public BindableBase
			{
			public:
				FontNameItem();

				property Platform::String^ FontNameValue
				{
					Platform::String^ get();
					void set(Platform::String^ value);
				}

			private:
				Platform::String^ _FontName;
			};


			[Windows::UI::Xaml::Data::Bindable]
			public ref class FontSizeItem sealed : public BindableBase
			{
			public:
				FontSizeItem();

				property int FontSizeValue
				{
					int get();
					void set(int value);
				}

			private:
				int _FontSize;
			};



			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class FreeTextProperty sealed
			{
			public:
				FreeTextProperty();
				void RelateToView(PDFViewCtrl^ View, double widthValue, double heightValue);
				void HideFontList();

				bool IsFontPanelIsVisible();
				bool IsFontNameListIsVisible();
				bool IsFontSizeListIsVisible();
				void SetFontPanelVisible();
				void SetFontNameListVisible();
				void SetFontSizeListVisible();
				void ResetFontValue();
				void ResetFontNameSizeListWidth();
				bool IsHideFontNameList();

			internal:
				property PDFViewCtrl^ View
				{
					PDFViewCtrl^ get();
				}

			private:
				void InitData();

			private:
				Platform::WeakReference m_PageViewWeakRef;
				Windows::Foundation::Collections::IVector<FontNameItem^>^ m_FontVect;
				Windows::Foundation::Collections::IVector<FontSizeItem^>^ m_FontSizeVect;
				Windows::Foundation::EventRegistrationToken __windowSizeChangedEventRegistrationToken;

			private:
				void ColorPageBtnSelect_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void tbFontName_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void fontNameList_ItemClick(Platform::Object^ sender, Windows::UI::Xaml::Controls::ItemClickEventArgs^ e);
				void imgBack_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void tbFontSize_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void fontSizeList_ItemClick(Platform::Object^ sender, Windows::UI::Xaml::Controls::ItemClickEventArgs^ e);
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnSizeChanged(Platform::Object ^sender, Windows::UI::Core::WindowSizeChangedEventArgs ^e);
			};
		}
	}
}
