/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			enum class AnnotCreateType;
			ref class EraserAnnotEventPeer;
			ref class ModifyAnnotUndoAction;
			ref class ModifyReplaceAnnotUndoAction;
			ref class PageViewAnnotMgrPeer : foxit::rdk::uiextensions::IAnnotManagerPeer
			{
			internal:
				PageViewAnnotMgrPeer(UIExtensionsManager^ pUIViewMgr);

				property foxit::rdk::PDFViewCtrl^ View
				{
					foxit::rdk::PDFViewCtrl^ get();
				}

				property UIExtensionsManager^ UIExtMgr
				{
					UIExtensionsManager^ get();
				}

			private:
				Platform::WeakReference m_UIViewWeakRef;
				Platform::WeakReference m_PageViewWeakRef;
				bool isShortTextAnnot;
				AnnotCreateType m_createTypeOfAnnot;
				EraserAnnotEventPeer^ eraserEventPeer;
				ModifyAnnotUndoAction^  modifyannotAction;
				ModifyReplaceAnnotUndoAction^ modifyReplaceAnnotAction;
				Windows::Foundation::EventRegistrationToken m_renderToken;
				Windows::Foundation::EventRegistrationToken m_pageLoadedToken;
				Windows::Foundation::EventRegistrationToken m_pageUnloadedToken;

			private:
				~PageViewAnnotMgrPeer();
				foxit::rdk::uiextensions::AnnotationType GetAnnotType(AnnotCreateType optType);
				void OnTapEvent(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);

			public:
				virtual int GetPageCount();
				virtual Platform::Object^ GetPdfPageObject(int pageIndex);
				virtual void NotifyDocumentChanged();
				virtual void UpdatePageView(int pageindex);
				virtual void SaveAnonotModifyBeforeProperty();
				virtual void InsertAnnotModifyUndo();

				virtual void OnAnnotPointerEntered(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				virtual void OnAnnotPointerExited(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				virtual void OnAnnotPointerMoved(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				virtual void OnAnnotPointerPressed(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				virtual void OnAnnotPointerReleased(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				virtual void OnAnnotTapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				virtual void OnAnnotRightTapped(Platform::Object^ sender, Windows::UI::Xaml::Input::RightTappedRoutedEventArgs^ e);
				virtual void OnAnnotManipulationStarted(Platform::Object^ sender, Windows::UI::Xaml::Input::ManipulationStartedRoutedEventArgs^ e);
				virtual void OnAnnotManipulationDelta(Platform::Object^ sender, Windows::UI::Xaml::Input::ManipulationDeltaRoutedEventArgs^ e);
				virtual void OnAnnotManipulationCompleted(Platform::Object^ sender, Windows::UI::Xaml::Input::ManipulationCompletedRoutedEventArgs^ e);
				virtual void OnManipulationInertiaStarting(Platform::Object^ sender, Windows::UI::Xaml::Input::ManipulationInertiaStartingRoutedEventArgs^ e);
				void OnRenderEvent(foxit::rdk::PDFViewCtrl ^sender, RenderCanvasEventArgs^ e);
				void OnPageLoaded(PDFViewCtrl^ sender, PageLoadedEventArgs^ e);
				void OnPageUnloaded(PDFViewCtrl^ sender, PageUnloadedEventArgs^ e);
			};
		}
	}
}
