/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#include "pch.h"
#include "BookMarkData.h"
#include "BookMarkHandle.h"

using namespace foxit::rdk::uiextensions;

BookMarkItemData::BookMarkItemData(Platform::String^ text, Windows::UI::Xaml::Visibility isHasNextList)
{
	_ItemText = text;
	_IsHasNextList = isHasNextList;
}

BookMarkItemData::BookMarkItemData(BookmarkItem^ handle)
{
	bookmarkItemHandle = handle;
	Series = bookmarkItemHandle->Series;
	Page = bookmarkItemHandle->PageIndex;
	ItemText = bookmarkItemHandle->Title;
	IsHasNextList = bookmarkItemHandle->IsHasNextList;
}

Platform::String^ BookMarkItemData::ItemText::get()
{
	return _ItemText;
}

void BookMarkItemData::ItemText::set(Platform::String^ value)
{
	if (_ItemText != value)
	{
		_ItemText = value;
		OnPropertyChanged("ItemText");
	}
}


Windows::UI::Xaml::Visibility BookMarkItemData::IsHasNextList::get()
{
	return _IsHasNextList;
}

void BookMarkItemData::IsHasNextList::set(Windows::UI::Xaml::Visibility value)
{
	if (_IsHasNextList != value)
	{
		_IsHasNextList = value;
		OnPropertyChanged("IsHasNextList");
	}
}

void BookMarkItemData::pageWidth::set(double value)
{
	if (_pageWidth != value)
	{
		_pageWidth = value;
		OnPropertyChanged("pageWidth");
	}
}

double BookMarkItemData::pageWidth::get()
{
	return _pageWidth;
}
