/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "Common\BindableBase.h"

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			ref class BookmarkItem;
		}
	}
}

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			[Windows::UI::Xaml::Data::Bindable]
			public ref class BookMarkItemData sealed : public BindableBase
			{
			public:
				BookMarkItemData(Platform::String^ text, Windows::UI::Xaml::Visibility isHasNextList);
				BookMarkItemData(BookmarkItem^ handle);

			internal:
				BookmarkItem^ bookmarkItemHandle;

			public:
				property int Series;
				property int Page;
				property Platform::String^ Index;
				property Platform::String^ ItemText
				{
					Platform::String^ get();
					void set(Platform::String^ value);
				}

				property Windows::UI::Xaml::Visibility IsHasNextList
				{
					Windows::UI::Xaml::Visibility get();
					void set(Windows::UI::Xaml::Visibility value);
				}

				property double pageWidth
				{
					double get();
					void set(double value);
				}

			private:
				Platform::String^ _ItemText;
				Windows::UI::Xaml::Visibility _IsHasNextList;
				double _pageWidth;
			};

			[Windows::Foundation::Metadata::WebHostHidden]
			[Windows::UI::Xaml::Data::Bindable]
			public ref class BookMarkData sealed : BindableBase
			{
			public:
				BookMarkData()
				{
					_Items = ref new Platform::Collections::Vector<Platform::Object^>();
				}

				virtual ~BookMarkData() {}

				property Windows::Foundation::Collections::IObservableVector<Platform::Object^>^ Items
				{
					Windows::Foundation::Collections::IObservableVector<Platform::Object^>^ get()
					{
						return _Items;
					}
				}

				property Windows::UI::Xaml::Visibility LoadComplete
				{
					Windows::UI::Xaml::Visibility get()
					{
						return _LoadComplete;
					}
					void set(Windows::UI::Xaml::Visibility value)
					{
						_LoadComplete = value;
						OnPropertyChanged("LoadComplete");
					}
				}

				property bool isHasBookMark;

			private:
				Platform::Collections::Vector<Platform::Object^>^ _Items;
				Windows::UI::Xaml::Visibility _LoadComplete;
			};

			public ref class BookMarkLocalDataList sealed
			{
			public:
				BookMarkLocalDataList()
				{
					_m_items = ref new Platform::Collections::Vector<Platform::Object^>();
				}

				property Windows::Foundation::Collections::IObservableVector<Platform::Object^>^ m_items
				{
					Windows::Foundation::Collections::IObservableVector<Platform::Object^>^ get()
					{
						return _m_items;
					}
				}

				property Platform::String^ title
				{
					Platform::String^ get()
					{
						return _title;
					}
					void set(Platform::String^ value)
					{
						_title = value;
					}
				}

			private:
				Platform::Collections::Vector<Platform::Object^>^ _m_items;
				Platform::String^ _title;
			};

			public ref class BookMarkGoToData sealed
			{
			public:
				BookMarkGoToData()
				{
					_params = ref new Platform::Collections::Vector<float>();
				}

				property int  pageIndex
				{
					int get()
					{
						return _pageIndex;
					}
					void set(int value)
					{
						_pageIndex = value;
					}
				}

				property int zoomMode
				{
					int get()
					{
						return _zoomMode;
					}
					void set(int value)
					{
						_zoomMode = value;
					}
				}

				property foxit::pdf::Bookmark^ bookmark
				{
					foxit::pdf::Bookmark^ get()
					{
						return _bookmark;
					}
					void set(foxit::pdf::Bookmark^ value)
					{
						_bookmark = value;
					}
				}

				property Windows::Foundation::Collections::IObservableVector<float>^ params
				{
					Windows::Foundation::Collections::IObservableVector<float>^ get()
					{
						return _params;
					}
				}
			private:
				int _pageIndex;
				int _zoomMode;
				Platform::Collections::Vector<float>^ _params;
				foxit::pdf::Bookmark^ _bookmark;
			};
		}
	}
}
