/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

using namespace foxit::rdk;

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class BookmarkItem sealed
			{
			internal:
				BookmarkItem(foxit::pdf::Bookmark^ bookmark, foxit::pdf::Bookmark^ parentbookmark, int serials);
				std::vector<foxit::pdf::actions::Destination^> destVector;

			public:
				property int Series
				{
					int get();
				}
				property int PageIndex
				{
					int get();
					void set(int value);
				}
				property Platform::String^ Title
				{
					Platform::String^ get();
					void set(Platform::String^ value);
				}
				property Windows::UI::Xaml::Visibility IsHasNextList
				{
					Windows::UI::Xaml::Visibility get();
					void set(Windows::UI::Xaml::Visibility value);
				}
				property Platform::String^ Index
				{
					Platform::String^ get();
					void set(Platform::String^ value);
				}
				void DoAction();

				property foxit::pdf::Bookmark^ bookmarkIterator
				{
					foxit::pdf::Bookmark^ get();
					void set(foxit::pdf::Bookmark^ value);
				}

				void ReleaseBookmarkPos();
				Windows::Foundation::IAsyncOperationWithProgress<bool, Platform::String^>^ InitialBookmarkDestAsync();
				void CancelParserAction();

			private:
				void InitialBookmark();
				void InitialBookmarkDest();

			private:
				int _Series;
				int _PageIndex;
				Platform::String^ _Title;
				foxit::pdf::Bookmark^  m_Parent;
				foxit::pdf::Bookmark^  m_This;

				bool m_bIsinitaction;
				Platform::WeakReference m_Document;
				Windows::UI::Xaml::Visibility _IsHasNextList;
				Platform::String^ _Index;
				foxit::pdf::Bookmark^ _bookmarkIterator;
				foxit::pdf::Bookmark^ bookmarkPos;
				bool m_isCancelParserAction;
			};
		}
	}
}
