﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "Bookmark\BookMarkPage.g.h"
#include "Common\BindableBase.h"
#include "BookMarkData.h"
#include "BookMarkParser.h"
#include "BookMarkHandle.h"

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			ref class ProgressBarFactory;
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class BookMarkPage sealed
			{
			public:
				BookMarkPage();
				void ReleaseMarkParser();
				void CancelMarkParser();

			internal:
				BookMarkPage(foxit::pdf::PDFDoc^ doc, GoToPageIndexDelegate^ GoTodelegate);

			protected:
				virtual void OnNavigatedTo(Windows::UI::Xaml::Navigation::NavigationEventArgs^ e) override;

			public:
				bool isFirstSlibing();

			private:
				void InitializeBookmarkPage();
				void bookmarkList_ItemClick(Platform::Object^ sender, Windows::UI::Xaml::Controls::ItemClickEventArgs^ e);
				void OnBackPressed(Platform::Object ^sender, Windows::Phone::UI::Input::BackPressedEventArgs ^args);

				void PushBackList(Platform::String^ key, Windows::Foundation::Collections::IObservableVector<Platform::Object^>^ bookmarkItems);
				BookMarkLocalDataList^ PopListItems();

				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);

				void OperateList();
				void ReleaseAllBookPos();
				void ParaseBookmarkTitle(Platform::String^ title);
				void LoadBookmarkDestination();

			internal:
				//void DoBookmarkDestination(std::vector<foxit::pdf::actions::GotoAction^> actions);
				void DoBookmarkDestination(foxit::pdf::Bookmark^ bookmark, std::vector<foxit::pdf::actions::Destination^> dests);

			private:
				Windows::Foundation::EventRegistrationToken m_HardwareButtonsBackPressedEventToken, m_SystemNavigationBackRequestedEventToken;
				Windows::Foundation::Collections::IVector<BookMarkLocalDataList^>^ items;
				Windows::Foundation::Collections::IVector<BookMarkItemData^>^ titleItems;
				BookMarkParser^ markParser;
				Platform::String^ TitleContent;
				foxit::rdk::uiextensions::ProgressBarFactory^		m_pProgressBar;
				foxit::pdf::PDFDoc^ pdfDoc;
				GoToPageIndexDelegate^ goToIndexDelegate;
				BookMarkItemData^ curClickBookMarkItem;
				BookMarkItemData^ curTitleBookMarkItem;
				bool m_IsParaseBookmarkAction;
				bool m_IsCancelParserAction;
				void OnSizeChanged(Platform::Object ^sender, Windows::UI::Xaml::SizeChangedEventArgs ^e);
				void TextBlock_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void tbTitle_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void imgBack_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void Image_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void OnBackRequested(Platform::Object ^sender, Windows::UI::Core::BackRequestedEventArgs ^args);
				void btnEditBookmark_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void clearBookMark_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void slelectBookMark_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
			};
		}
	}
}
