/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			ref class BookmarkItem;
			ref class BookMarkData;
			ref class BookMarkGoToData;
		}
	}
}

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			public delegate void GoToPageIndexDelegate(BookMarkGoToData^ goToData);
			public delegate void CollectBookMarkListDelegate();

			ref class BookMarkParser sealed
			{
			public:
				virtual ~BookMarkParser();
				void ReleaseBookMarkParser();
				void CancelBookMarkParser();
				Windows::Foundation::IAsyncOperationWithProgress<bool, Platform::String^>^ GetAllBookMarkData();
				void StartGetAllBookMarkDataTaskWithAsync();
				bool BuildBookmark(int series);
				bool ModifyBookMarkText(Platform::Object^ item, Platform::String^ text);
				bool AddOneBookMark(Platform::Object^ siblingitem, Platform::String^ text);
				bool IsCompleted();
				bool IsHaveBookmark();
				void SetDelegate(CollectBookMarkListDelegate^ del);
				void AddBookmarkItem();


			internal:
				BookMarkParser(foxit::pdf::PDFDoc^ doc);
				foxit::pdf::Bookmark^	m_currentBookmark;
				void SetCurIterator(foxit::pdf::Bookmark^ pos);
				bool RemoveBookmarkItem(foxit::pdf::Bookmark^ pos);

			protected:
				void Test();
				void InitializeReset();

			internal:
				BookMarkData^ m_BookMarkData;
				std::vector<BookmarkItem^> m_nativeVect;

			private:
				bool GetNextChildBookMark(foxit::pdf::Bookmark^ parent, int series);
				bool GetNextSiblingBookMark(foxit::pdf::Bookmark^ parent, int series);
				bool ParseOneBookMark(foxit::pdf::Bookmark^ parent, foxit::pdf::Bookmark^ bookmark, int series);
				Platform::String^ GetBookMarkHorizontalTabsBuffer(int series);
			private:
				bool m_IsInitialize;
				bool m_isFinish;
				bool m_bCancel;
				foxit::pdf::PDFDoc^ m_pDoc;
				Windows::Foundation::IAsyncOperationWithProgress<bool, Platform::String^>^ asynctask;
				HANDLE m_EventCancelParserBookmark;
				Platform::WeakReference m_WeakDocument;
				Platform::WeakReference m_pPageView;
				int m_BookmarkIndex;
				CollectBookMarkListDelegate^ collectBookMarkList;
			};
		}
	}
}