/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class BindableBase : Windows::UI::Xaml::DependencyObject, Windows::UI::Xaml::Data::INotifyPropertyChanged, Windows::UI::Xaml::Data::ICustomPropertyProvider
			{
			public:
				virtual event Windows::UI::Xaml::Data::PropertyChangedEventHandler^ PropertyChanged;

			public:
				// ICustomPropertyProvider
				virtual Windows::UI::Xaml::Data::ICustomProperty^ GetCustomProperty(Platform::String^ name);
				virtual Windows::UI::Xaml::Data::ICustomProperty^ GetIndexedProperty(Platform::String^ name, Windows::UI::Xaml::Interop::TypeName type);
				virtual Platform::String^ GetStringRepresentation();

				property Windows::UI::Xaml::Interop::TypeName Type
				{
					virtual Windows::UI::Xaml::Interop::TypeName get() { return this->GetType(); }
				}


			protected:
				virtual void OnPropertyChanged(Platform::String^ propertyName);
			};
		}
	}
}