/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#include "pch.h"
#include "BooleanToVisibilityConverter.h"

using namespace foxit::rdk::uiextensions;

using namespace Platform;
using namespace Windows::UI::Xaml::Interop;
using namespace Windows::ApplicationModel::Resources;


BooleanToVisibilityConverter::BooleanToVisibilityConverter()
{

}

Platform::Object^ BooleanToVisibilityConverter::Convert(Platform::Object^ value, Windows::UI::Xaml::Interop::TypeName targetType, Platform::Object^ parameter, Platform::String^ language)
{
	auto valueString = value->ToString();
	auto valueTypeString = value->GetType()->FullName;

	return (value->GetType()->FullName ==  bool::typeid->FullName && (bool)value) ? Windows::UI::Xaml::Visibility::Visible : Windows::UI::Xaml::Visibility::Collapsed;
}


Platform::Object^ BooleanToVisibilityConverter::ConvertBack(Platform::Object^ value, Windows::UI::Xaml::Interop::TypeName targetType, Platform::Object^ parameter, Platform::String^ language)
{
	return value->GetType()->FullName == Platform::IBox<Windows::UI::Xaml::Visibility>::typeid->FullName && (Windows::UI::Xaml::Visibility)value == Windows::UI::Xaml::Visibility::Visible;
}
