﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class UIContentHostedDialog sealed : public Windows::UI::Xaml::Controls::ContentControl
			{
			public:
				UIContentHostedDialog();

				static property Windows::UI::Xaml::DependencyProperty^ IsLightDismissEnabledProperty
				{
					Windows::UI::Xaml::DependencyProperty^ get();
				}
				property bool IsLightDismissEnabled
				{
					bool get();
					void set(bool value);
				}

				static property Windows::UI::Xaml::DependencyProperty^ AutoCloseProperty
				{
					Windows::UI::Xaml::DependencyProperty^ get();
				}
				property bool AutoClose
				{
					bool get();
					void set(bool value);
				}

				static property Windows::UI::Xaml::DependencyProperty^ IsContentFullScreenProperty
				{
					Windows::UI::Xaml::DependencyProperty^ get();
				}
				property bool IsContentFullScreen
				{
					bool get();
					void set(bool value);
				}

			public:
				void ShowDialog();
				void Hide();

			internal:

			public:
				void OnApplyTemplate() override;

			private:
				void ResizeLayoutRoot();

			private:
				bool m_IsShown;
				Windows::UI::Xaml::Controls::Panel^ m_LayoutRoot;
				Windows::UI::Xaml::Controls::ContentPresenter^ m_ContentPresenter;
				Windows::UI::Xaml::Controls::Primitives::Popup^ m_ContentPopup;
				Windows::UI::Xaml::Controls::Panel^ m_ParentPanel;
				Windows::UI::Xaml::Controls::ContentControl^ m_ParentContentControl;
				Windows::UI::Xaml::Controls::Panel^ m_TemporaryParentPanel;

				Windows::Foundation::EventRegistrationToken m_ParentSizeChangedEventToken;

				Windows::UI::Xaml::DispatcherTimer^ m_AutoCloseTimer;
				Platform::WeakReference m_PageViewWeakRef;
				Windows::Foundation::EventRegistrationToken			m_BackPresseEventToken, m_SystemNavigationBackRequestedEventToken;

				UINonVisibilityButton^ m_NonVisibilityBtn;

			private:
				void OnInitializeControl();
				void HookUpEvents();
				void UnHookEvents();
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnLayoutRootTapped(Platform::Object ^sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs ^e);
				void OnParentSizeChanged(Platform::Object ^sender, Windows::UI::Xaml::SizeChangedEventArgs ^e);
				void OnContentPopupOpened(Platform::Object ^sender, Platform::Object ^args);
				void OnPopupLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnAutoCloseTick(Platform::Object ^sender, Platform::Object ^args);
				void OnBackPressed(Platform::Object ^sender, Windows::Phone::UI::Input::BackPressedEventArgs ^args);
				void OnBackRequested(Platform::Object ^sender, Windows::UI::Core::BackRequestedEventArgs ^args);
			};
		}
	}
}
