/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class UIControlSizeTrigger sealed : public Windows::UI::Xaml::StateTriggerBase
			{
			public:
				UIControlSizeTrigger();

			public:
				property Windows::UI::Xaml::FrameworkElement^ TargetElement
				{
					Windows::UI::Xaml::FrameworkElement^ get();
					void set(Windows::UI::Xaml::FrameworkElement^ value);
				}

				property double MinWidth
				{
					double get();
					void set(double value);
				}

				property double MinHeight
				{
					double get();
					void set(double value);
				}

			private:
				Windows::UI::Xaml::FrameworkElement^ _TargetElement;
				double _MinHeight, _MinWidth;
				double _currentHeight, _currentWidth;

			private:
				void UpdateTrigger();
				void OnSizeChanged(Platform::Object ^sender, Windows::UI::Xaml::SizeChangedEventArgs ^e);
			};
		}
	}
}
