/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once
#include <Windows.h>

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			class CritSec
			{
			public:
				CRITICAL_SECTION m_criticalSection;
			public:
				CritSec()
				{
					InitializeCriticalSectionEx(&m_criticalSection, 100, 0);
				}

				~CritSec()
				{
					DeleteCriticalSection(&m_criticalSection);
				}

				_Acquires_lock_(m_criticalSection)
					void Lock()
				{
					EnterCriticalSection(&m_criticalSection);
				}

				_Releases_lock_(m_criticalSection)
					void Unlock()
				{
					LeaveCriticalSection(&m_criticalSection);
				}
			};

			class AutoLock
			{
			private:
				CritSec *m_pCriticalSection;
			public:
				_Acquires_lock_(m_pCriticalSection)
					AutoLock(CritSec& crit)
				{
					m_pCriticalSection = &crit;
					m_pCriticalSection->Lock();
				}

				_Releases_lock_(m_pCriticalSection)
					~AutoLock()
				{
					m_pCriticalSection->Unlock();
				}
			};
		}
	}
}