/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#include "pch.h"
#include "DeviceFamilyTrigger.h"

using namespace foxit::rdk::uiextensions;

using namespace Platform;

UIDeviceFamilyTrigger::UIDeviceFamilyTrigger()
{
	_currentDeviceFamily = Windows::System::Profile::AnalyticsInfo::VersionInfo->DeviceFamily;
}

Platform::String^ UIDeviceFamilyTrigger::DeviceFamily::get()
{
	return _queriedDeviceFamily;
}

void UIDeviceFamilyTrigger::DeviceFamily::set(Platform::String^ value)
{
	_queriedDeviceFamily = value;
	//Get the current device family
	_currentDeviceFamily = Windows::System::Profile::AnalyticsInfo::VersionInfo->DeviceFamily;

	//The trigger will be activated if the current device family matches the device family value in XAML
	SetActive(_queriedDeviceFamily == _currentDeviceFamily);
}
