﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#include "pch.h"
#include "DoubleToStringConverter.h"

using namespace foxit::rdk::uiextensions;

using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Interop;

Object^ DoubleToStringConverter::Convert(Object^ value, TypeName targetType, Object^ parameter, String^ language)
{
	(void) targetType;	
	(void) parameter;	
	(void) language;	

	auto boxedDouble = dynamic_cast<Box<double>^>(value);
	return (boxedDouble != nullptr) ? boxedDouble->Value.ToString() : L"";
}

Object^ DoubleToStringConverter::ConvertBack(Object^ value, TypeName targetType, Object^ parameter, String^ language)
{
	(void) targetType;	
	(void) parameter;	
	(void) language;	

	auto dbvalue = dynamic_cast<Box<double>^>(value);
	return (dbvalue != nullptr) ? dbvalue->Value : 0.0;
}
