﻿/**
* Copyright (C) 2003-2018, Foxit Software Inc..
* All Rights Reserved.
*
* http://www.foxitsoftware.com
*
* The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
* distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
* is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
* Review legal.txt for additional license and legal information.
*/


#pragma once

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class FlyoutHostedControl sealed : public Windows::UI::Xaml::Controls::ContentControl
			{
			public:
				FlyoutHostedControl();

				static property Windows::UI::Xaml::DependencyProperty^ IsPinEnabledProperty
				{
					Windows::UI::Xaml::DependencyProperty^ get();
				}
				property bool IsPinEnabled
				{
					bool get();
					void set(bool value);
				}

				static property Windows::UI::Xaml::DependencyProperty^ TitleProperty
				{
					Windows::UI::Xaml::DependencyProperty^ get();
				}
				property Platform::String^ Title
				{
					Platform::String^ get();
					void set(Platform::String^ value);
				}

				void ShowFlyoutPage(Windows::UI::Xaml::FrameworkElement^ pFrameworkElement);
				void CloseFlyout();

				event Windows::Foundation::EventHandler<Platform::Object^>^ Show;
				event Windows::Foundation::EventHandler<Platform::Object^>^ Hide;

			public:
				void OnApplyTemplate() override;

			internal:
				static void OnIsPinEnabledChanged(Windows::UI::Xaml::DependencyObject^ obj, Windows::UI::Xaml::DependencyPropertyChangedEventArgs^ args);

			protected:
				void OnIsPinEnabledValueChanged(bool oldValue, bool newValue);

			private:
				Windows::UI::Xaml::Controls::Panel^ m_LayoutRoot;
				Windows::UI::Xaml::Controls::ContentPresenter^ m_ContentPresenter;
				Windows::UI::Xaml::Controls::Button^ m_CloseButton;

				Windows::Foundation::EventRegistrationToken m_WindowSizeChangedEventToken, m_CloseButtonClickEventToken;
				Windows::UI::Xaml::Controls::Flyout^ m_Flyout;

				Platform::WeakReference m_PlaceTarget;

				bool m_NeedReOpen;

				Windows::Foundation::EventRegistrationToken m_BackPresseEventToken, m_SystemNavigationBackRequestedEventToken;

			private:
				void UpdateFlyoutPosition();

			private:
				void OnInitializeControl();
				void HookUpEvents();
				void UnHookEvents();
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnCloseButtonClick(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void OnFlyoutOpened(Platform::Object ^sender, Platform::Object ^args);
				void OnFlyoutClosed(Platform::Object ^sender, Platform::Object ^args);
				void OnVisibleBoundsChanged(Windows::UI::ViewManagement::ApplicationView ^sender, Platform::Object ^args);
				void OnBackPressed(Platform::Object ^sender, Windows::Phone::UI::Input::BackPressedEventArgs ^args);
				void OnBackRequested(Platform::Object ^sender, Windows::UI::Core::BackRequestedEventArgs ^args);
			};
		}
	}
}
