/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#include "pch.h"
#include "InputTypeTrigger.h"

using namespace foxit::rdk::uiextensions;

using namespace Platform;

InputTypeTrigger::InputTypeTrigger()
{

}

Windows::UI::Xaml::FrameworkElement^ InputTypeTrigger::TargetElement::get()
{
	return _targetElement;
}

void InputTypeTrigger::TargetElement::set(Windows::UI::Xaml::FrameworkElement^ value)
{
	_targetElement = value;
	_targetElement->AddHandler(Windows::UI::Xaml::FrameworkElement::PointerPressedEvent, ref new Windows::UI::Xaml::Input::PointerEventHandler(this, &InputTypeTrigger::TargetElement_PointerPressed), true);
}

Windows::Devices::Input::PointerDeviceType InputTypeTrigger::PointerType::get()
{
	return _triggerPointerType;
}

void InputTypeTrigger::PointerType::set(Windows::Devices::Input::PointerDeviceType value)
{
	_triggerPointerType = value;
}

void InputTypeTrigger::UpdateTrigger()
{
	SetActive(_triggerPointerType == _lastPointerType);
}

void InputTypeTrigger::TargetElement_PointerPressed(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e)
{
	_lastPointerType = e->Pointer->PointerDeviceType;

	UpdateTrigger();
}