﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class UINonVisibilityButton sealed : public Windows::UI::Xaml::Controls::Button
			{
			public:
				UINonVisibilityButton();

			protected:
				virtual Windows::UI::Xaml::Automation::Peers::AutomationPeer^ OnCreateAutomationPeer() override;
			};

			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class NonVisibilityButtonAutomationPeer sealed : Windows::UI::Xaml::Automation::Peers::FrameworkElementAutomationPeer
			{
			public:
				NonVisibilityButtonAutomationPeer(UINonVisibilityButton^ owner)
					: FrameworkElementAutomationPeer(owner)
				{
					this->ownerControl = owner;
					this->accClass = "UINonVisibilityButton";
				}

			protected:
				/// <summary>
				/// Override GetClassNameCore and set the name of the class that defines the type associated with this control.
				/// </summary>
				/// <returns>The name of the control class</returns>
				virtual Platform::String^ GetClassNameCore() override
				{
					return this->accClass;
				}

			private:
				UINonVisibilityButton^ ownerControl;
				Platform::String^ accClass;
			};
		}
	}
}
