/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class NumericTextBox sealed : Windows::UI::Xaml::Controls::TextBox
			{
			public:
				NumericTextBox();

			public:
				static property Windows::UI::Xaml::DependencyProperty^ AllowSpaceProperty
				{
					Windows::UI::Xaml::DependencyProperty^ get();
				};
				property bool AllowSpace
				{
					bool get();
					void set(bool value);
				}

			protected:
				virtual void OnKeyDown(Windows::UI::Xaml::Input::KeyRoutedEventArgs^ e) override;

			private:
				void OnInitializeControl();

			private:
				Platform::String^ m_PrevInputString;
				void OnTextChanged(Platform::Object ^sender, Windows::UI::Xaml::Controls::TextChangedEventArgs ^e);
				void OnTextCompositionChanged(Windows::UI::Xaml::Controls::TextBox ^sender, Windows::UI::Xaml::Controls::TextCompositionChangedEventArgs ^args);
			};
		}
	}
}
