﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class SearchTextBoxQuerySubmittedEventArgs sealed : public Windows::UI::Xaml::DependencyObject
			{
			public:
				SearchTextBoxQuerySubmittedEventArgs()
				{

				}

				property Platform::String^ QueryText;
			};

			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class SearchTextBox sealed : public Windows::UI::Xaml::Controls::TextBox
			{
			public:
				SearchTextBox();

			public:
				static property Windows::UI::Xaml::DependencyProperty^ IsSearchingProperty
				{
					Windows::UI::Xaml::DependencyProperty^ get();
				}
				property bool IsSearching
				{
					bool get();
					void set(bool value);
				}

			internal:
				static void OnIsSearchingChanged(Windows::UI::Xaml::DependencyObject^ obj, Windows::UI::Xaml::DependencyPropertyChangedEventArgs^ args);

			public:
				void OnApplyTemplate() override;

				event Windows::Foundation::TypedEventHandler<Platform::Object^, SearchTextBoxQuerySubmittedEventArgs^>^ QuerySubmitted;

			private:
				Windows::UI::Xaml::Controls::Button^ m_QueryButton;
				Windows::UI::Xaml::Controls::ContentControl^ m_PlaceholderTextContentPresenter;
				Windows::Foundation::EventRegistrationToken m_QueryButtonClickEventRegistrationToken;
				bool m_TextChanged;

			private:
				Platform::String^ TrimSpace(Platform::String^ str);
				bool SearchCheckStringValid(Platform::String^ findstr);

			private:
				void OnInitializeControl();
				void HookUpEvents();
				void UnHookEvents();
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnKeyDown(Platform::Object ^sender, Windows::UI::Xaml::Input::KeyRoutedEventArgs ^e);
				void OnQueryButtonClick(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnTextChanged(Platform::Object ^sender, Windows::UI::Xaml::Controls::TextChangedEventArgs ^e);
				void OnGotFocus(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnLostFocus(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
			};
		}
	}
}
