/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#include "pch.h"
#include "ToolBarButton.h"

using namespace foxit::rdk::uiextensions;

using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Documents;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Interop;
using namespace Windows::UI::Xaml::Media;

ToolBarButton::ToolBarButton()
{
	DefaultStyleKey = "foxit.rdk.uiextensions.ToolBarButton";
	this->ApplyTemplate();
}

static DependencyProperty^ _HitTextVisibleProperty =
DependencyProperty::Register("HitTextVisible", TypeName(bool::typeid), TypeName(ToolBarButton::typeid),
	ref new PropertyMetadata(nullptr, ref new PropertyChangedCallback(ToolBarButton::OnHitTextVisibleChanged)));

static DependencyProperty^ _LabelProperty =
DependencyProperty::Register("Label", TypeName(Platform::String::typeid), TypeName(ToolBarButton::typeid),
	ref new PropertyMetadata(nullptr, ref new PropertyChangedCallback(ToolBarButton::OnLabelChanged)));

Windows::UI::Xaml::DependencyProperty^ ToolBarButton::LabelProperty::get()
{
	return _LabelProperty;
}

Platform::String^ ToolBarButton::Label::get()
{
	return (Platform::String^)GetValue(LabelProperty);
}

void ToolBarButton::Label::set(Platform::String^ value)
{
	SetValue(LabelProperty, value);
}



Windows::UI::Xaml::DependencyProperty^ ToolBarButton::HitTextVisibleProperty::get()
{
	return _HitTextVisibleProperty;
}

bool ToolBarButton::HitTextVisible::get()
{
	return (bool)GetValue(HitTextVisibleProperty);
}

void ToolBarButton::HitTextVisible::set(bool value)
{
	SetValue(HitTextVisibleProperty, value);
}

void ToolBarButton::OnHitTextVisibleChanged(Windows::UI::Xaml::DependencyObject^ obj, Windows::UI::Xaml::DependencyPropertyChangedEventArgs^ args)
{

}

void ToolBarButton::OnLabelChanged(Windows::UI::Xaml::DependencyObject^ obj, Windows::UI::Xaml::DependencyPropertyChangedEventArgs^ args)
{

}