/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
#define FSPDF_ANNOT_ICONNAME_TEXT_CHECKMARK				"Checkmark"
			/** @brief	Note icon type: Check. */
#define FSPDF_ANNOT_ICONNAME_TEXT_CHECK					"Check"
/** @brief	Note icon type: Circle. */
#define FSPDF_ANNOT_ICONNAME_TEXT_CIRCLE				"Circle"
/** @brief	Note icon type: Comment. */
#define FSPDF_ANNOT_ICONNAME_TEXT_COMMENT				"Comment"
/** @brief	Note icon type: Cross. */
#define FSPDF_ANNOT_ICONNAME_TEXT_CROSS					"Cross"
/** @brief	Note icon type: Help. */
#define FSPDF_ANNOT_ICONNAME_TEXT_HELP					"Help"
/** @brief	Note icon type: Insert. */
#define FSPDF_ANNOT_ICONNAME_TEXT_INSERT				"Insert"
/** @brief	Note icon type: Key. */
#define FSPDF_ANNOT_ICONNAME_TEXT_KEY					"Key"
/** @brief	Note icon type: New Paragraph. */
#define FSPDF_ANNOT_ICONNAME_TEXT_NEWPARAGRAPH			"NewParagraph"
/** @brief	Note icon type: Note. */
#define FSPDF_ANNOT_ICONNAME_TEXT_NOTE					"Note"
/** @brief	Note icon type: Paragraph. */
#define FSPDF_ANNOT_ICONNAME_TEXT_PARAGRAPH				"Paragraph"
/** @brief	Note icon type: Right Arrow. */
#define FSPDF_ANNOT_ICONNAME_TEXT_RIGHARROW				"RightArrow"
/** @brief	Note icon type: Right Pointer. */
#define FSPDF_ANNOT_ICONNAME_TEXT_RIGHPOINTER			"RightPointer"
/** @brief	Note icon type: Star. */
#define FSPDF_ANNOT_ICONNAME_TEXT_STAR					"Star"
/** @brief	Note icon type: Up Arrow. */
#define FSPDF_ANNOT_ICONNAME_TEXT_UPARROW				"UpArrow"
/** @brief	Note icon type: Up-left Arrow. */
#define FSPDF_ANNOT_ICONNAME_TEXT_UPLEFTARROW			"UpleftArrow"

/** @brief	File attachment icon type: Graph. */
#define FSPDF_ANNOT_ICONNAME_FILEATTACH_GRAPH			"Graph"
/** @brief	File attachment icon type: PaperClip. */
#define FSPDF_ANNOT_ICONNAME_FILEATTACH_PAPERCLIP		"Paperclip"
/** @brief	File attachment icon type: PushPin. */
#define FSPDF_ANNOT_ICONNAME_FILEATTACH_PUSHPIN			"PushPin"
/** @brief	File attachment icon type: Tag. */
#define FSPDF_ANNOT_ICONNAME_FILEATTACH_TAG				"Tag"

/** @brief	Stamp annotation icon type: Approved. */
#define FSPDF_ANNOT_ICONNAME_STAMP_APPROVED				"Approved"
/** @brief	Stamp annotation icon type: AsIs. */
#define FSPDF_ANNOT_ICONNAME_STAMP_ASIS					"AsIs"
/** @brief	Stamp annotation icon type: Confidential. */
#define FSPDF_ANNOT_ICONNAME_STAMP_CONFIDENTIAL			"Confidential"
/** @brief	Stamp annotation icon type: Departmental. */
#define FSPDF_ANNOT_ICONNAME_STAMP_DEPARTMENTAL			"Departmental"
/** @brief	Stamp annotation icon type: Draft. */
#define FSPDF_ANNOT_ICONNAME_STAMP_DRAFT				"Draft"
/** @brief	Stamp annotation icon type: Experimental. */
#define FSPDF_ANNOT_ICONNAME_STAMP_EXPERIMENTAL			"Experimental"
/** @brief	Stamp annotation icon type: Expired. */
#define FSPDF_ANNOT_ICONNAME_STAMP_EXPIRED				"Expired"
/** @brief	Stamp annotation icon type: Final. */
#define FSPDF_ANNOT_ICONNAME_STAMP_FINAL				"Final"
/** @brief	Stamp annotation icon type: ForComment. */
#define FSPDF_ANNOT_ICONNAME_STAMP_FORCOMMENT			"ForComment"
/** @brief	Stamp annotation icon type: ForPublicRelease. */
#define FSPDF_ANNOT_ICONNAME_STAMP_FORPUBLICRELEASE		"ForPublicRelease"
/** @brief	Stamp annotation icon type: NotApproved. */
#define FSPDF_ANNOT_ICONNAME_STAMP_NOTAPPROVED			"NotApproved"
/** @brief	Stamp annotation icon type: NotForPublicRelease. */
#define FSPDF_ANNOT_ICONNAME_STAMP_NOTFORPUBLICRELEASE	"NotForPublicRelease"
/** @brief	Stamp annotation icon type: Sold. */
#define FSPDF_ANNOT_ICONNAME_STAMP_SOLD					"Sold"
/** @brief	Stamp annotation icon type: TopSecret. */
#define FSPDF_ANNOT_ICONNAME_STAMP_TOPSECRET			"TopSecret"

/** @brief	Sound annotation icon type: Speaker. */
#define FSPDF_ANNOT_ICONNAME_SOUND_SPEAKER				"Speaker"
/** @brief	Sound annotation icon type: Mic. */
#define FSPDF_ANNOT_ICONNAME_SOUND_MIC					"Mic"

//////////////////////////////////////////////////////////////////////////
//  Utility
//  Description: Development Tools.
//////////////////////////////////////////////////////////////////////////
			class FoxitTypeConvert
			{
			public:
				static foxit::pdf::PDFPage^ ConvertFromWraperClass(Platform::Object^ pageObj);

				static Windows::UI::Color ConvertFromColorString(Platform::String^ colorstr);

				static Platform::String^ ConvertToColorString(Windows::UI::Color color);

				static foxit::pdf::annots::Style ConvertToFoxitAnnotBorderStyle(AnnotBorderStyle borderstyle);

				static AnnotBorderStyle ConvertFromFoxitAnnotBorderStyle(foxit::pdf::annots::Style borderstyle);

				static foxit::common::DateTime^ ConvertToFoxitDateTime(Windows::Foundation::DateTime datetime);

				static Windows::Foundation::DateTime ConvertFromFoxitDateTime(foxit::common::DateTime^ datetime);

				static Platform::String^ ConvertToFoxitAnnotIconNameTextTypeString(AnnotIconNameTextType icontype);

				static AnnotIconNameTextType ConvertFromFoxitAnnotIconNameTextTypeString(Platform::String^ iconname);

				static Platform::String^ ConvertToFoxitAnnotIconNameFileattachTypeString(AnnotIconNameFileattachType icontype);

				static AnnotIconNameFileattachType ConvertFromFoxitAnnotIconNameFileattachTypeString(Platform::String^ iconname);

				static Platform::String^ ConvertToFoxitAnnotIconNameStampTypeString(AnnotIconNameStampType icontype);

				static AnnotIconNameStampType ConvertFromFoxitAnnotIconNameStampTypeString(Platform::String^ iconname);

				static Platform::String^ ConvertToFoxitAnnotIconNameSoundTypeString(AnnotIconNameSoundType icontype);

				static AnnotIconNameSoundType ConvertFromFoxitAnnotIconNameSoundTypeString(Platform::String^ iconname);

				static Platform::String^  ConvertFromFoxitAnnotType(foxit::pdf::annots::AnnotType annotType);

				static foxit::pdf::annots::AnnotType ConvertFromAnnotType(AnnotationType type);
			};

			public ref class Utility sealed
			{
			internal:
				static void ThrowIfFailed(HRESULT hr);
				static byte* GetPointerToPixelData(Windows::Storage::Streams::IBuffer^ buffer, unsigned int* length = nullptr);

				static Platform::String^ GetGUID();
				static Platform::String^ GetUuid();
				static Platform::String^ GetcPDFUuid();

				static Windows::UI::Color ConvertFromString(Platform::String^ colorstr);
				static Platform::String^ ConvertToColorString(Windows::UI::Color color);

				static foxit::common::fxcrt::Matrix2D^ ConvertToFoxitMatrix(Windows::UI::Xaml::Media::Matrix matrix);
				static Windows::UI::Xaml::Media::Matrix ConvertFromFoxitMatrix(foxit::common::fxcrt::Matrix2D^ matrix);

				static bool IsEqualColor(Windows::UI::Color a, Windows::UI::Color b);
				static Platform::String^ TrimSpace(Platform::String^ str);

				static  std::string ConvertToStdString(Platform::String^ str);

				static bool IsDesktopPlatform();
				static bool IsMobilePlatform();

				static Windows::UI::Xaml::Media::Imaging::BitmapImage^ GetAnnotBitmap(Platform::String^ key);

			private:
				static Platform::Collections::Map<Platform::String^, Windows::UI::Xaml::Media::Imaging::BitmapImage^>^ m_BitmapMap;
				static void InitAnnotBitmapMap();
			};

			class FoxitRectConverter
			{
			public:
				inline static Windows::Foundation::Rect ConvertFromQuardsPoint(foxit::pdf::annots::QuadPoints^ quardPoints)
				{
					float minX = quardPoints->first->x;
					float minY = quardPoints->first->y;
					float maxX = minX, maxY = minY;
					for (int i = 0; i < 3; i++)
					{
						foxit::common::fxcrt::PointF^ pt = nullptr;
						switch (i)
						{
						case 0:
							pt = quardPoints->second;
							break;
						case 1:
							pt = quardPoints->third;
							break;
						case 2:
							pt = quardPoints->fourth;
							break;
						default:
							break;
						}

						minX = pt->x > minX ? minX : pt->x;
						maxX = pt->x < maxX ? maxX : pt->x;
						minY = pt->y > minY ? minY : pt->y;
						maxY = pt->y < maxY ? maxY : pt->y;
					}
					return Windows::Foundation::Rect(minX, minY, (maxX - minX), (maxY - minY));
				}

				inline static Windows::Foundation::Rect ConvertFromFoxitRect(foxit::common::fxcrt::RectI^ fsrect)
				{
					Windows::Foundation::Rect rect;
					rect.X = (float)fsrect->left, rect.Y = (float)fsrect->top, rect.Width = fabs((float)(fsrect->left - fsrect->right)), rect.Height = -((float)(fsrect->top - fsrect->bottom));
					return NormalizeToWindowsRect(rect);
				}

				inline static void ConvertFromFoxitRect(foxit::common::fxcrt::RectI^ fsrect, Windows::Foundation::Rect& rect)
				{
					rect.X = (float)fsrect->left, rect.Y = (float)fsrect->top, rect.Width = fabs((float)(fsrect->left - fsrect->right)), rect.Height = -((float)(fsrect->top - fsrect->bottom));
				}

				inline static Windows::Foundation::Rect ConvertFromFoxitRectF(foxit::common::fxcrt::RectF^ fsrectf)
				{
					Windows::Foundation::Rect rect;
					rect.X = (float)fsrectf->left, rect.Y = (float)fsrectf->top, rect.Width = fabs((float)(fsrectf->right - fsrectf->left)), rect.Height = -((float)(fsrectf->top - fsrectf->bottom));
					return NormalizeToWindowsRect(rect);
				}

				inline static void ConvertFromFoxitRectF(foxit::common::fxcrt::RectF^ fsrectf, Windows::Foundation::Rect& rect)
				{
					rect.X = (float)fsrectf->left, rect.Y = (float)fsrectf->top, rect.Width = fabs((float)(fsrectf->left - fsrectf->right)), rect.Height = -((float)(fsrectf->top - fsrectf->bottom));
				}

				inline static foxit::common::fxcrt::RectI^ ConvertToFoxitRect(Windows::Foundation::Rect rect)
				{
					foxit::common::fxcrt::RectI^ fsrect = ref new foxit::common::fxcrt::RectI();
					fsrect->left = (FS_INT32)rect.Left, fsrect->right = (FS_INT32)rect.Right, fsrect->top = (FS_INT32)rect.Top, fsrect->bottom = (FS_INT32)rect.Bottom;
					return NormalizeToFoxitRect(fsrect);
				}

				inline static foxit::common::fxcrt::RectF^ ConvertToFoxitRectF(Windows::Foundation::Rect rect)
				{
					foxit::common::fxcrt::RectF^ fsrectf = ref new foxit::common::fxcrt::RectF();
					fsrectf->left = (FS_FLOAT)rect.Left, fsrectf->right = (FS_FLOAT)rect.Right, fsrectf->top = (FS_FLOAT)rect.Top, fsrectf->bottom = (FS_FLOAT)rect.Bottom;
					return NormalizeToFoxitRectF(fsrectf);
				}

				inline static Windows::Foundation::Rect ScaleUpRect(Windows::Foundation::Rect rect, int width)
				{
					return Windows::Foundation::Rect(rect.X - width, rect.Y - width, rect.Width + 2 * width, rect.Height + 2 * width);
				}

				inline static foxit::common::fxcrt::RectI^ NormalizeToFoxitRect(foxit::common::fxcrt::RectI^ fsrect)
				{
					if (fsrect->left > fsrect->right)
					{
						auto _swap = fsrect->left;
						fsrect->left = fsrect->right;
						fsrect->right = _swap;
					}
					if (fsrect->top < fsrect->bottom)
					{
						auto _swap = fsrect->top;
						fsrect->top = fsrect->bottom;
						fsrect->bottom = _swap;
					}
					return fsrect;
				}

				inline static foxit::common::fxcrt::RectF^ NormalizeToFoxitRectF(foxit::common::fxcrt::RectF^ fsrectf)
				{
					if (fsrectf->left > fsrectf->right)
					{
						auto _swap = fsrectf->left;
						fsrectf->left = fsrectf->right;
						fsrectf->right = _swap;
					}
					if (fsrectf->top < fsrectf->bottom)
					{
						auto _swap = fsrectf->top;
						fsrectf->top = fsrectf->bottom;
						fsrectf->bottom = _swap;
					}
					return fsrectf;
				}

				inline static Windows::Foundation::Rect NormalizeToWindowsRect(Windows::Foundation::Rect rect)
				{
					if (rect.Width < 0)
					{
						rect.X += rect.Width;
						rect.Width = -rect.Width;
					}
					if (rect.Height < 0)
					{
						rect.Y += rect.Height;
						rect.Height = -rect.Height;
					}
					return Windows::Foundation::Rect(rect);
				}
			};

			inline static std::wstring wstring_format(const wchar_t *fmt, ...)
			{
				std::wstring strResult = L"";
				if (NULL != fmt)
				{
					va_list marker = NULL;
					va_start(marker, fmt);
					size_t nLength = _vscwprintf(fmt, marker) + 1;
					std::vector<wchar_t> vBuffer(nLength, L'\0');
					int nWritten = _vsnwprintf_s(&vBuffer[0], vBuffer.size(), nLength, fmt, marker);
					if (nWritten > 0)
					{
						strResult = &vBuffer[0];
					}
					va_end(marker);
				}
				return strResult;
			}
			inline static bool GetIsDesktopPlatform()
			{
				return (Windows::System::Profile::AnalyticsInfo::VersionInfo->DeviceFamily == "Windows.Desktop");
			}

			class FSPDFDocUtil
			{
			public:
				static int GetDocumentSize(Windows::Storage::StorageFile^ file);
				static DocumentEncryptType GetDocumentEncryptType(foxit::pdf::PDFDoc^ doc);
				static bool GetIsDocumentSecurity(foxit::pdf::PDFDoc^ doc);
				static bool GetIsDocumentCanExtra(foxit::pdf::PDFDoc^ doc);
				static bool GetIsDocumentCanAssemble(foxit::pdf::PDFDoc^ doc);
				static bool GetIsDocumentCanBeSigning(foxit::pdf::PDFDoc^ doc);
				static bool GetIsDocumentCanModify(foxit::pdf::PDFDoc^ doc);
				static bool GetIsDocumentCanBePrint(foxit::pdf::PDFDoc^ doc);
				static bool GetIsDocumentCanBeCopy(foxit::pdf::PDFDoc^ doc);
				static bool GetIsDocumentCanModifyAnnotation(foxit::pdf::PDFDoc^ doc);
				static bool GetIsDocumentCanFillInForm(foxit::pdf::PDFDoc^ doc);
				static bool GetIsDocumentCanAddComment(foxit::pdf::PDFDoc^ doc);

				static FS_FLOAT PixelToPDFPoint(foxit::pdf::PDFDoc^ doc, int pageIndex, int pixel);
				static double PDFPointToPixel(foxit::pdf::PDFDoc^ doc, int pageIndex, float PdfPoint, double dbPageRenderWidth, double dbPageRenderHeight);
				static Windows::UI::Xaml::Media::Imaging::WriteableBitmap^ GetThumbImageSync(foxit::pdf::PDFDoc^ doc, int pageIndex, int width, int height, int nRotate);

				static Windows::Foundation::Rect DeviceToPageRect(foxit::pdf::PDFDoc^ doc, int index, double dbStartX, double dbStartY, double dbSizeX, double dbSizeY, Windows::Foundation::Rect rcDevice, int nRotate);
				static Windows::Foundation::Rect PageToDeviceRect(foxit::pdf::PDFDoc^ doc, int index, double dbSizeX, double dbSizeY, Windows::Foundation::Rect rcPage, int nRotate);
				static Windows::Foundation::Rect PageToDeviceRect(foxit::pdf::PDFDoc^ doc, int index, double dbStartX, double dbStartY, double dbSizeX, double dbSizeY, Windows::Foundation::Rect rcPage, int nRotate);
				static Windows::Foundation::Point DeviceToPagePoint(foxit::pdf::PDFDoc^ doc, int index, double dbStartX, double dbStartY, double dbSizeX, double dbSizeY, Windows::Foundation::Point pt, int nRotate);
				static Windows::Foundation::Point PageToDevicePoint(foxit::pdf::PDFDoc^ doc, int index, double dbStartX, double dbStartY, double dbSizeX, double dbSizeY, Windows::Foundation::Point pt, int nRotate);

				static void PageParse(foxit::pdf::PDFPage^ page, foxit::pdf::ParseFlags flag = foxit::pdf::ParseFlags::e_ParsePageNormal);

				static bool IsValidBookmark(foxit::pdf::Bookmark^ pos);
			};
		}
	}
}
