/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#include "pch.h"
#include "CursorFactory.h"
#include "CustomCursorsFactory.h"

using namespace foxit::rdk::uiextensions;

static IFoxitCursorFactory^ m_CurrentFactory;

IFoxitCursorFactory^ FoxitCursorFactory::Current::get()
{
	if (!m_CurrentFactory)
	{
		m_CurrentFactory = ref new FoxitCustomCursorsFactory();
	}
	return m_CurrentFactory;
}

 void FoxitCursorFactory::SetCursorFactory(IFoxitCursorFactory^ value)
 {
	 if (value)
	 {
		 m_CurrentFactory = value;
	 }
 }
