/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#include "pch.h"
#include "CustomCursorsFactory.h"
#include "resource.h"

using namespace foxit::rdk::uiextensions;


FoxitCustomCursorsFactory::FoxitCustomCursorsFactory()
{

}

Windows::UI::Core::CoreCursor^ FoxitCustomCursorsFactory::GetNormalCursor()
{
	if (m_NormalCur == nullptr)
	{
		m_NormalCur = ref new Windows::UI::Core::CoreCursor(Windows::UI::Core::CoreCursorType::Arrow, 0);
	}
	return m_NormalCur;
}

Windows::UI::Core::CoreCursor^ FoxitCustomCursorsFactory::GetArrowCursor()
{
	if (m_ArrowCur == nullptr)
	{
		m_ArrowCur = ref new Windows::UI::Core::CoreCursor(Windows::UI::Core::CoreCursorType::Arrow, 0);
	}
	return m_ArrowCur;
}

Windows::UI::Core::CoreCursor^ FoxitCustomCursorsFactory::GetHandCursor()
{
	if (m_HandCur == nullptr)
	{
		m_HandCur = ref new Windows::UI::Core::CoreCursor(Windows::UI::Core::CoreCursorType::Hand, 0);
	}
	return m_HandCur;
}

Windows::UI::Core::CoreCursor^ FoxitCustomCursorsFactory::GetBusyCursor()
{
	if (m_BusyCur == nullptr)
	{
		m_BusyCur = ref new Windows::UI::Core::CoreCursor(Windows::UI::Core::CoreCursorType::Wait, 0);
	}
	return m_BusyCur;
}

Windows::UI::Core::CoreCursor^ FoxitCustomCursorsFactory::GetAnnotCursor()
{
	if (m_AnnotCur == nullptr)
	{
		m_AnnotCur = ref new Windows::UI::Core::CoreCursor(Windows::UI::Core::CoreCursorType::Custom, IDC_CURSOR_ANNOT);
	}
	return m_AnnotCur;
}

Windows::UI::Core::CoreCursor^ FoxitCustomCursorsFactory::GetLinkSelectCursor()
{
	if (m_LinkSelectCur == nullptr)
	{
		m_LinkSelectCur = ref new Windows::UI::Core::CoreCursor(Windows::UI::Core::CoreCursorType::Hand, 0);
	}
	return m_LinkSelectCur;
}

Windows::UI::Core::CoreCursor^ FoxitCustomCursorsFactory::GetTextSelectCursor()
{
	if (m_TextSelectCur == nullptr)
	{
		m_TextSelectCur = ref new Windows::UI::Core::CoreCursor(Windows::UI::Core::CoreCursorType::IBeam,0);
	}
	return m_TextSelectCur;
}

Windows::UI::Core::CoreCursor^ FoxitCustomCursorsFactory::GetTextHighlightCursor()
{
	if (m_TextHighlightCur == nullptr)
	{
		m_TextHighlightCur = ref new Windows::UI::Core::CoreCursor(Windows::UI::Core::CoreCursorType::Arrow, 0);
	}
	return m_TextHighlightCur;
}

Windows::UI::Core::CoreCursor^ FoxitCustomCursorsFactory::GetTextCommentCursor()
{
	if (m_TextCommentCur == nullptr)
	{
		m_TextCommentCur = ref new Windows::UI::Core::CoreCursor(Windows::UI::Core::CoreCursorType::Arrow, 0);
	}
	return m_TextCommentCur;
}

Windows::UI::Core::CoreCursor^ FoxitCustomCursorsFactory::GetTextStrikeCursor()
{
	if (m_TextStrikeCur == nullptr)
	{
		m_TextStrikeCur = ref new Windows::UI::Core::CoreCursor(Windows::UI::Core::CoreCursorType::Arrow, 0);
	}
	return m_TextStrikeCur;
}

Windows::UI::Core::CoreCursor^ FoxitCustomCursorsFactory::GetTextUnderlineCursor()
{
	if (m_TextUnderlineCur == nullptr)
	{
		m_TextUnderlineCur = ref new Windows::UI::Core::CoreCursor(Windows::UI::Core::CoreCursorType::Arrow, 0);
	}
	return m_TextUnderlineCur;
}

Windows::UI::Core::CoreCursor^ FoxitCustomCursorsFactory::GetDrawRectCursor()
{
	if (m_DrawRectCur == nullptr)
	{
		m_DrawRectCur = ref new Windows::UI::Core::CoreCursor(Windows::UI::Core::CoreCursorType::Arrow, 0);
	}
	return m_DrawRectCur;
}

Windows::UI::Core::CoreCursor^ FoxitCustomCursorsFactory::GetDrawPencilCursor()
{
	if (m_DrawPencilCur == nullptr)
	{
		m_DrawPencilCur = ref new Windows::UI::Core::CoreCursor(Windows::UI::Core::CoreCursorType::Cross,0);
	}
	return m_DrawPencilCur;
}

Windows::UI::Core::CoreCursor^ FoxitCustomCursorsFactory::GetDrawEllipseCursor()
{
	if (m_DrawEllipseCur == nullptr)
	{
		m_DrawEllipseCur = ref new Windows::UI::Core::CoreCursor(Windows::UI::Core::CoreCursorType::Arrow, 0);
	}
	return m_DrawEllipseCur;
}

Windows::UI::Core::CoreCursor^ FoxitCustomCursorsFactory::GetDrawLineCursor()
{
	if (m_DrawLineCur == nullptr)
	{
		m_DrawLineCur = ref new Windows::UI::Core::CoreCursor(Windows::UI::Core::CoreCursorType::Arrow, 0);
	}
	return m_DrawLineCur;
}