﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "FloatWindow\AnnotPropertyPhone.g.h"

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::UI::Xaml::Data::Bindable]
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class NoteStyleInfo sealed : public BindableBase
			{
			public:
				NoteStyleInfo();

				property Platform::String^ IconName
				{
					Platform::String^ get();
					void set(Platform::String^ value);
				}
				property Windows::UI::Xaml::Media::ImageSource^ IconImage
				{
					Windows::UI::Xaml::Media::ImageSource^ get();
					void set(Windows::UI::Xaml::Media::ImageSource^ value);
				}
				property Windows::UI::Xaml::Visibility IconIsChecked
				{
					Windows::UI::Xaml::Visibility get();
					void set(Windows::UI::Xaml::Visibility value);
				}
				property Platform::String^ IconTag
				{
					Platform::String^ get();
					void set(Platform::String^ value);
				}

			private:
				Platform::String^ _IconTag;
				Platform::String^ _IconName;
				Windows::UI::Xaml::Media::ImageSource^ _IconImage;
				Windows::UI::Xaml::Visibility _IconIsChecked;
			};


			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class AnnotPropertyPhone sealed
			{
			public:
				AnnotPropertyPhone(foxit::rdk::PDFViewCtrl^ view);

			internal:
				property foxit::rdk::PDFViewCtrl^ View
				{
					foxit::rdk::PDFViewCtrl^ get();
				}
				void HideNoteStylePopup();
				bool IsNoteStylePopupIsOpen();
				void SetPropertyToolIsEnabled(bool isEnable);
				void CloseBorderListPopup();
				void SetStampPopupClosed();
				void InitControlSize();
				void SetFreeTextPropertyIsShow(bool isShow, Platform::String^ title);

			private:
				Platform::WeakReference m_PageViewWeakRef;
				Windows::UI::Xaml::Controls::Primitives::Popup^ stampIconPopup;
				Windows::Foundation::EventRegistrationToken __windowSizeChangedEventRegistrationToken;

			private:
				void InitPropertyPanelVisible();
				void InitAppBarProperty();

			private:
				void NoteLogoSetting_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void ColorPageBtnSelect_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void OpacityPageBtnSelect_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void ExitProperty_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);

				void OnSizeChanged(Platform::Object ^sender, Windows::UI::Xaml::SizeChangedEventArgs ^e);
				void InitAnnotColorList(AnnotationType type);
				AnnotationType GetAnnotType(AnnotCreateType optType);
				void SetRadioColorChecked(Platform::String^ colorRGBValue, AnnotationType type);
				void AppBarButton_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnValueChanged(Platform::Object ^sender, Windows::UI::Xaml::Controls::Primitives::RangeBaseValueChangedEventArgs ^e);
				void OnValuePorChanged(Platform::Object ^sender, Windows::UI::Xaml::Controls::Primitives::RangeBaseValueChangedEventArgs ^e);
				void OnWindowsSizeChanged(Platform::Object ^sender, Windows::UI::Core::WindowSizeChangedEventArgs ^e);
				void bitBack_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
			};
		}
	}
}
