﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "FloatWindow\AnnotStampUserControl.g.h"

using namespace foxit::rdk;
namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class AnnotStampUserControl sealed
			{
			public:
				AnnotStampUserControl();
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void RelativePageView(PDFViewCtrl^ view);

			internal:
				property PDFViewCtrl^ View
				{
					PDFViewCtrl^ get();
				}

			private:
				Platform::WeakReference m_PageViewWeakRef;
				Windows::Foundation::EventRegistrationToken __windowSizeChangedEventRegistrationToken;

			private:
				void UpdateSignStampsList();
				void UpdateDefaultStampsList();
				void UpdateDynamicStampsList();

			private:
				Windows::Foundation::Collections::IVector<Windows::UI::Xaml::Media::ImageSource^>^ m_DefaultStampsVect;
				Windows::Foundation::Collections::IVector<Windows::UI::Xaml::Media::ImageSource^>^ m_SignStampsVect;
				Windows::Foundation::Collections::IVector<Windows::UI::Xaml::Media::ImageSource^>^ m_DynamicStampsVect;
				void btnStandard_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void defaultStampsGridView_ItemClick(Platform::Object^ sender, Windows::UI::Xaml::Controls::ItemClickEventArgs^ e);
				void customStampsGridView_ItemClick(Platform::Object^ sender, Windows::UI::Xaml::Controls::ItemClickEventArgs^ e);
				void dynamicStampsGridView_ItemClick(Platform::Object^ sender, Windows::UI::Xaml::Controls::ItemClickEventArgs^ e);
				void OnSizeChanged(Platform::Object ^sender, Windows::UI::Core::WindowSizeChangedEventArgs ^e);
			};
		}
	}
}
