﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#include "pch.h"
#include "DirectControl.xaml.h"

using namespace foxit::rdk::uiextensions;

using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;

// The User Control item template is documented at http://go.microsoft.com/fwlink/?LinkId=234236

DirectControl::DirectControl()
{
	InitializeComponent();

	this->Loaded += ref new Windows::UI::Xaml::RoutedEventHandler(this, &DirectControl::OnLoaded);
	this->Unloaded += ref new Windows::UI::Xaml::RoutedEventHandler(this, &DirectControl::OnUnloaded);
}


void DirectControl::OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e)
{
	m_LayoutGridTransform = ref new Windows::UI::Xaml::Media::CompositeTransform();
	m_LayoutGridTransform->TranslateX = 0;
	m_LayoutGridTransform->TranslateY = 0;
	gridDirector->RenderTransform = m_LayoutGridTransform;
}


void DirectControl::OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e)
{
	m_PageViewWeakRef = nullptr;
}

void DirectControl::RelatePageView(UIExtensionsManager^ view)
{
	m_PageViewWeakRef = view;
}

UIExtensionsManager^ DirectControl::View::get()
{
	return m_PageViewWeakRef.Resolve<UIExtensionsManager>();
}


void DirectControl::btnPageLeft_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e)
{
	if (View)
	{
		View->CreateGraphAnnotBySliderPage();
	}
}


void DirectControl::btnPageRight_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e)
{
	if (View)
	{
		View->CreateGraphAnnotBySliderPage();
	}
}


void DirectControl::btnPageDown_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e)
{
	if (View)
	{
		View->CreateGraphAnnotBySliderPage();
	}
}

void DirectControl::btnPageUp_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e)
{
	if (View)
	{
		View->CreateGraphAnnotBySliderPage();
	}
}


void DirectControl::Grid_ManipulationStarted(Platform::Object^ sender, Windows::UI::Xaml::Input::ManipulationStartedRoutedEventArgs^ e)
{
	
}


void DirectControl::Grid_ManipulationDelta(Platform::Object^ sender, Windows::UI::Xaml::Input::ManipulationDeltaRoutedEventArgs^ e)
{
	if (e->IsInertial)
	{
		return;
	}
	Windows::Foundation::Rect windowRect= Windows::UI::Xaml::Window::Current->Bounds;
	double xValue= m_LayoutGridTransform->TranslateX + e->Delta.Translation.X;
	double yValue= m_LayoutGridTransform->TranslateY + e->Delta.Translation.Y;

	if (xValue < -(windowRect.Width - 200))
		m_LayoutGridTransform->TranslateX = -(windowRect.Width - 200);
	else if (xValue >0)
		m_LayoutGridTransform->TranslateX = 0;
	else if (yValue < -(windowRect.Height - 100))
		m_LayoutGridTransform->TranslateY = -(windowRect.Height - 100);
	else if(yValue>0)
		m_LayoutGridTransform->TranslateY =0;
	else
	{
		m_LayoutGridTransform->TranslateY += e->Delta.Translation.Y;
		m_LayoutGridTransform->TranslateX += e->Delta.Translation.X;
	}
}


void DirectControl::Grid_ManipulationCompleted(Platform::Object^ sender, Windows::UI::Xaml::Input::ManipulationCompletedRoutedEventArgs^ e)
{

}




