﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#include "pch.h"
#include "DrawSignatureControl.xaml.h"

using namespace foxit::rdk::uiextensions;

using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;
using namespace Windows::UI::Input::Inking;
using namespace Windows::UI::Core;
using namespace Windows::Storage;

// The User Control item template is documented at http://go.microsoft.com/fwlink/?LinkId=234236

DrawSignatureControl::DrawSignatureControl()
{
	InitializeComponent();

	Windows::Storage::ApplicationDataContainer^ _localSettings = Windows::Storage::ApplicationData::Current->LocalSettings;
	auto _localSettingsValues = _localSettings->Values;
	auto _SettingDataCompositeValue = _localSettingsValues->HasKey(APPSETTINGKEY) ? dynamic_cast<Windows::Storage::ApplicationDataCompositeValue^>(_localSettingsValues->Lookup(APPSETTINGKEY)) : ref new Windows::Storage::ApplicationDataCompositeValue();
	bool _IsHasDefaultSig = false;
	if (!_SettingDataCompositeValue->HasKey(L"IsHasDefaultSignature"))
	{
		checkDefault->IsChecked = true;
	}

	InitInkAttributes();
}

void DrawSignatureControl::InitInkAttributes()
{
	InkPresenter^ mypresenter = myInkCanvas->InkPresenter;
	mypresenter->InputDeviceTypes = CoreInputDeviceTypes::Mouse | CoreInputDeviceTypes::Touch;
	InkDrawingAttributes^ myAttributes = mypresenter->CopyDefaultDrawingAttributes();
	myAttributes->Color = Windows::UI::Colors::Red;
	myAttributes->PenTip = PenTipShape::Rectangle;
	myAttributes->Size = Size(20, 6);
	mypresenter->UpdateDefaultDrawingAttributes(myAttributes);
}

void DrawSignatureControl::SaveDefaultSigFlag()
{
	Windows::Storage::ApplicationDataContainer^ _localSettings = Windows::Storage::ApplicationData::Current->LocalSettings;
	auto _localSettingsValues = _localSettings->Values;
	auto _SettingDataCompositeValue = _localSettingsValues->HasKey(APPSETTINGKEY) ? dynamic_cast<Windows::Storage::ApplicationDataCompositeValue^>(_localSettingsValues->Lookup(APPSETTINGKEY)) : ref new Windows::Storage::ApplicationDataCompositeValue();
	bool _IsHasDefaultSig = false;
	if (!_SettingDataCompositeValue->HasKey(L"IsHasDefaultSignature"))
	{
		_SettingDataCompositeValue->Insert(L"IsHasDefaultSignature", true);
	}
	_localSettingsValues->Insert(APPSETTINGKEY, _SettingDataCompositeValue);
}

UIExtensionsManager^ foxit::rdk::uiextensions::DrawSignatureControl::View::get()
{
	return m_viewWeakRef.Resolve<UIExtensionsManager>();
}

void foxit::rdk::uiextensions::DrawSignatureControl::RelatePageView(UIExtensionsManager^ view)
{
	m_viewWeakRef = view;
}


void foxit::rdk::uiextensions::DrawSignatureControl::AddSignature_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e)
{
	StorageFolder^ folder = ApplicationData::Current->LocalFolder;
	String^ path = folder->Path;
	int i = 0;

	bool isChecked = checkDefault->IsChecked->Value;

	if (checkDefault->IsChecked)
	{
		concurrency::create_task(ApplicationData::Current->LocalFolder->CreateFolderAsync("SignatureImg", Windows::Storage::CreationCollisionOption::OpenIfExists))
			.then([=](Windows::Storage::StorageFolder^ folder)
		{
			return folder->CreateFileAsync("SignatureDefault.png", Windows::Storage::CreationCollisionOption::OpenIfExists);
		})
			.then([=](Windows::Storage::StorageFile^ file)
		{
			return file->OpenAsync(FileAccessMode::ReadWrite);
		})
			.then([=](Windows::Storage::Streams::IRandomAccessStream^ stream)
		{
			myInkCanvas->InkPresenter->StrokeContainer->SaveAsync(stream);
		}).then([=](void) {
			if (View)
			{ 				
				View->HideDrawSignatureControl();
				SaveDefaultSigFlag();
			}
		});
	}
	else
	{
		concurrency::create_task(ApplicationData::Current->LocalFolder->CreateFolderAsync("SignatureImg", Windows::Storage::CreationCollisionOption::OpenIfExists))
			.then([=](Windows::Storage::StorageFolder^ folder)
		{
			return folder->CreateFileAsync("aa.png", Windows::Storage::CreationCollisionOption::OpenIfExists);
		})
			.then([=](Windows::Storage::StorageFile^ file)
		{
			return file->OpenAsync(FileAccessMode::ReadWrite);
		})
			.then([=](Windows::Storage::Streams::IRandomAccessStream^ stream)
		{
			myInkCanvas->InkPresenter->StrokeContainer->SaveAsync(stream);
		}).then([=](void) {
			if (View)
			{
				View->HideDrawSignatureControl();
			}
		});
	}
}


void foxit::rdk::uiextensions::DrawSignatureControl::btnCancle_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e)
{
	if (View)
		View->HideDrawSignatureControl();
}
