﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "FloatWindow\EyeProtectionModeControl.g.h"

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class EyeProtectionModeControl sealed
			{
			public:
				EyeProtectionModeControl();

			internal:
				void SetPageView(UIExtensionsManager^ view);

				property UIExtensionsManager^ View
				{
					UIExtensionsManager^ get();
				}

			private:
				Platform::WeakReference m_PageViewWeakRef;
				Windows::Foundation::EventRegistrationToken m_LayoutUpdatedToken;
				bool m_bIsLoaded;

			private:
				void OnInitializeControl();

			private:
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void RadioButton_Checked(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void RadioButton_DragStarting(Windows::UI::Xaml::UIElement^ sender, Windows::UI::Xaml::DragStartingEventArgs^ args);
				void RadioButton_Drop(Platform::Object^ sender, Windows::UI::Xaml::DragEventArgs^ e);
			};
		}
	}
}
