﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "FloatWindow\NoteStyleUserControl.g.h"
#include "Common\BindableBase.h"

using namespace foxit::rdk;
namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::UI::Xaml::Data::Bindable]
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class NoteIcoItem sealed : public BindableBase
			{
			public:
				NoteIcoItem();

				property Platform::String^ IconName
				{
					Platform::String^ get();
					void set(Platform::String^ value);
				}
				property Windows::UI::Xaml::Media::ImageSource^  IconBitmap
				{
					Windows::UI::Xaml::Media::ImageSource^ get();
					void set(Windows::UI::Xaml::Media::ImageSource^ value);
				}

			private:
				Platform::String^ _IconName;
				Windows::UI::Xaml::Media::ImageSource^ _IconBitmap;
			};


			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class NoteStyleUserControl sealed
			{
			public:
				NoteStyleUserControl();
				void RelateToView(PDFViewCtrl^ View);
				void InitNoteStyleHeight();

			internal:
				property PDFViewCtrl^ View
				{
					PDFViewCtrl^ get();
				}

			private:
				Platform::WeakReference m_PageViewWeakRef;
				Windows::Foundation::Collections::IVector<NoteIcoItem^>^ m_NoteImageVect;
				Windows::Foundation::EventRegistrationToken __windowSizeChangedEventRegistrationToken;

			private:
				void InitNoteImageList();

			private:
				void StackPanel_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void listNoteStyle_SelectionChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::SelectionChangedEventArgs^ e);
				void noteIconGridView_ItemClick(Platform::Object^ sender, Windows::UI::Xaml::Controls::ItemClickEventArgs^ e);
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnSizeChanged(Platform::Object ^sender, Windows::UI::Core::WindowSizeChangedEventArgs ^e);
			};
		}
	}
}
