﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#include "pch.h"
#include "NoteTipFloatControl.xaml.h"

using namespace foxit::rdk::uiextensions;
using namespace foxit::rdk;

using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;

// The User Control item template is documented at http://go.microsoft.com/fwlink/?LinkId=234236

NoteTipFloatControl::NoteTipFloatControl()
{
	InitializeComponent();
	InitHideAnimation();
}

void NoteTipFloatControl::InitHideAnimation()
{
	m_HideTimer = ref new Windows::UI::Xaml::DispatcherTimer();
	Windows::Foundation::TimeSpan _HideTimerTimeSpan;
	_HideTimerTimeSpan.Duration = 3 * 10000000;
	m_HideTimer->Interval = _HideTimerTimeSpan;
	m_HideTimer->Tick += ref new Windows::Foundation::EventHandler<Platform::Object ^>(this, &foxit::rdk::uiextensions::NoteTipFloatControl::OnTick);
}


void foxit::rdk::uiextensions::NoteTipFloatControl::OnTick(Platform::Object ^sender, Platform::Object ^args)
{
	Hide(true);
}

void foxit::rdk::uiextensions::NoteTipFloatControl::Activate()
{
	this->Visibility = Windows::UI::Xaml::Visibility::Visible;
	if (m_HideTimer->IsEnabled)
		m_HideTimer->Stop();
	m_HideTimer->Start();
}

void foxit::rdk::uiextensions::NoteTipFloatControl::Hide(bool isHideStoryboard)
{
	if (m_HideTimer)
	{
		m_HideTimer->Stop();
	}
	if (isHideStoryboard)
	{
		auto hideStoryboard = safe_cast<Windows::UI::Xaml::Media::Animation::Storyboard^>(this->Resources->Lookup("LabelSlowHideStoryboard"));
		if (hideStoryboard)
			hideStoryboard->Begin();
	}
	else
	{
		this->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
	}
}