﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "FloatWindow\PageNumberControl.g.h"
//#include "PageView.xaml.h"

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class PageNumberControl sealed
			{
			public:
				PageNumberControl(UIExtensionsManager^ view);
				void JumpToPage();
				void FocusNumberTextBox();

			internal:
				property UIExtensionsManager^ View
				{
					UIExtensionsManager^ get();
				}

			private:
				bool m_isPhoneHorizontalMode;
				Platform::WeakReference m_PageViewWeakRef;
				Windows::Foundation::EventRegistrationToken __windowSizeChangedEventRegistrationToken;
				Windows::Foundation::EventRegistrationToken __inputPaneShowingEventRegistrationToken, __inputPaneHidingEventRegistrationToken;

				void btnCancel_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void btnOk_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);

				bool IsValidString(Platform::String^ str);
				void UserControl_Loaded(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void UserControl_Unloaded(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void PageIndicatorText_KeyDown(Platform::Object^ sender, Windows::UI::Xaml::Input::KeyRoutedEventArgs^ e);
				void PageIndicatorText_GotFocus(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void OnSizeChanged(Platform::Object ^sender, Windows::UI::Core::WindowSizeChangedEventArgs ^e);
				void SetControlLayOut();
			};
		}
	}
}
