﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "FloatWindow\PageNumberShowControl.g.h"
//#include "UIExtensionsManager.xaml.h"

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class PageNumberShowControl sealed
			{
			public:
				PageNumberShowControl(UIExtensionsManager^ view);

			internal:
				property UIExtensionsManager^ View
				{
					UIExtensionsManager^ get();
				}
				void InitPageCurIndex(int pageIndex);
				void Activate();

			private:
				Platform::WeakReference m_PageViewWeakRef;
				Windows::UI::Xaml::DispatcherTimer^ m_HideTimer;

			private:
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void InitHideAnimation();
				void OnTick(Platform::Object ^sender, Platform::Object ^args);
			};
		}
	}
}
