﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "FloatWindow\PageSlideHorViewControl.g.h"
//#include "PageView.xaml.h"

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class PageSlideHorViewControl sealed
			{
			public:
				PageSlideHorViewControl();

			internal:
				property UIExtensionsManager^ View
				{
					UIExtensionsManager^ get();
				}

			public:
				void RelatePageView(UIExtensionsManager^ view);
				void InitPageNumText(int pageIndex);
				void CalculateStepOffset();

			private:
				Windows::UI::Xaml::Media::CompositeTransform^ m_LayoutGridTransform;
				Platform::WeakReference m_PageViewWeakRef;
				int m_pageCount;
				int m_pageIndex;
				double m_VerticalOffsetLeft;
				double m_VerticalOffsetRight;
				double m_stepOffset;
				double m_controlWidth;
				double m_AppBarHeight;
				double m_SliderViewWidth;

			private:
				void Grid_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void UserControl_Loaded(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void OnManipulationDelta(Platform::Object ^sender, Windows::UI::Xaml::Input::ManipulationDeltaRoutedEventArgs ^e);
				void OnManipulationCompleted(Platform::Object ^sender, Windows::UI::Xaml::Input::ManipulationCompletedRoutedEventArgs ^e);
				void OnManipulationStarted(Platform::Object ^sender, Windows::UI::Xaml::Input::ManipulationStartedRoutedEventArgs ^e);
			};
		}
	}
}
