﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#include "pch.h"
#include "PhoneAnnotTipControl.xaml.h"

using namespace foxit::rdk::uiextensions;

using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;

// The User Control item template is documented at http://go.microsoft.com/fwlink/?LinkId=234236

PhoneAnnotTipControl::PhoneAnnotTipControl()
{
	InitializeComponent();
}

Platform::String^ PhoneAnnotTipControl::GetResourceString(Platform::String^ str)
{
	auto resourceLoader = Windows::ApplicationModel::Resources::ResourceLoader::GetForCurrentView("foxit.rdk.uiextensions/Resources");
	return resourceLoader->GetString(str);
}

void PhoneAnnotTipControl::InitMobileCurAnnotTip(AnnotCreateType type)
{
	auto _bitmapImage = ref new Windows::UI::Xaml::Media::Imaging::BitmapImage();
	Uri^ url = ref new Uri("ms-appx:///foxit.rdk.uiextensions/Assets/Annot/" + "highlight.png");

	Platform::String^ annotStr = GetResourceString(L"HighLightTipText");
	if (type == AnnotCreateType::AreaHighLight)
	{
		url = ref new Uri("ms-appx:///foxit.rdk.uiextensions/Assets/Annot/" + "AreaHighLight.png");
		annotStr = GetResourceString(L"AreaHightLightTipText");
	}
	else if (type == AnnotCreateType::StrikeOut)
	{
		url = ref new Uri("ms-appx:///foxit.rdk.uiextensions/Assets/Annot/" + "strikeout.png");
		annotStr = GetResourceString(L"StrikeOutTipText");
	}
	else if (type == AnnotCreateType::UnderLine)
	{
		url = ref new Uri("ms-appx:///foxit.rdk.uiextensions/Assets/Annot/" + "underline.png");
		annotStr = GetResourceString(L"UnderLineTipText");
	}
	else if (type == AnnotCreateType::Squiggly)
	{
		url = ref new Uri("ms-appx:///foxit.rdk.uiextensions/Assets/Annot/" + "Squiggly.png");
		annotStr = GetResourceString(L"SquigglyTipText");
	}
	else if (type == AnnotCreateType::Text)
	{
		url = ref new Uri("ms-appx:///foxit.rdk.uiextensions/Assets/Annot/" + "note.png");
		annotStr = GetResourceString(L"CommentTipText");
	}
	else if (type == AnnotCreateType::Pencil)
	{
		url = ref new Uri("ms-appx:///foxit.rdk.uiextensions/Assets/Annot/" + "pencil.png");
		annotStr = GetResourceString(L"InkTipText");
	}
	else if (type == AnnotCreateType::Square)
	{
		url = ref new Uri("ms-appx:///foxit.rdk.uiextensions/Assets/Annot/" + "square.png");
		annotStr = GetResourceString(L"SquareTipText");
	}
	else if (type == AnnotCreateType::Circle)
	{
		url = ref new Uri("ms-appx:///foxit.rdk.uiextensions/Assets/Annot/" + "oval.png");
		annotStr = GetResourceString(L"CircleTipText");
	}
	else if (type == AnnotCreateType::Line)
	{
		url = ref new Uri("ms-appx:///foxit.rdk.uiextensions/Assets/Annot/" + "line.png");
		annotStr = GetResourceString(L"LineTipText");
	}
	else if (type == AnnotCreateType::Arrow)
	{
		url = ref new Uri("ms-appx:///foxit.rdk.uiextensions/Assets/Annot/" + "arrow.png");
		annotStr = GetResourceString(L"ArrowTipText");
	}
	else if (type == AnnotCreateType::Stamp)
	{
		url = ref new Uri("ms-appx:///foxit.rdk.uiextensions/Assets/Annot/" + "stamp.png");
		annotStr = GetResourceString(L"StampTipText");
	}
	else if (type == AnnotCreateType::Eraser)
	{
		url = ref new Uri("ms-appx:///foxit.rdk.uiextensions/Assets/Annot/" + "eraser.png");
		annotStr = GetResourceString(L"EraserTipText");
	}
	else if (type == AnnotCreateType::FreeText)
	{
		url = ref new Uri("ms-appx:///foxit.rdk.uiextensions/Assets/Annot/" + "typewriter.png");
		annotStr = GetResourceString(L"TypewriterTipText");
	}
	else if (type == AnnotCreateType::Caret)
	{
		url = ref new Uri("ms-appx:///foxit.rdk.uiextensions/Assets/Annot/" + "InsertText.png");
		annotStr = GetResourceString(L"InsertTextTipText");
	}
	else if (type == AnnotCreateType::ReplaceText)
	{
		url = ref new Uri("ms-appx:///foxit.rdk.uiextensions/Assets/Annot/" + "ReplaceText.png");
		annotStr = GetResourceString(L"ReplaceTextTipText");
	}
	_bitmapImage->UriSource = url;
	imgAnnot->Source = _bitmapImage;
	tbCurAnnotNmae->Text = annotStr;
}
