﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "FloatWindow\ReflowViewAppBar.g.h"

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			ref class MainPageAppBar;
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class ReflowViewAppBar sealed
			{
			public:
				ReflowViewAppBar();

			internal:
				property MainPageAppBar^ MainAppBar
				{
					MainPageAppBar^ get();
				}

				property bool IsMobilePlatform
				{
					bool get();
				}

				void UpdateControlState();
				void SetAppBarIsCompact(bool isCompact);

			private:
				Platform::WeakReference m_MainAppBarWeakRef;
				bool m_IsMobilePlatform;

			private:
				void OnInitializeControl();
				void UpdateViewFontSizeBtnState();
				void UpdateFlipPageBtnState();

				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void IncreaseFontSizeBtn_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void ReduceFontSizeBtn_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void PrevPageBtn_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void NextPageBtn_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void OutlineBtn_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void ShowPageBtn_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void NotShowPageBtn_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void ExitAppBarBtn_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
			};
		}
	}
}
