﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "FloatWindow\ViewToolAppBar.g.h"

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			ref class MainPageAppBar;
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class ViewToolAppBar sealed
			{
			public:
				ViewToolAppBar(foxit::rdk::PDFViewCtrl^ view, MainPageAppBar^ appbar);


			internal:
				property foxit::rdk::PDFViewCtrl^ View
				{
					foxit::rdk::PDFViewCtrl^ get();
				}

				property MainPageAppBar^ MainAppBar
				{
					MainPageAppBar^ get();
				}
				void ResetToolSize();

				property Windows::UI::Xaml::Controls::Primitives::Popup^ HostedPopup
				{
					Windows::UI::Xaml::Controls::Primitives::Popup^ get();
				}

			private:
				Platform::WeakReference m_PageViewWeakRef;
				Platform::WeakReference m_AppBarWeakRef;
				Platform::WeakReference m_HostedPopupWeakRef;

			private:
				void OnInitViewToolPanel();
				void OnContinuousPageView();
				void OnSinglePageView();
				void OnDayModePageView();
				void OnDarkModePageView();
				void OnLeftRotatePageView();
				void OnRightRotatePageView();
				void OnReflowPageView();
				void OnThumbnailPageView();

			private:
				void ClosePopup();

			private:
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void ContinuousPageCommandPC_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void SinglePageCommandPC_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void DayModeCommandPC_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void DarkModeCommandPC_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void LeftRotateCommandPC_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void RightRotateCommandPC_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void ReflowPageCommandPC_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void ThumbnailPageCommandPC_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void ContinuousPageCommand_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void SinglePageCommand_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void DayModeCommand_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void DarkModeCommand_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void RightRotateCommand_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void LeftRotateCommand_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void ReflowPageCommand_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void ThumbnailPageCommand_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void EyeProtectionMode_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void CommandPC_PointerEntered(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				void CommandPC_PointerExited(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
			};
		}
	}
}
