﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "FormFiller/FormControlListControl.g.h"

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::UI::Xaml::Data::Bindable]
			public ref class FormControlListItem sealed : foxit::rdk::uiextensions::BindableBase
			{
			internal:
				FormControlListItem(foxit::pdf::interform::ChoiceOption^ choiceOption);

			public:
				property Platform::String^ Label
				{
					Platform::String^ get();
				}

				property bool IsSelected
				{
					bool get();
					void set(bool value);
				}

			internal:
				foxit::pdf::interform::ChoiceOption^ _ChoiceOption;

			private:
				Platform::String^ _Label;
			};


			public ref class FormControlListItemGroup sealed : foxit::rdk::uiextensions::BindableBase
			{
			internal:
				FormControlListItemGroup(foxit::pdf::interform::Form^ form, foxit::pdf::annots::IAnnot^ annot);

			public:
				property Windows::Foundation::Collections::IVector<FormControlListItem^>^ Group
				{
					Windows::Foundation::Collections::IVector<FormControlListItem^>^ get();
				}

				property int DefaultSelectIndex
				{
					int get();
				}

				property int SelectIndex
				{
					int get();
				}

				bool IsDataChanged();

				void ReleaseFormResource();
				void UpdateToDocument();

			internal:
				foxit::pdf::annots::IAnnot^ GetSdkAnnot();

			private:
				int GetSelectIndexFromSdk();

			private:
				foxit::pdf::interform::ChoiceOptionArray^ m_ChoiceOption;
				int m_DefaultSelectIndex;
				int m_SelectIndex;
				int m_InitializeSelectedIndex;
				Platform::Collections::Vector<FormControlListItem^>^ _Group;
				foxit::pdf::interform::Form^ m_pSdkForm;
				foxit::pdf::annots::IAnnot^ m_pAnnot;
			};

			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class FormControlListControl sealed
			{
			public:
				FormControlListControl();

			internal:
				property foxit::rdk::PDFViewCtrl^ View
				{
					foxit::rdk::PDFViewCtrl^ get();
				}

				void SetPageView(foxit::rdk::PDFViewCtrl^ view);
				void InitDataListSource(FormControlListItemGroup^ data);

			private:
				void OnInitializeControl();
				void InitDataList();
				void UpdateControlSize();

			private:
				Windows::Foundation::EventRegistrationToken m_WindowSizeChangedEventToken;
				Platform::WeakReference m_PageViewWeakRef;
				FormControlListItem^ m_PrevControlItem;
				FormControlListItemGroup^ m_ItemsGroup;
				int m_InitializeSelectedIndex;

			private:
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnWindowSizeChanged(Platform::Object ^sender, Windows::UI::Core::WindowSizeChangedEventArgs ^e);
				void FormControlListView_SelectionChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::SelectionChangedEventArgs^ e);
			};
		}
	}
}
