﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class FormControlTextBox sealed : public Windows::UI::Xaml::Controls::TextBox
			{
			public:
				FormControlTextBox();

				void SetPageView(foxit::rdk::PDFViewCtrl^ view);

			internal:
				property foxit::rdk::PDFViewCtrl^ View
				{
					foxit::rdk::PDFViewCtrl^ get();
				}

				void ResetInputText();

			protected:
				void OnApplyTemplate() override;
				void OnKeyDown(Windows::UI::Xaml::Input::KeyRoutedEventArgs^ e) override;
				void OnKeyUp(Windows::UI::Xaml::Input::KeyRoutedEventArgs^ e) override;

			private:
				Windows::UI::Xaml::Controls::ContentControl^ m_PlaceholderTextContentPresenter;
				Platform::WeakReference m_PageViewWeakRef;
				Windows::System::VirtualKey m_KeyDownVirtualKey;
				Platform::String^ m_PrevInputString;

			private:
				void OnInitializeControl();
				void HookUpEvents();
				void UnHookEvents();
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnControlKeyDown(Platform::Object ^sender, Windows::UI::Xaml::Input::KeyRoutedEventArgs ^e);
				void OnTextChanging(Windows::UI::Xaml::Controls::TextBox ^sender, Windows::UI::Xaml::Controls::TextBoxTextChangingEventArgs ^args);
				void OnTextChanged(Platform::Object ^sender, Windows::UI::Xaml::Controls::TextChangedEventArgs ^e);
				void OnTextCompositionStarted(Windows::UI::Xaml::Controls::TextBox ^sender, Windows::UI::Xaml::Controls::TextCompositionStartedEventArgs ^args);
				void OnTextCompositionChanged(Windows::UI::Xaml::Controls::TextBox ^sender, Windows::UI::Xaml::Controls::TextCompositionChangedEventArgs ^args);
				void OnTextCompositionEnded(Windows::UI::Xaml::Controls::TextBox ^sender, Windows::UI::Xaml::Controls::TextCompositionEndedEventArgs ^args);
			};
		}
	}
}
