﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "FormFiller\FormOperationBarControl.g.h"

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			ref class PDFViewCtrl;
			ref class FormControlListItemGroup;
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class FormOperationBarControl sealed
			{
			public:
				FormOperationBarControl();

			internal:
				property foxit::rdk::PDFViewCtrl^ View
				{
					foxit::rdk::PDFViewCtrl^ get();
				}

				void SetPageView(foxit::rdk::PDFViewCtrl^ view);

				void UpdateControlState();
				void UpdateControlPosition();

				void OpenFormListControl();

			private:
				void OnInitializeControl();
				bool IsHitElement(Windows::Foundation::Point pt, Windows::UI::Xaml::FrameworkElement^ frameworkElement);

			private:
				void HookUpInputPaneEvent();
				void UnHookInputPaneEvent();

			private:
				Windows::Foundation::EventRegistrationToken m_WindowSizeChangedEventToken;
				Platform::WeakReference m_PageViewWeakRef;
				FormControlListItemGroup^ m_ItemsGroup;

				bool m_bIsShowInputPane;
				bool m_PrevInputPaneEnsuredFocusedElementInView;
				Windows::UI::Xaml::Media::TranslateTransform^ m_InputPaneTranslateTransform;
				Windows::Foundation::EventRegistrationToken m_InputPaneShowingEventToken, m_InputPaneHidingEventToken;

			private:
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnWindowSizeChanged(Platform::Object ^sender, Windows::UI::Core::WindowSizeChangedEventArgs ^e);
				void PrevButton_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void NextButton_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void FormOperationBarControlClearFieldButton_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void FormOperationBarControlCompleteButton_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void OnShowing(Windows::UI::ViewManagement::InputPane ^sender, Windows::UI::ViewManagement::InputPaneVisibilityEventArgs ^args);
				void OnHiding(Windows::UI::ViewManagement::InputPane ^sender, Windows::UI::ViewManagement::InputPaneVisibilityEventArgs ^args);
				void ListControlPopup_Opened(Platform::Object^ sender, Platform::Object^ e);
				void BarGrid_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void ListControlPopup_Closed(Platform::Object^ sender, Platform::Object^ e);
			};
		}
	}
}
