/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			class PDFFormImplementor;
			class foxit::rdk::PDFViewCtrl;
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class PDFFormAbstration sealed
			{
			public:
				bool InitializeModule(foxit::rdk::PDFViewCtrl^ viewControl);
				void ReleaseModule();

				void BeginFormFiller();
				void EndFormFiller();

			internal:
				static PDFFormAbstration^ ConcreatePDFFormAbstration(PDFFormImplementor* pImpl);

				void Form_PointerPressed(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				void Form_PointerMoved(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				void Form_PointerReleased(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);

			private:
				PDFFormAbstration(PDFFormImplementor* pImpl);

			private:
				PDFFormImplementor* m_pImplementor;
			};
		}
	}
}

