/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#include "pch.h"
#include "PDFFormAbstraction.h"
#include "PDFFormImplementor.h"

using namespace foxit::rdk::uiextensions;

using namespace Platform;
using namespace Windows::UI::Xaml;
using namespace Windows::Foundation;

PDFFormAbstration::PDFFormAbstration(PDFFormImplementor* pImpl) : m_pImplementor(pImpl)
{

}

PDFFormAbstration^ PDFFormAbstration::ConcreatePDFFormAbstration(PDFFormImplementor* pImpl)
{
	auto pPdfFormAbs = ref new PDFFormAbstration(pImpl);

	return pPdfFormAbs;
}

bool PDFFormAbstration::InitializeModule(foxit::rdk::PDFViewCtrl^ viewControl)
{
	return m_pImplementor ? m_pImplementor->Initialize(viewControl) : false; 
}

void PDFFormAbstration::ReleaseModule()
{
	if (m_pImplementor)
	{
		m_pImplementor->Release();
	}
}

void PDFFormAbstration::BeginFormFiller()
{
	if (m_pImplementor)
	{
		m_pImplementor->BeginFormFiller();
	}
}

void PDFFormAbstration::EndFormFiller()
{
	if (m_pImplementor)
	{
		m_pImplementor->EndFormFiller();
	}
}

void PDFFormAbstration::Form_PointerPressed(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e)
{
}

void PDFFormAbstration::Form_PointerMoved(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e)
{

}

void PDFFormAbstration::Form_PointerReleased(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e)
{

}
