﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "MainSecondaryCommandBar.g.h"

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			ref class MainPageAppBar;
			ref class AnnotationsPage;
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class MainSecondaryCommandBar sealed
			{
			public:
				MainSecondaryCommandBar();

			internal:
				property MainPageAppBar^ MainAppBar
				{
					MainPageAppBar^ get();
				}

				void RelateMainAppBar(MainPageAppBar^ mainAppBar);
				void SetPanelWidth(double widthValue);
				void UpdateUnRedoState();
				void UpdateBtnState();
				void SetSaveBtnUnEnabled();
				void ResetScrollViewHeight();
				double GetActualHeight();

			private:
				Platform::WeakReference m_MainAppBarWeakRef;
				bool m_bIsFlyoutShow;
				Windows::Foundation::EventRegistrationToken m_WindowSizeChangedEventToken;
				foxit::rdk::uiextensions::AnnotationsPage^ m_AnnotationsPage;

			private:
				void secondaryCommand_PointerExited(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				void appBarUndo_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void appBarRedo_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void appBarSave_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void appBarSaveAs_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void appBarShareContent_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void HideAnnotBar_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void ShowAnnotBar_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void AnnotationsPage_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void FileProperty_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void ResetFormButton_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnClosed(Platform::Object ^sender, Platform::Object ^args);
				void ImportFormDataButton_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void ExportFormDataButton_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void SubscribeButton_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void SubscribeManageButton_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
			};
		}
	}
}
