﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "PropertyPage.g.h"

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class PropertyPage sealed
			{
			public:
				PropertyPage(foxit::rdk::PDFViewCtrl^ viewcontrol);

			protected:
				virtual void OnNavigatedTo(Windows::UI::Xaml::Navigation::NavigationEventArgs^ e) override;

			private:
				void OnInitializePage(foxit::rdk::PDFViewCtrl^ viewcontrol);
				void InitFileProperty(foxit::rdk::PDFViewCtrl^ viewcontrol, foxit::pdf::PDFDoc^ doc);


			private:
				ProgressBarFactory^		m_pProgressBar;
				foxit::pdf::PDFDoc^ m_Document;
				Windows::Foundation::EventRegistrationToken m_HardwareButtonsBackPressed, m_SystemNavigationBackRequestedEventToken;

			private:
				void OnBackPressed(Platform::Object ^sender, Windows::Phone::UI::Input::BackPressedEventArgs ^args);
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnBackRequested(Platform::Object ^sender, Windows::UI::Core::BackRequestedEventArgs ^args);
			};
		}
	}
}
