﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#include "pch.h"
#include "SearchTextResultControl.xaml.h"

using namespace foxit::rdk::uiextensions;

using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;

// The User Control item template is documented at http://go.microsoft.com/fwlink/?LinkId=234236

SearchTextResultControl::SearchTextResultControl()
{
	InitializeComponent();

	OnInitializeComponent();
}

void SearchTextResultControl::OnInitializeComponent()
{
	m_IsLoad = false;
	SeachResultList->SelectionChanged += ref new SelectionChangedEventHandler(this, &SearchTextResultControl::ListViewSelChange);

	Loaded += ref new RoutedEventHandler(this, &SearchTextResultControl::OnLoaded);
	Unloaded += ref new RoutedEventHandler(this, &SearchTextResultControl::OnUnloaded);
}

void SearchTextResultControl::UpdateProgressControl(double value)
{
	if (value == 1.0)
	{
		if (ProgressPanel->Visibility == ::Visibility::Collapsed)
			ProgressPanel->Visibility = ::Visibility::Visible;

	}
	SearchSlider->Value = value;
}

void SearchTextResultControl::HideProgressControl()
{
	ProgressPanel->Visibility = ::Visibility::Collapsed;
}

void SearchTextResultControl::OnLoaded(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e)
{
	m_SizeChangedEventToken = this->SizeChanged += ref new Windows::UI::Xaml::SizeChangedEventHandler(this, &SearchTextResultControl::OnSizeChanged);
	m_WindowSizeChangedEventToken = Window::Current->SizeChanged += ref new Windows::UI::Xaml::WindowSizeChangedEventHandler(this, &SearchTextResultControl::OnWindowSizeChanged);

	if (this->Parent->GetType()->FullName == Popup::typeid->FullName)
	{
		auto popup = safe_cast<Windows::UI::Xaml::Controls::Primitives::Popup^>(this->Parent);

		_popupPoint = Point((float)popup->HorizontalOffset, (float)popup->VerticalOffset);
		popup->VerticalOffset = _popupPoint.Y - this->ActualHeight;
	}
	m_IsLoad = true;
}

void SearchTextResultControl::OnUnloaded(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e)
{

	if (m_SizeChangedEventToken.Value)
	{
		this->SizeChanged -= m_SizeChangedEventToken;
		m_SizeChangedEventToken.Value = 0;
	}
	if (m_WindowSizeChangedEventToken.Value)
	{
		Window::Current->SizeChanged -= m_WindowSizeChangedEventToken;
		m_WindowSizeChangedEventToken.Value = 0;
	}
}

void SearchTextResultControl::OnSizeChanged(Platform::Object^ sender, Windows::UI::Xaml::SizeChangedEventArgs^ e)
{
}

void SearchTextResultControl::OnWindowSizeChanged(Platform::Object^ sender, Windows::UI::Core::WindowSizeChangedEventArgs^ e)
{
	
}

void SearchTextResultControl::ListViewSelChange(Platform::Object^ sender, Windows::UI::Xaml::Controls::SelectionChangedEventArgs^ e)
{

}

void foxit::rdk::uiextensions::SearchTextResultControl::PageNoCheck(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e)
{

}
