﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "Text/SearchTextResultControl.g.h"

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			//ref class PDFViewCtrl;
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class SearchTextResultControl sealed
			{
			public:
				SearchTextResultControl();

			internal:
				void UpdateProgressControl(double value);
				void HideProgressControl();

			protected:
				void ListViewSelChange(Platform::Object^ sender, Windows::UI::Xaml::Controls::SelectionChangedEventArgs^ e);

			private:
				void OnInitializeComponent();
				void OnLoaded(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void OnUnloaded(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void OnSizeChanged(Platform::Object^ sender, Windows::UI::Xaml::SizeChangedEventArgs^ e);
				void OnWindowSizeChanged(Platform::Object^ sender, Windows::UI::Core::WindowSizeChangedEventArgs^ e);
				void PageNoCheck(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);

			private:
				bool m_IsLoad;
				Windows::Foundation::Point _popupPoint;
				Windows::Foundation::EventRegistrationToken m_VectorChangedEventToken;
				Windows::Foundation::EventRegistrationToken m_SizeChangedEventToken;
				Windows::Foundation::EventRegistrationToken m_WindowSizeChangedEventToken;
				Windows::Foundation::EventRegistrationToken m_HostingFrameworkElementLayupdateToken;
				Platform::WeakReference m_HostedViewWeakRef;
			};
		}
	}
}
