/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

namespace foxit {
	namespace rdk {
		namespace uiextensions {
			interface class ITextSearchDataItem;
		}
	}
}

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::UI::Xaml::Data::Bindable]
			public ref class TextSearchDataItem sealed : public ITextSearchDataItem
			{
			public:
				TextSearchDataItem()
				{
					_mVect = ref new Platform::Collections::Vector<Windows::Foundation::Rect>();
				}
				virtual ~TextSearchDataItem() {}

				property int PageNo
				{
					virtual int get()
					{
						return _PageNo;
					}
					virtual void set(int value)
					{
						_PageNo = value;
					}
				}
				property bool IsFirstResultInPage
				{
					virtual bool get()
					{
						return _IsFirstResultInPage;
					}
					virtual void set(bool value)
					{
						_IsFirstResultInPage = value;
					}
				}

				property int StartCharIndex
				{
					virtual int get()
					{
						return _StartCharIndex;
					}
					virtual void set(int value)
					{
						_StartCharIndex = value;
					}
				}
				property Windows::Foundation::Collections::IVector<Windows::Foundation::Rect>^ RectVect
				{
					virtual Windows::Foundation::Collections::IVector<Windows::Foundation::Rect>^ get()
					{
						return _mVect;
					}
				}

				property Platform::String^ ContextTillQuery
				{
					virtual Platform::String^ get()
					{
						return _ContextTillQuery;
					}
					virtual void set(Platform::String^ value)
					{
						_ContextTillQuery = value;
					}
				}
				property Platform::String^ Query
				{
					virtual Platform::String^ get()
					{
						return _Query;
					}
					virtual void set(Platform::String^ value)
					{
						_Query = value;
					}
				}
				property Platform::String^ ContextPostQuery
				{
					virtual Platform::String^ get()
					{
						return _ContextPostQuery;
					}
					virtual void set(Platform::String^ value)
					{
						_ContextPostQuery = value;
					}
				}

			private:
				int _PageNo;
				bool _IsFirstResultInPage;
				Platform::String^ _ContextTillQuery;
				Platform::String^ _Query;
				Platform::String^ _ContextPostQuery;
				int _StartCharIndex;
				Platform::Collections::Vector<Windows::Foundation::Rect>^ _mVect;
			};
		}
	}
}
