﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "Thumbnail/ExtractPageControl.g.h"

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			ref class ThumbnailPage;
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class ExtractPageControl sealed
			{
			public:
				ExtractPageControl();

			internal:
				property ThumbnailPage^ HostPage
				{
					ThumbnailPage^ get();
				}

				void SetHostedPage(ThumbnailPage^ page);

			private:
				bool m_PrevInputPaneEnsuredFocusedElementInView;
				bool m_bIsShowInputPane;
				Windows::UI::Xaml::Media::TranslateTransform^ m_InputPaneTranslateTransform;

				Windows::Foundation::EventRegistrationToken m_InputPaneShowingEventToken, m_InputPaneHidingEventToken;
				Windows::Foundation::EventRegistrationToken m_WindowSizeChangedEventToken;

				Platform::WeakReference m_HostPageWeakRef;

				double m_LayoutRootGridMinWidth;

				Platform::Collections::Vector<int>^ m_ExtractPageIndexVect;

				Windows::Storage::StorageFolder^ m_LocateStorageFolder;

			private:
				void OnInitializeControl();
				void UpdateControlState();
				void UpdateControlPosition();
				void ClosePopup();
				void ResizeLayoutRoot();
				void UpdatePageRangeTextBox();
				Platform::String^ GetPageRangeStringFromHostPage();
				Platform::String^ GetPageRangeString(Windows::Foundation::Collections::IVector<int>^ pageIndexVect);
				bool ParsePageRangeString(Platform::String^ pageRangeStr, Windows::Foundation::Collections::IVector<int>^ pageIndexVect);
				bool IsValidPdfFileName(Platform::String^ fileName);

				void ShowNoneErrorTips();
				void ShowInvalidRangeErrorTips();
				void ShowInvalidFolderErrorTips();

			private:
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnInputPaneShowing(Windows::UI::ViewManagement::InputPane ^sender, Windows::UI::ViewManagement::InputPaneVisibilityEventArgs ^args);
				void OnInputPaneHiding(Windows::UI::ViewManagement::InputPane ^sender, Windows::UI::ViewManagement::InputPaneVisibilityEventArgs ^args);
				void OnWindowSizeChanged(Platform::Object ^sender, Windows::UI::Core::WindowSizeChangedEventArgs ^e);
				void ClosePopupButton_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void ExtractPageControlSureButton_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void ExtractPageControlCancelButton_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void ExtractPageControlPageRangeTextBox_TextChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::TextChangedEventArgs^ e);
				void ExtractPageControlBrowserButton_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
			};
		}
	}
}
