﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "Thumbnail/ThumbnailItemUserControl.g.h"

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			ref class ThumbnailItem;
			ref class ThumbnailPage;
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class ThumbnailItemUserControl sealed : Windows::UI::Xaml::Data::INotifyPropertyChanged
			{
			public:
				ThumbnailItemUserControl();


				static property Windows::UI::Xaml::DependencyProperty^ PageNumberProperty
				{
					Windows::UI::Xaml::DependencyProperty^ get();
				}

				virtual event Windows::UI::Xaml::Data::PropertyChangedEventHandler^ PropertyChanged;

				property int PageNumber
				{
					int get();
					void set(int value);
				}

			internal:
				void ShowPlaceholder(ThumbnailItem^ item, ThumbnailPage^ page);
				void ShowImage();
				void ClearData();

			private:
				ThumbnailItem^ m_ThumbnailItem;
				Platform::WeakReference m_ThumbnailPageWeakRef;
				concurrency::cancellation_token_source m_Cts;
				int m_PageIndex;

			private:
				void OnInitializeControl();
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
			};
		}
	}
}
