﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "Toolkit/DefaultProgressingUserControl.g.h"
#include "IProgressBar.h"

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class DefaultProgressingUserControl sealed : IProgressBar
			{
			public:
				DefaultProgressingUserControl();

			public:
				virtual Platform::Object^ GetContent();
				virtual Windows::UI::Color GetBackgroundColor();
				virtual void SetBackgroundColor(Windows::UI::Color color);
				virtual Windows::UI::Color GetForegroundColor();
				virtual void SetForegroundColor(Windows::UI::Color color);

			private:
				Windows::Foundation::EventRegistrationToken m_WindowSizeChangedEventToken;
				Windows::UI::Xaml::Controls::Primitives::Popup^ m_ParentPopup;

			private:
				void AttachWindowSizeChangedHandlers();
				void DetachWindowSizeChangedHandlers();

			private:
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnWindowSizeChanged(Platform::Object ^sender, Windows::UI::Core::WindowSizeChangedEventArgs ^e);
			};
		}
	}
}