/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
#define FOXIT_ENABLE_LOG
			//#undef FOXIT_ENABLE_LOG

			/// 5 levels of informationDEBUGINFOWARNINGERRORFATAL
#define FOXIT_LOG_LEVEL_DEBUG		1
#define FOXIT_LOG_LEVEL_INFO		2
#define FOXIT_LOG_LEVEL_WARNING		3
#define FOXIT_LOG_LEVEL_ERROR		4
#define FOXIT_LOG_LEVEL_FATAL		5

			class LogRealize sealed
			{
				static LogRealize*				m_instance;
			public:
				LogRealize();
				static LogRealize* GetInstance();

			public:
				static	void OutputMsg(int msgType, Platform::String^ msg);
				static void WriteMsgToLogFile(Platform::String^ msg);
				static void LogFileOutMsgFormat(char* pszFormat, ...);

			private:
				static char * ConvertToCharStr(Platform::String^ outMsg);
			};
		}
	}
}