﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class MessageDlg sealed : public Windows::UI::Xaml::Controls::ContentControl
			{
			public:
				MessageDlg();

			public:
				property Windows::UI::Xaml::Controls::Primitives::Popup^ ChildWindowPopup
				{
					Windows::UI::Xaml::Controls::Primitives::Popup^ get();
				}

				property Platform::Object^ MessageContent
				{
					Platform::Object^ get();
					void set(Platform::Object^ value);
				}
				property bool IsOpen
				{
					bool get();
				}
				void Hide();
				void Show();
				void SetIsBackToPreFrame(bool isGoBack);

			public:
				void OnApplyTemplate() override;
				static property Windows::UI::Xaml::DependencyProperty^ IsStoreAppBarStateProperty
				{
					Windows::UI::Xaml::DependencyProperty^ get();
				}
				static void OnIsStoreAppBarStatePropertyChanged(Windows::UI::Xaml::DependencyObject^ obj, Windows::UI::Xaml::DependencyPropertyChangedEventArgs^ args);

				property bool IsStoreAppBarState
				{
					bool get();
					void set(bool value);
				}

			private:
				Windows::UI::Xaml::Controls::ContentPresenter^ m_Body;
				Windows::UI::Xaml::Shapes::Rectangle^ m_BackgroundRect;
				Windows::UI::Xaml::Visibility m_AppBarVisual;
				Windows::Foundation::EventRegistrationToken m_BackPresseEventToken;
				Windows::UI::Xaml::Controls::Primitives::Popup^ m_ChildWindowPopup;
				Windows::Foundation::EventRegistrationToken __windowSizeChangedEventRegistrationToken;
				bool m_isGoBack;

			private:
				void InitializeMessagePrompt();
				static property Windows::UI::Xaml::Controls::Page^ Page
				{
					Windows::UI::Xaml::Controls::Page^ get();
				}
				static property Windows::UI::Xaml::Controls::Frame^ RootVisual
				{
					Windows::UI::Xaml::Controls::Frame^ get();
				}

				void HardwareButtons_BackPressed(Platform::Object^ sender, Windows::Phone::UI::Input::BackPressedEventArgs^ e);
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnWindowSizeChanged(Platform::Object ^sender, Windows::UI::Core::WindowSizeChangedEventArgs ^e);
			};
		}
	}
}