/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			interface class IProgressBar;
			public interface class IProgressBarFactory
			{
				void Show();
				void Close();

				IProgressBar^ GetProgressBar();
			};

			public ref class ProgressBarFactory sealed : IProgressBarFactory
			{
			public:
				ProgressBarFactory();

				virtual void Show();
				virtual void Close();

				virtual IProgressBar^ GetProgressBar();

			private:
				Windows::UI::Xaml::Controls::Primitives::Popup^ m_Popup;
				Windows::UI::Xaml::UIElement^ m_PopupContent;
				IProgressBar^ m_PragressBar;
				Windows::Foundation::EventRegistrationToken m_BackPresseEventToken;
				Windows::UI::Xaml::Visibility m_AppBarVisual;
				void OnPopupOpened(Platform::Object ^sender, Platform::Object ^args);
				void OnPopupClosed(Platform::Object ^sender, Platform::Object ^args);
				void HardwareButtons_BackPressed(Platform::Object^ sender, Windows::Phone::UI::Input::BackPressedEventArgs^ e);
			};
		}
	}
}