/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			interface class IProgressBarFactory;
			ref class MessageDlg;
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class UtilityToolsFactory sealed
			{
			public:
				static IProgressBarFactory^ GetProgressBarFactory();

				static MessageDlg^ GetMessageDlg();

				static void Test();
			};

			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class ComputationalSegment  sealed
			{
			public:
				ComputationalSegment() { m_ptIntersection.X = -1; m_ptIntersection.Y = -1; }

				int	LineSegmentCross(Windows::Foundation::Point a, Windows::Foundation::Point b, Windows::Foundation::Point c, Windows::Foundation::Point d);
				Windows::Foundation::Point GetIntersectionPoint() { return m_ptIntersection; }
				bool IsLineSegmentRectIntersection(Windows::Foundation::Point start_p, Windows::Foundation::Point end_p, Windows::Foundation::Rect rect);

			private:
				int	dblcmp(double d);
				double	det(double x1, double y1, double x2, double y2);
				double	cross(Windows::Foundation::Point a, Windows::Foundation::Point b, Windows::Foundation::Point c);
				double	dotdet(double x1, double y1, double x2, double y2);
				double	dot(Windows::Foundation::Point a, Windows::Foundation::Point b, Windows::Foundation::Point c);
				int		betweenCmp(Windows::Foundation::Point a, Windows::Foundation::Point b, Windows::Foundation::Point c);

			private:
				Windows::Foundation::Point m_ptIntersection;

			};
		}
	}
}