/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#include "pch.h"
#include "UICustomControlFactory.h"
#include "Thumbnail\ThumbnailPage.xaml.h"

using namespace foxit::rdk::uiextensions;

using namespace Platform;

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			ref class DefaultFoxitUICustomControlAdapter : IFoxitUICustomControlAdapter
			{
			public:
				virtual IThumbnailPage^ GetThumbnailPage()
				{
					return ref new ThumbnailPage();
				}

			internal:
				DefaultFoxitUICustomControlAdapter()
				{

				}
			};
		}
	}
}

FoxitUICustomControlFactory^ _Current;

FoxitUICustomControlFactory::FoxitUICustomControlFactory()
{
	m_Adapter = ref new DefaultFoxitUICustomControlAdapter();
}

FoxitUICustomControlFactory^ FoxitUICustomControlFactory::Current::get()
{
	if (_Current == nullptr)
	{
		_Current = ref new FoxitUICustomControlFactory();
	}

	return _Current;
}

void FoxitUICustomControlFactory::SetFoxitUICustomControlAdapter(IFoxitUICustomControlAdapter^ pAdapter)
{
	if (pAdapter)
	{
		m_Adapter = pAdapter;
	}
}

IThumbnailPage^ FoxitUICustomControlFactory::ConCreateThumbnailPage()
{
	return m_Adapter->GetThumbnailPage();
}
