﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#include "pch.h"
#include "UIHostedContorl.xaml.h"
#include "MainPageAppBar.xaml.h"

using namespace foxit::rdk::uiextensions;

using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;

// The User Control item template is documented at https://go.microsoft.com/fwlink/?LinkId=234236

FoxitUIHostedContorl::FoxitUIHostedContorl()
{
	InitializeComponent();

	OnInitializeControl();
}

void FoxitUIHostedContorl::OnInitializeControl()
{
	this->Loaded += ref new Windows::UI::Xaml::RoutedEventHandler(this, &foxit::rdk::uiextensions::FoxitUIHostedContorl::OnLoaded);
	this->Unloaded += ref new Windows::UI::Xaml::RoutedEventHandler(this, &foxit::rdk::uiextensions::FoxitUIHostedContorl::OnUnloaded);
}

foxit::rdk::PDFViewCtrl^ FoxitUIHostedContorl::View::get()
{
	return m_ViewWeakRef.Resolve<PDFViewCtrl>();
}

UIExtensionsManager^ FoxitUIHostedContorl::UIExtMgr::get()
{
	return m_UIViewWeakRef.Resolve<UIExtensionsManager>();
}

void FoxitUIHostedContorl::SetUIExtMgr(UIExtensionsManager^ pUIView)
{
	m_UIViewWeakRef = pUIView;
}

Windows::UI::Xaml::Controls::Grid^ FoxitUIHostedContorl::AppBarLayout::get()
{
	return mainAppBar;
}

 Windows::UI::Xaml::Controls::Grid^ FoxitUIHostedContorl::AppBarBottomLayout::get()
{
	 return mainAppBarBottom;
}

Windows::UI::Xaml::Controls::Grid^ FoxitUIHostedContorl::FlyoutPlacement::get()
{
	return FloutPanel;
}

void foxit::rdk::uiextensions::FoxitUIHostedContorl::OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e)
{
	OutputDebugString(L"FoxitUIHostedContorl::OnLoaded...\n");
	PDFViewCtrl^ pView = foxit::rdk::uiextensions::GetVisualParent<PDFViewCtrl^>(this);
	if (pView)
	{
		m_ViewWeakRef = pView;
	}

}

void foxit::rdk::uiextensions::FoxitUIHostedContorl::OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e)
{

}

void FoxitUIHostedContorl::StartSelHandle_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e)
{
	if (UIExtMgr->TextManager)
		UIExtMgr->TextManager->OnSelHandleClick(sender, e);
}

void FoxitUIHostedContorl::EndSelHandle_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e)
{
	if (UIExtMgr->TextManager)
		UIExtMgr->TextManager->OnSelHandleClick(sender, e);
}

void FoxitUIHostedContorl::appbarZoomIn_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e)
{
	double _scale = View->GetScale();
	double _dbMaxScale = View->GetMaxScale();
	if (_scale >= _dbMaxScale)
	{
		InitViewZoomInOut();
		return;
	}

	if (!UIExtMgr->GetIsCanScrollPageView())
		return;

	UIExtMgr->ExitAnnotPropertyMode();
	UIExtMgr->CloseAllPropertyPopup();
	UIExtMgr->StopZoomInOutTimer();

	_scale = _scale + 0.5;
	if (_scale > _dbMaxScale)
		_scale = _dbMaxScale;

	auto windowsRect = Windows::UI::Xaml::Window::Current->Bounds;
	View->ZoomTo(Point(windowsRect.X, windowsRect.Y), _scale, false, false);

	InitViewZoomInOut();
	UIExtMgr->StartZoomInOutTimer();
	
}

void FoxitUIHostedContorl::appbarZoomOut_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e)
{
	double _scale = View->GetScale();
	double _dbMinScale = View->GetMinScale();
	if (_scale <= _dbMinScale)
	{
		InitViewZoomInOut();
		return;
	}

	if (!UIExtMgr->GetIsCanScrollPageView())
		return;

	UIExtMgr->ExitAnnotPropertyMode();
	UIExtMgr->CloseAllPropertyPopup();
	UIExtMgr->StopZoomInOutTimer();

	_scale = _scale - 0.5;
	if (_scale < _dbMinScale)
	{
		_scale = _dbMinScale;
	}

	auto windowsRect = Windows::UI::Xaml::Window::Current->Bounds;
	View->ZoomTo(Point(windowsRect.X, windowsRect.Y), _scale, false, false);

	InitViewZoomInOut();
	UIExtMgr->StartZoomInOutTimer();
	
}

void FoxitUIHostedContorl::InitViewZoomInOut()
{
	double m_scale = View->GetScale();
	double maxScale = View->GetMaxScale();
	double minScale = View->GetMinScale();

	if (m_scale <= minScale)
	{
		appbarZoomOut->Opacity = 0.4;
	}
	else if (m_scale > minScale)
	{
		appbarZoomOut->Opacity = 1;
	}

	if (m_scale >= maxScale)
	{
		appbarZoomIn->Opacity = 0.4;
	}
	else
	{
		appbarZoomIn->Opacity = 1;
	}
}

void FoxitUIHostedContorl::StackPanel_PointerExited(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e)
{

}

void FoxitUIHostedContorl::StackPanel_PointerEntered(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e)
{

}

void FoxitUIHostedContorl::AnnotCanvas_PointerPressed(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e)
{

}

void FoxitUIHostedContorl::AnnotCanvas_PointerMoved(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e)
{

}

void FoxitUIHostedContorl::AnnotCanvas_PointerReleased(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e)
{

}

void FoxitUIHostedContorl::AnnotPropertyTipGird_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e)
{
	UIExtMgr->SetAnnotPropertyTipShow(false);
	if (UIExtMgr->GetMainAppBar())
		UIExtMgr->GetMainAppBar()->RestartTimeTick();
}

