﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "UIHostedContorl.g.h"

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class FoxitUIHostedContorl sealed
			{
			public:
				FoxitUIHostedContorl();

			internal:
				property PDFViewCtrl^ View
				{
					PDFViewCtrl^ get();
				}

				property UIExtensionsManager^ UIExtMgr
				{
					UIExtensionsManager^ get();
				}

				void SetUIExtMgr(UIExtensionsManager^ pUIView);

				property Windows::UI::Xaml::Controls::Grid^ AppBarLayout
				{
					Windows::UI::Xaml::Controls::Grid^ get();
				}

				property Windows::UI::Xaml::Controls::Grid^ AppBarBottomLayout
				{
					Windows::UI::Xaml::Controls::Grid^ get();
				}

				property Windows::UI::Xaml::Controls::Grid^ FlyoutPlacement
				{
					Windows::UI::Xaml::Controls::Grid^ get();
				}

			private:
				void StartSelHandle_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void EndSelHandle_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);

			private:
				Platform::WeakReference m_ViewWeakRef;
				Platform::WeakReference m_UIViewWeakRef;

			private:
				void OnInitializeControl();
				void InitViewZoomInOut();
			private:
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void appbarZoomIn_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void appbarZoomOut_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void StackPanel_PointerExited(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				void StackPanel_PointerEntered(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				void AnnotCanvas_PointerPressed(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				void AnnotCanvas_PointerMoved(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				void AnnotCanvas_PointerReleased(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e);
				void AnnotPropertyTipGird_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
			};
		}
	}
}
