/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			interface class IUndoItem;
			ref class DocUndo sealed
			{
			internal:
				DocUndo(int nBufsize = 1000);

			public:
				void Undo();
				void Redo();

				void AddItem(IUndoItem^ pItem);

				bool CanUndo();
				bool CanRedo();
				bool IsModified();
				bool IsWorking();

				void Reset();

				IUndoItem^ GetItem(int nIndex);
				int GetItemCount();
				int GetCurUndoPos();

				void DeleteItem(IUndoItem^ pItem);

			private:
				void SetBufSize(int nSize);
				int GetBufSize();

				void RemoveHeads();
				void RemoveTails();

			private:
				int	 m_nCurUndoPos;
				int	 m_nBufSize;
				bool m_bModified;
				bool m_bVirgin;
				bool m_bWorking;

				Platform::Collections::Vector<IUndoItem^>^ m_UndoItems;
			};
		}
	}
}

