/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			public interface class IUndoItem
			{
				void Undo();
				void Redo();
				Platform::String^ GetDescr();
				void ReleaseItem();
			};

			public delegate void UndoEventHandler(Platform::Object^ sender, Platform::Object^ args);
			public delegate void UndoOperaListChangedEventHandler(Platform::Object^ sender, Platform::Object^ args);

			[Windows::Foundation::Metadata::WebHostHidden]
			public interface class IUndo
			{
				bool IsUndoRedoing(UIExtensionsManager^ pDocument);
				bool CanUndo(UIExtensionsManager^ pDocument);
				bool CanRedo(UIExtensionsManager^ pDocument);

				void Undo(UIExtensionsManager^ pDocument);
				void Redo(UIExtensionsManager^ pDocument);

				Platform::String^ GetUndoTitle();
				Platform::String^ GetRedoTitle();

				Platform::String^ GetUndoDescription(UIExtensionsManager^ pDocument);
				Platform::String^ GetRedoDescription(UIExtensionsManager^ pDocument);

				void Enable(bool bEnabled);
				bool IsEnabled();

				void AddUndoItem(UIExtensionsManager^ pDocument, IUndoItem^ pUndoItem);
				void DeleteUndoItem(UIExtensionsManager^ pDocument, IUndoItem^ pUndoItem);
				void Reset(UIExtensionsManager^ pDocument);

				event UndoEventHandler^ BeforeUndo;
				event UndoEventHandler^ AfterUndo;
				event UndoEventHandler^ BeforeRedo;
				event UndoEventHandler^ AfterRedo;

				event UndoOperaListChangedEventHandler^ OperaListChanged;
			};

			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class UndoFactory sealed
			{
			public:
				static IUndo^ GetUndoInstance();
			};
		}
	}
}

