/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "IUndo.h"

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class DefaultUndo sealed : public IUndo
			{
			public:
				DefaultUndo();

			public:
				virtual bool IsUndoRedoing(UIExtensionsManager^ pDocument);
				virtual bool CanUndo(UIExtensionsManager^ pDocument);
				virtual bool CanRedo(UIExtensionsManager^ pDocument);

				virtual void Undo(UIExtensionsManager^ pDocument);
				virtual void Redo(UIExtensionsManager^ pDocument);

				virtual Platform::String^ GetUndoTitle();
				virtual Platform::String^ GetRedoTitle();

				virtual Platform::String^ GetUndoDescription(UIExtensionsManager^ pDocument);
				virtual Platform::String^ GetRedoDescription(UIExtensionsManager^ pDocument);

				virtual void Enable(bool bEnabled);
				virtual bool IsEnabled();

				virtual void AddUndoItem(UIExtensionsManager^ pDocument, IUndoItem^ pUndoItem);
				virtual void DeleteUndoItem(UIExtensionsManager^ pDocument, IUndoItem^ pUndoItem);
				virtual void Reset(UIExtensionsManager^ pDocument);

				virtual event UndoEventHandler^ BeforeUndo;
				virtual event UndoEventHandler^ AfterUndo;
				virtual event UndoEventHandler^ BeforeRedo;
				virtual event UndoEventHandler^ AfterRedo;
				virtual event UndoOperaListChangedEventHandler^ OperaListChanged;

			private:
				bool m_bEnabled;
				Platform::Collections::Vector<IUndoItem^>^ m_UndoItems;
			};
		}
	}
}
