﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include "Undo/UndoAppBarPhoneControl.g.h"

namespace foxit
{
	namespace rdk
	{
		namespace uiextensions
		{
			ref class MainPageAppBar;
			[Windows::Foundation::Metadata::WebHostHidden]
			public ref class UndoAppBarPhoneControl sealed
			{
			public:
				UndoAppBarPhoneControl();

			internal:
				property MainPageAppBar^ MainAppBar
				{
					MainPageAppBar^ get();
				}

				void UpdateUndoControlState();
				void ShowAnnotEditControl(bool isShow);
				void SetPropertyPopupColsed();
				void UpdatePropertyVisible();
				void HideUnRedoControl();
				void ShowUnRedoControl();
				bool ISPropertyPopupIsOpen();
				void SetFreeTextPropertyIsShow(bool isShow, Platform::String^ title);
				void SetUnRedoIsEnabled(bool isEnable);

			private:
				Platform::WeakReference m_MainAppBarWeakRef;
				Windows::Foundation::EventRegistrationToken m_AfterUndoEventToken, m_AfterRedoEventToken, m_OperaListChangedEventToken;
				Windows::Foundation::EventRegistrationToken m_AppBarShowEventToken, m_AppBarHideEventToken;

				Windows::UI::Xaml::Controls::Primitives::Popup^ propertyPopup;

			private:
				void OnLoaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void OnUnloaded(Platform::Object ^sender, Windows::UI::Xaml::RoutedEventArgs ^e);
				void RadioUndo_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void RadioRedo_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
				void OnAfterUndo(Platform::Object ^sender, Platform::Object ^args);
				void OnAfterRedo(Platform::Object ^sender, Platform::Object ^args);
				void OnAppBarShow(Platform::Object ^sender, Platform::Object ^args);
				void OnAppBarHide(Platform::Object ^sender, Platform::Object ^args);
				void OnOperaListChanged(Platform::Object ^sender, Platform::Object ^args);
				void propertyBtn_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e);
				void appBarContinueOpera_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);

				bool CreateAnnotIsContinueOpera(AnnotCreateType type);
				void appBarStampIcon_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
			};
		}
	}
}
