﻿/**
 * Copyright (C) 2003-2018, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit Mobile PDF SDK to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#pragma once

#include <collection.h>
#include <ppltasks.h>

#include <wrl/client.h>
#include <d3d11_2.h>
#include <d2d1_2.h>
#include <dwrite_2.h>
#include <wincodec.h>
#include <shcore.h>

/** Common header files. */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <string>
#include <iostream>
#include <vector>
#include <locale.h>
#include <sstream>
#include <fstream>

#include <wrl.h>
#include <msxml6.h>
#include <concrt.h>

#pragma comment(lib, "shcore.lib")
#pragma comment(lib, "msxml6.lib")

#include "AppDefine.h"

#include "Annotations\AnnotImp\AnnotTypeDefine.h"

#include "Common/BindableBase.h"
#include "Common/FileSizeConverter.h"
#include "Common/BooleanToVisibilityConverter.h"
#include "Common/BooleanNegationToVisibilityConverter.h"
#include "Common/BooleanToIBoxBooleanConverter.h"
#include "Common/DoubleToStringConverter.h"
#include "Common/Utilities.h"
#include "Common/CritSec.h"
#include "Common/VisualTreeHelperEx.h"
#include "Common/ControlSizeTrigger.h"
#include "Common/DeviceFamilyTrigger.h"
#include "Common/InputTypeTrigger.h"

#include "Common/BindableBase.h"
#include "Common/ToolBarButton.h"
#include "Common/SearchTextBox.h"
#include "Common/NumericTextBox.h"
#include "Common/NonVisibilityButton.h"
#include "Common/ContentHostedDialog.h"
#include "Common/FlyoutHostedControl.h"

#include "Cursor/ICursorFactory.h"
#include "Cursor/CursorFactory.h"

#include "Text/ITextSearchDataItem.h"
#include "Text/IPDFTextManager.h"
#include "Text/TextSearchDataItem.h"
#include "Text/PDFTextManager.h"

#include "Toolkit/MessageDlg.h"
#include "Toolkit/ProgressBarFactory.h"

#include "FormFiller/PDFFormDefine.h"
#include "FormFiller\FormControlTextBox.h"

#include "Undo/IUndo.h"

#include "Annotations\AnnotImp\IAnnot.h"
#include "Annotations\AnnotImp\AnnotBase.h"
#include "Annotations\AnnotImp\Annot_Text.h"
#include "Annotations\AnnotImp\Annot_StrikeOut.h"
#include "Annotations\AnnotImp\Annot_Caret.h"
#include "Annotations\AnnotImp\Annot_FreeText.h"
#include "Annotations\AnnotImp\Annot_Ink.h"
#include "Annotations\AnnotImp\Annot_Square.h"
#include "Annotations\AnnotImp\Annot_Squiggly.h"
#include "Annotations\AnnotImp\Annot_Stamp.h"
#include "Annotations\AnnotImp\Annot_Line.h"
#include "Annotations\AnnotImp\Annot_Link.h"
#include "Annotations\AnnotImp\Annot_Highlight.h"
#include "Annotations\AnnotImp\Annot_Circle.h"
#include "Annotations\AnnotImp\Annot_UnderLine.h"
#include "Annotations\AnnotImp\Annot_Widget.h"
#include "Annotations\AnnotImp\AnnotSettingManager.h"
#include "Annotations\AnnotImp\AnnotManager.h"
#include "Annotations\AnnotImp\AnnotCreaterFactory.h"
#include "UICustomControlFactory.h"
#include "UIExtensions.h"

